* -*- mode:Mail -*-
*	TITLE ALGB External Declarations
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
*******************************************************************
*   ALGB Library external declarations file.  This file should    *
*   be included in all source modules.                            *
*******************************************************************
********************
*   Noms visbles   *
********************
* page 1
EXTERNAL xXY
EXTERNAL xidn
EXTERNAL xTRAN
EXTERNAL xTR
EXTERNAL xMAD
EXTERNAL xrref
* page 2
EXTERNAL xGCD1
EXTERNAL xLCM1
EXTERNAL xSIMP2
EXTERNAL xDIVIS
EXTERNAL xLGCD
EXTERNAL xEGCD
* page 3
EXTERNAL xFCOEF
EXTERNAL xSQRT
EXTERNAL xCOLC
EXTERNAL xEXPA
EXTERNAL xFACTO
EXTERNAL xFROOTS
* page 4
EXTERNAL xAXL
EXTERNAL xSXL
EXTERNAL xS2L
EXTERNAL xXNUM
EXTERNAL xXQ
EXTERNAL xL2S
* page 5
EXTERNAL xLVAR
EXTERNAL xMMULT
EXTERNAL xEPSX0
EXTERNAL xre
EXTERNAL xim
EXTERNAL xconj
* page 6
EXTERNAL xFXND
EXTERNAL xNDXF
EXTERNAL xPF
EXTERNAL xEXEC
EXTERNAL xtEVAL
EXTERNAL xder
* page 7
EXTERNAL xPTAYL
EXTERNAL xDIV1
EXTERNAL xHORN
EXTERNAL xLU2
EXTERNAL xFDER
EXTERNAL xFINT
* page 8
EXTERNAL xadd
EXTERNAL xSUBT
EXTERNAL xMULT
EXTERNAL xDIV2
EXTERNAL xPOWER
EXTERNAL xCHS
* page 9
EXTERNAL xVER

* 49 XLIB nomms = #31    *

***************************
*      Nullnamed XLIB     *
***************************
* Les nombres indiquent les numros hexas et dcimaux
* de ROMPTR pour l'EXTERNAL qui suit

* #31, 49 (ROMPTR 314 31, XLIB 788 49)

EXTERNAL VERNUMext  ( -> % )
* renvoie le numro de version
EXTERNAL TRIMOBJext ( obj -> obj )
* comme TRIM mais ne redonne pas forcment une liste sur une liste
EXTERNAL LXAext  ( liste -> array )
* Transforme 1 liste (niveau 1) en tableau (si possible)
EXTERNAL AXLext  ( array -> liste )
* Transforme un tableau en liste
EXTERNAL EGCDext ( a, b -> d, u, v t.q. d=pgcd[a,b], au+bv=d )
* identit de Bezout 
EXTERNAL MONOEVALext  ( o # [op du runstream] -> op[o] )
* pour un operateur op unaire
EXTERNAL ELMGext ( obj -> obj )
* Remplace par 0 les reels inferieurs a epsilon

* #38, 56

EXTERNAL DIVISext   ( objet -> liste des diviseurs )
EXTERNAL RACPOLext  ( liste de racines ou de facteurs -> polynome ou entier )
* Inverse de RFACText. Si le UserFlag 10 est arme, il s'agit de facteurs
* entiers, sinon de racines.
EXTERNAL FACT1ext ( polynome -> lvar, poly-liste, {liste des racines} )
* Factorise un polynome, renvoie le coefficient dominant
* et la liste des racines.
EXTERNAL FACTOext  
( polynome ou entier -> lvar, poly-liste, liste des facteurs )
EXTERNAL SOLVext   ( polynome-liste -> liste des racines )
( ou polynome-liste, epsilon, nombre d'iterations -> liste des racines )
* Factorise un polynome-liste a coeffcients reels ou complexes
* par la methode de Laguerre ou de Bairstow.
EXTERNAL EVIDENText  ( polynome-liste -> liste de racines, reste du poly )
* Recherche les racines rationnelles d'un polynome (permet aussi de
* factoriser certains polynomes a coefficients formels)
EXTERNAL DEG2ext  ( polynome-liste de degre < 3 -> liste des racines )
* Factorisation d'un polynome de degre 2 (eventuellement formel)
EXTERNAL PIext ( liste -> produit des elements de liste )


* #40, 64

EXTERNAL POSITIFext ( obj -> obj, flag )
* essaie de determiner si on est + a l'infini 
EXTERNAL DENOLCMext ( liste -> ppcm des denominateurs )
* determine le ppcm des denominateurs d'une liste
EXTERNAL asopext
* appelle BINEVALext apres test des profondeurs des 2 objets
EXTERNAL rrefext
* row reduction to echelon form
EXTERNAL LOPAext    ( liste, objet, operateur binaire -> liste )
* List Operation All
EXTERNAL LOPMext    ( objet, liste -> { objet * elements de liste } )
* List Operation Multiplication
EXTERNAL DIVOBJext ( f , objet -> f/objet )
EXTERNAL DIVext      ( obj2, obj1 -> obj2 DIV obj1 , obj2 MOD obj1 )
* Division euclidienne de 2 polynomes-listes ou de 2 reels
* calcule le quotient et le reste
EXTERNAL LOPDext ( liste, objet -> { elements de liste / objet } )
* List Operation Division

* #49, 73

EXTERNAL DERext     ( polynome-liste -> derivee )
EXTERNAL INTEGRext  ( polynome-liste -> primitive )
* calcule la primitive s'annulant en 0

* #4B, 75

EXTERNAL LRDMext    ( liste entier -> liste )
* Rajoute des 0 a gauche pour obtenir un polynome "de degre" egal a
* l'entier specifie (entier est un reel ou un binaire)
EXTERNAL RRDMext    ( liste entier -> liste )
* Comme LRDM mais cree des zeros a droite
EXTERNAL TRIMext    ( liste -> liste )
* Enleve les zeros en tete de liste
EXTERNAL DEGREext   ( objet -> degre )
* renvoie le degre d'un polynome-liste
EXTERNAL COMPRIMext ( liste -> liste comprimee au sens ensembliste )
EXTERNAL NEXTPext   ( liste -> liste1 liste2 )
* liste=liste1+liste2, liste2 est formee d'elements identiques
( { o1 o2 ... } -> { liste1 } { o1 ... o1 } )
( liste1=liste-{o1 ... o1 } )
EXTERNAL QOBJext    ( objet [runstream: programme] -> objet )
* Exexute programme par 'REVAL sur les elements de objet (pour des objets
* de type liste, algebrique ou array en les decomposant)

* #52, 82

EXTERNAL FXNDext    ( objet -> numerateur, denominateur )
* Decompose une fraction
EXTERNAL NDXFext    ( numerateur, denominateur -> algebrique )
* inverse de FXND
EXTERNAL DEPTHext ( objet -> # )
* Renvoie la profondeur de l'objet (en terme de listes)
EXTERNAL LVARext    ( objet -> objet, liste des identificateurs globaux )
EXTERNAL VXXLext    ( algbrique ID -> polynome-liste )
EXTERNAL VALext     ( P, x -> P[x] ou P, { x1,..., xn } -> P[x1,...,xn] )
* Note: VALext met internalflag a 0 avant d'appeler VALOBJext

* #58, 88

EXTERNAL %PGCDext    ( r2 r1 -> PGCD[r2,r1] )
EXTERNAL TRLPGCDext
* TRIMext suivi de LPGCDext
EXTERNAL LPGCDext   ( liste -> liste, PGCD de la liste )
EXTERNAL SIMPext    ( o1, o2 -> o1' o2' )
* Simplifie o1/o2 en o1'/o2' par division par le PGCD de o1 et o2
EXTERNAL SIMP1ext ( symb -> symb simplifie )
EXTERNAL SIMPLISText    ( l1, l2 -> l1' l2' )
* Simplifie l1/l2 en l1'/l2' par division par le PGCD de l1 et l2
* l1 et l2 peuvent etre des objets de type liste, reel, complexe
EXTERNAL NUMEVALext ( evalue l'objet suivant du runstream en mode num )
EXTERNAL NOSIMPEVALext
* evalue l'objet suivant du runstream sans faire de simplifications

* #60, 96

EXTERNAL SQFFext ( poly-liste -> liste des facteurs )
EXTERNAL XSQRext    ( objet -> racine carre de l'objet )

* #62, 98

EXTERNAL idnext     ( cre une matrice symbolique identit )
* liste, arry, real ou # -> identite
EXTERNAL ERR$EVALext ( seco ou numero d'erreur -> action )
* Pour un # effectue :: SWAP NOTcase :: # 31400 #+ DO#EXIT ; DROP ;
* Donc on peut faire un test puis # ERR$EVALext, ou # dsigne
* le numro d'erreur a executer si le test est false,
* Pour un % effectue teste le flag utilisateur %, si le test
* est ngatif, depile l'objet situ au niveau 2, sinon revient
*  l'excution normale, ceci permet un programme du type
* { ONE TWO &$ DISPROW1 } %1 ERR$EVALext qui affiche la concatnation
* des messages 1 et 2 lorsque le flag 1 est arm.
* Sinon excute le programme, la liste ou le symbolique
* (EVAL de chaque objet) mais pour les entiers
* systmes non taggus, remplace ces entiers par #31400+# et
* excute JstGETTHEMESG (rappelle le message d'erreur # de ALGB)
* Exemple :: ONE TWO &$ DISPROW1 ; ERR$EVALext
* rappelle les messages 1,2 les concatne et affiche le rsultat
* en ligne 1.
* Attention, les NULLLAM sont dcals de 2 et les compteurs de
* boucles de 1
EXTERNAL User1IT
* Execute l'objet au niveau 1  la manire de ERR$EVALext si UF1 est arm.
EXTERNAL MENUext ( $6 $5 $4 $3 $2 $1 -> affichage du menu )
* Affiche les 6 chanes dans les 6 cases du menu
EXTERNAL SYMCOMPext ( obj -> sym, idnt ou lam )

* #67, 103

EXTERNAL XYext      ( vecteur x et y -> x.y produit scalaire )
EXTERNAL MMULText   ( matrice 1, matrice 2 -> produit des 2 matrices )
EXTERNAL MPMULText ( matrice M, polynme P-> M * P )
EXTERNAL TRANext    ( matrice -> matrice transpose )
EXTERNAL TRext      ( matrice -> trace )
EXTERNAL MADJext ( matrice M -> M^-1, P[M], P[lambda] )
* Calcule le polynome caracteristique et le polynome matrice adjoint
* d'une matrice donnee.
EXTERNAL DTYPFMAT?  ( objet -> objet TRUE ou -> objet FALSE )
* Teste si on a affaire a une matrice formelle
EXTERNAL DTYPENDO? ( objet -> objet TRUE ou FALSE )
* Teste si objet est la matrice d'un endomorphisme (matrice carree)
* Convertit eventuellement une matrice numerique en matrice formelle
EXTERNAL CK2FPOLY ( -> )
* teste les niveaux 1 et 2 de la pile, si une liste vide est rencontree
* provoque une erreur
EXTERNAL MEVALext   ( objet, l1, l2 -> objet )
* obj, l1, l2 -> obj': remplace dans obj les elements de l1 par ceux de l2


* #71, 113
EXTERNAL CK1TONOext ( prg -> prg )
* en remplacant CK[1|2]&Dispatch par CK&DISPATCH1 en tete de prog
EXTERNAL HORNext    ( polynome-liste P, r -> P[X] div [X-r], r, P[r] )
EXTERNAL PTAYLext   ( polynme-liste P, r -> dvpt Taylor de P en r )
EXTERNAL SIMPEVALext
* evalue l'objet suivant du runstream en simplifiant

* #75, 117

EXTERNAL LISTSECOext ( list, seco ou symb -> list, seco ou symb )
* Excute de manire non rcursive 1GETLAM sur les composants
* de list ou de seco
EXTERNAL TOLISText  ( o1, ..., on, #n -> lvar, l-o1,..., l-on )
* conversion au format interne de plusieurs objets selon flag 17

* #77, 119

EXTERNAL LISTOPext ( -> liste d'operateurs )

* #78, 120

EXTERNAL ADDMATOBJext ( array,obj -> array,obj | obj, array -> obj, array )
* Prepare une operation entre un array et un objet
EXTERNAL RADDext  ( o1, o2 -> o1+o2 )
EXTERNAL RSUBext ( o1, o2 -> o1-o2 )
EXTERNAL RMULText ( o1, o2 -> o1*o2 )
EXTERNAL RDIVext ( o1, o2 -> o1/o2 )
EXTERNAL MPext ( objet, #entier, prg de multiplication -> objet^#entier )

* #7E, 126

EXTERNAL RASOPext ( routine commune a RADDext et RSUBext )
EXTERNAL x*ext ( x* avec EvalNoCK )

* #80, 128

EXTERNAL RREext ( f -> re[f] )
EXTERNAL RIMext ( f -> im[f] )
EXTERNAL RCONJext ( f -> conj[f] )
EXTERNAL RNEGext ( f -> -f )
EXTERNAL SETQext ( -> )
* place en mode symbolique

* #85, 133
EXTERNAL MMULTOBJext ( o1, o2 -> o1, o2 ou o1*o2 )
* Prpare un produit matrice*matrice ou matrice*vecteur
EXTERNAL SIMPNDXFext ( o2, o1 -> 'o2/o1' simplifie )
EXTERNAL SYMBNext ( meta -> obj ou symb )

* #88, 136 operations courantes pour args: liste, symbolique

EXTERNAL MLAM1LAM2ext ( obj1, obj2, prg1, #lev -> matrice )
* effectue obj2 prg1 sur tous les elements de obj1
* situee au niveau 1, le schema de pile de prg1
* doit etre obj obj2 -> obj
* par exemple obj2=%5 et prg1=RMULText
* ou obj2='X' et prg1=VALext
* #lev designe le niveau de recursion
EXTERNAL INSERT{}N ( liste, obj, # pos -> liste )
* insre objet dans liste  la position # pos,
* # pos doit etre infrieur au nombre d'lments de liste
* si # pos est nul, l'lment est rajout en fin de liste
EXTERNAL REDLIBext ( # -> 3 ou 5 programmes )
*( rappelle sur la pile selon la valeur de stk1 )
*( #0: PIVOT, EXL, ELEM )
*( #1: PIVOT, EXL, ELEM, XRED, LDISP,  )
*( Bind 6     5    4     3      2     1 )

* #8B, 139

EXTERNAL QOBJIMext
EXTERNAL QOBJREext
EXTERNAL MADJOBJext ( I_n, A, I_n, #n+1 -> )
( -> [-1]^n*det[A], inv[A]=1/det[A]* com[A], pmadj, pcar )
* utilitaire de madj

* #8E, 142

EXTERNAL VALOBJext ( #depth, poly-liste, { x1 ... xn } -> poly-symb )
* appelle SLVARext pour simplifier la liste de variables puis VAL2
* Note: si internalflag est Set, la conversion n'a pas lieu
EXTERNAL LVARDext 
( objet, liste d'operateurs -> #profondeur, objet, liste des idnt )
EXTERNAL DEPTHOBJext ( objet, ONE ou TWO -> profondeur )
* ONE ou TWO indique s'il faut ou non rechercher dans les symboliques
EXTERNAL FACTOBJext ( lfact, #, flag -> lfact ou lrac )
* voir dans alsubs.h
EXTERNAL VXLVARext ( symb -> oldvx, symb, lvar )
* identique a LVAR mais en positionnant le contenu de VX en tete,
* si VX n'est pas present, modifie le contenu de VX

* #93, 147

EXTERNAL RACTOFACext
* transforme une liste de racines en liste de facteurs
* contrairement a RACPOL, ici il s'agit de { rac rac rac ... }
* et pas de { rac mul rac mul ... }
EXTERNAL num0case
* comme num0=case mais en testant aussi un polynome-liste nul
EXTERNAL LOP1ext ( liste, obj, prg -> liste )
* { o1, ..., on }, obj, prg -> { prg[o1,obj], ..., prg[on, obj] }
EXTERNAL FROMLISText
* lvar, obj1,..., objn, {#prof1, ..., #profn} -> obj1, ..., objn
* contraire de TOLISText
EXTERNAL RREIMext
* routine commune a RREext et RIMext

* #98, 152
EXTERNAL QUOTOBJext
* routine commune a QUOText et DIV2LISText
EXTERNAL QUOText ( o1, o2 -> o1 div o2 )
* calcule le quotient de la division euclidienne de 2 objets
EXTERNAL QOBJCONJext ( o -> conj[o] )
* conjugue d'une liste
EXTERNAL MVMULText ( matrice, vecteur -> vecteur )
* produit
EXTERNAL DMONOEVALext
* appelle MONOEVALext avec comme profondeur celle de l'objet
EXTERNAL BINEVALext ( o1, o2, #prof [operande du runstream] -> o1 operande o2 )
* effectue EVAL mais en representation liste
EXTERNAL DIV2LISText
* comme DIV2, mais pour 2 listes et sans TRIMext sur le quotient
EXTERNAL CKFPOLYext
* teste s'il y a une null{} dans l'objet -> erreur
EXTERNAL QXNDext ( obj -> a, b, c )
* decompose un irrationnel quadratique

* # A0, 160

EXTERNAL NDXQext ( a, b, c -> obj )
* recompose un irrationnel quadratique
EXTERNAL QADDext ( o1, o2 -> o1+o2 )
* additionne 2 irrationnels quadratiques
EXTERNAL QSUBext ( o1, o2 -> o1-o2 )
* soustrait 2 irrationnels quadratiques
EXTERNAL QMULText ( o1, o2 -> o1*o2 )
* multiplie 2 irrationnels quadratiques
EXTERNAL QDIVext ( o1, o2 -> o1/o2 )
EXTERNAL QCONJext ( a+ b*sqrt[c] -> a - b*sqrt[c] )
EXTERNAL QNORMext ( a+b*sqrt[c] -> a*a-c*b*b )
EXTERNAL BIN2EVALext ( o1, o2, [ procedure du runstream] -> o1', o2' )
EXTERNAL QOBJNEGext ( routine de RNEGext )
EXTERNAL LLVARDext ( o -> #depth, o, lvar )
* liste des identificateurs, racines carrees considerees comme op arithmetique
EXTERNAL QOBJSECext
* comme QOBJ mais on ne decompose pas les secondaries
EXTERNAL SLVARext ( lvar -> lvar )
* simplifie la liste des variables selon le flag recurseflag
EXTERNAL VAL2ext ( #depth, poly-liste, { x1 ... xn } -> poly-symb )
* Note: si internalflag est Set, la conversion n'a pas lieu
EXTERNAL COMPext ( obj1, obj2 -> obj1, obj2, true or false )
* teste si obj1 < obj2: tri par type puis par chaine de caracteres 
EXTERNAL PREPARext ( o1, o2 -> a1, b1, c1, a2, b2, c2 )
* avec c1=c2 ou c1 et c2 premiers entre eux 
EXTERNAL FACT2MULText ( listnum, listdeno -> list )
* listnum et listdeno representent des listes de facteurs au numerateur et au
* denominateur,
* on regroupe les facteurs sous la forme facteur multiplicite
* Exemple { 2 2 3 4 } { 3 3 3 5 5 } -> { 4 1 2 2 3 -2 5 -2 }
* l'algo n'est pas terrible, on extrait tous les facteurs du numerateur
* avec NEXTP, on regarde comment ils sont au denominateur
EXTERNAL SMULTOBJext ( matrice/vecteur, scalaire -> m,s ou m*s )
* Prpare un produit matrice ou vecteur par un scalaire
EXTERNAL VPMULText ( vecteur, scalaire -> vecteur )
* Produit vecteur * scalaire
EXTERNAL MULMULText ( liste, coeff -> liste )
* multiplie les multiplicites dans liste par coeff
EXTERNAL ADDLISText ( liste, multiplicite, objet -> liste )
* ajoute un objet ayant une multiplicite a une liste
* d'objets-multiplicite
EXTERNAL COMPLISText ( liste -> liste )
* additionne les multiplicites et supprime les facteurs multiples
* de la liste
EXTERNAL SQFF2ext ( l1, ..., ln, #n -> l1', ..., ln', #n)
* teste s'il y a des pgcd non triviaux entre les facteurs des lj
* pour renvoyer une liste de facteurs premiers entre eux
EXTERNAL RFACText ( obj, # -> lvar, obj interne, liste fact/rac )
* Factorisation rationnelle selon #
EXTERNAL RFACT2ext ( obj, lvar, # -> lvar, obj, lrac | lfac )
* Comme le precedent mais avec lvar precise
EXTERNAL FACTOOBJext ( inverse de RFACText )
* Si flag est TRUE on a affaire a des facteurs, sinon a des racines
EXTERNAL DERIVext ( symb -> derivee )
EXTERNAL ISOLext ( symb, idnt -> symb )
* comme la fonction user ISOL
EXTERNAL LIDNText ( obj -> liste des idnt )
* EXTERNAL 13SIMP1ext ( o -> o simplifie )
* appelle SIMP1ext si le flag 13 est desarme
