* -*- mode:Mail -*-
*	TITLE GNU ALGB Library User Words
*  (c) 08/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

	
INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h

*****************************************************************
* The user module contains the "xNames" - the user words.  These
* will be visible to the user.  The nibble that precedes each
* xName tells the parser that this is a non-algebraic.  Note that
* the user words are specified with the compiler directive
* "xNAME".
*****************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME XY
::
CK2
AXLext NOTLISTcase SETSIZEERR
SWAP AXLext NOTLISTcase SETSIZEERR
CK2FPOLY
DUPLENCOMP 3PICK LENCOMP #= NcaseSIZEERR ZERO BINEVALext XYext
;
*********
ASSEMBLE
         CON(1)  8
RPL
* Renvoie la matrice identit\'e formelle (semblable \`a IDN)
xNAME idn
::
CK1&Dispatch
real :: DUP %0> NcaseTYPEERR
	DUPDUP %FLOOR %= NcaseTYPEERR
	idnext
	;
any ::	DTYPENDO? NcaseTYPEERR
	idnext
	;
;
******************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME TRAN
::
CK1
dARRYcase TRANext
DTYPFMAT? NcaseSIZEERR TRANext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME TR
::
CK1 DTYPENDO? NcaseSIZEERR TRext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME MAD
::
CK1
internalflag TestUserFlag case MADJext
CKFPOLYext LVARext VXXLext MADJext
{ ZERO TWO THREE ONE } FROMLISText
ZEROSWAP ID VX ONE{}N VAL2ext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME rref
::
CK1 rrefext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME GCD1
::
CK2 ZERO BINEVALext :: TWO{}N CKFPOLYext TRLPGCDext SWAPDROP ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME LCM1 ( P1, P2 -> PPMC[P1,P2] )
* Remarque, PPMC est obtenu par la formule PPMC*PGCD=P1*P2
::
CK2 BIN2EVALext :: 2DUP xGCD1 RDIVext ; RMULText 
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME SIMP2
::
CK2 CK2FPOLY SETQext BIN2EVALext SIMPext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME DIVIS
::
CK1 CKFPOLYext ONE MONOEVALext DIVISext
;
************
ASSEMBLE
         CON(1)  8
RPL
xNAME LGCD
::
CK1&Dispatch
list :: CKFPOLYext 
	internalflag TestUserFlag case TRLPGCDext
	ONE TOLISText TRLPGCDext { ONE ZERO } FROMLISText 
	;
;
***********

ASSEMBLE
         CON(1)  8
RPL
xNAME GCD3
::
CK2
::	internalflag TestUserFlag ?SEMI
	integerflag SetUserFlag 
	TWO TOLISText 'REVAL ZEROZEROZERO THREE{}N FROMLISText
	;
EGCDext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME FCOEF
::
CK1 
NOTLISTcase SETSIZEERR
DUPLENCOMP TWO #/ DROP #1=case SETSIZEERR
CKFPOLYext 
::	internalflag TestUserFlag ?SEMI
	ONE TOLISText 'REVAL SWAP' ID VX XEQRCL >HCOMP VALext
	;
RACPOLext 
;
*****************************
ASSEMBLE
         CON(3)  000
RPL
xNAME SQRT
::
CK1&Dispatch
any :: CKFPOLYext ZERO MONOEVALext XSQRext ;
;
****************
ASSEMBLE
         CON(1)  8
RPL
xNAME COLC
::
CK1&Dispatch
list :: CKFPOLYext SQFFext ;
symb :: FOUR RFACText 
	( lvar, obj interne, { facteurs mult } )
	SWAPDROP ONESWAP ROT VALOBJext 
	( { fact mult } )
        internalflag ClrUserFlag ONE MONOEVALext NOP
	( { fact1 num1 fact2 num2 ... } )
	TRUE 'x* ' x^ FACTOOBJext
        ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME EXPA
::
CK1 SETQext QOBJext SIMP1ext 
;
*************
ASSEMBLE
         CON(1)  8
RPL
xNAME  FACTO
::
CK1 CKFPOLYext
internalflag TestUserFlag case FACTOext
FACTOext ROTDUP 2SWAP
{ ZERO ONE } FROMLISText
( lvar, poly, facteurs )
;
*************
ASSEMBLE
         CON(1)  8
RPL
xNAME  FROOTS
::
CK1
dREALNcase ::	CKFPOLYext 
		internalflag TestUserFlag case FACT1ext
		FACT1ext
		( lvar, poly-l, root-l )
		SWAP3PICK VALext
		( lvar, root-l, poly )
		ONE ROT
		( lvar, poly, #1, root-l )
		4PICK CDRCOMP VALOBJext
		( lvar, poly, roots )
		;
%ABSCOERCE CK3NOLASTWD
CK&DISPATCH1
# 510 SOLVext			
;
**************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME AXL
::
CK1&Dispatch
list :: DTYPFMAT?
        ITE LXAext
            xOBJ\->
        x\->ARRY
        ;
arry AXLext
any NOP
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME SXL
::
CK1&Dispatch
list :: CKFPOLYext
        DUP CARCOMP
        CK&DISPATCH1
        ELEVEN :: DROP DUPLENCOMP #2+ UNCOERCE CKNNOLASTWD DROP
                  QOBJext HXS>#
                  FROMLISText
                  ;
        any :: DROP' ID VX XEQRCL VALext ;
        ;
ELEVEN :: internalflag ClrUserFlag #>% CKNNOLASTWD TOLISText
          ;
any :: DUP FXNDext
       :: CK&DISPATCH1
          list TRUE
          EIGHTY TRUE
          any FALSE
          ;
       UNROT2DROP ' ID VX XEQRCL SWAP
       case VALext VXXLext
       ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME S2L
::
CK2
VXXLext
;
**********
ASSEMBLE
         CON(1)  8
RPL
xNAME XNUM
::
CK0
real_intflag ClrUserFlag 
pgcdflag ClrUserFlag
DEPTH #0=?SEMI
QOBJext CRUNCH
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME XQ
::
CK0
SETQext
DEPTH #0=?SEMI
ID EPS dREALNcase SETSIZEERR 
%LOG %ABSCOERCE DOFIX QOBJext x\->Q DOSTD
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME L2S
::
CK2&Dispatch
any VALext
;
**************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME LVAR
::
CK1 LVARext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME MMULT
::
CK3
dREALNcase SETSIZEERR
( multiplication avec des matrices et vecteurs )
* %0 matrice*matrice
* %1 matrice*vecteur colonne
* %2 matrice*scalaire, %6 scalaire*matrice
* %3 vecteur*scalaire, %7 scalaire*vecteur
%ABSCOERCE
FOUR #/
( o1, o2, reste, quot )
#0=ITE UNROTSWAP UNROT
( reste, o2, o1 )
( teste o1 )
DUPTYPEARRY? ?SKIP ::	NOTLISTcase SETSIZEERR 3PICK #3=
			ITE	CKFPOLYext 
				:: DTYPFMAT? NcaseSIZEERR ;
			;
( teste o2 )
SWAP3PICK #>1
ITE	CKFPOLYext 
	::	DUPTYPEARRY? ?SEMI
		NOTLISTcase SETSIZEERR 
		3PICK 
		#0=ITE :: DTYPFMAT? NcaseSIZEERR ;
			CKFPOLYext
		;
( reste, o1, o2 )
ROT 
( reste, o1, o2 )
DUP#0=csedrp :: TWO BINEVALext MMULText ;
DUP#1= casedrop :: ONE BINEVALext MVMULText ;
#2= case :: TWO BINEVALext MPMULText ;
ONE BINEVALext VPMULText
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME EPSX0
::
CK1 ELMGext TRIMext
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME re
::
CK1&Dispatch
any :: DMONOEVALext RREext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME im
::
CK1&Dispatch
any :: DMONOEVALext RIMext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME conj
::
CK1&Dispatch
any :: DMONOEVALext RCONJext ;
;
***********
ASSEMBLE
         CON(1)  8
RPL
xNAME  FXND
::
CK1 FXNDext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME NDXF
::
CK2 CK2FPOLY NDXFext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME PF
::
CK1
DUPTYPESYMB? NOT?SEMI
TWO RFACText
( lvar, numl/denol, liste rac )
DUPNULL{}? 
casedrop :: ZEROSWAP ROT VALOBJext internalflag ClrUserFlag ;
RESOROMP MPext
RESOROMP RMULText
' :: ZEROSWAP 1GETLAM VAL2ext ;
6ROLL
( num-liste/deno-list, liste rac, x^, x*, prog lxx, lvar )
4NULLLAM{} BIND

SWAP FXNDext DUPUNROT DIVext
( liste rac, deno-l, partie entiere-l, nouveau num-l  )
4UNROLL 2GETEVAL
( num-liste, liste rac, deno list, partie entiere  )
4UNROLL SWAP
( partie entiere, num-list, deno-list, liste rac  )
{	BlankDA12 FIFTEEN SEVENTEEN &$ DISPROW1
	DUP EDITDECOMP$ :: TWO FIVE ; Disp5x7 
	} 
User1IT
BEGIN
	( partie entiere, num-list, deno-list, liste rac  )
	DUPLENCOMP #0<>
WHILE
	INNERCOMP #2- {}N UNROT
	( p. entiere, num-l, deno-l, { reste }, rac, mul )
	{	SEVENTEEN DISPROW6 
		OVER DO>STR APPEND_SPACE 
		OVER DO>STR &$ DISPROW7 
	} User1IT
	( p. entiere, num-l, deno-l, { reste }, rac, mul )
	%ABSCOERCE SWAP ONE{}N RACTOFACext CARCOMP
	( p. entiere, num-l, deno-l, { reste }, #mul, fact )
	DUP 2GETEVAL 7UNROLL
	( facteuralg, ent., num-l, deno-l, { reste }, #mul, fact  )
	SWAP2DUP 3GETLAM 4GETLAM EVAL
	( facteuralg, int, num-l, deno-l, { reste }, facteur, #n, fact^#n )
	5PICK OVER DIVext DROP
	( .., num, deno, reste rac, facteur, #n, fact^#n, deno/fact^#n )
	7PICK UNROT
	( .., num, deno, reste rac, facteur, #n, num, fact^#n[x], deno/fact^#n[y] )

	( ID CAB )
	( c, a, b )
	EGCDext
	( c, d, u, v )
	2SWAP DIVext TRIMOBJext
	( u, v, c div d, c mod d )
	%0 EQUAL NcaseSIZEERR
	( u, v, c div d )
	ROTOVER RMULText UNROT RMULText
	( u*[c div d], v*[c div d])
	( fin de CAB )

	( .., num, deno, reste rac, facteur, #n, x, y )
	SWAPDROP
	( .., num, deno, reste rac, facteur, #n, y )
	OVER
	( .., num, deno, reste rac, facteur, #n, y , #n)
	ZERO_DO (DO)
		( .., num, deno, reste rac, facteur, #n, y )
		3PICK DIVext
		( facteuralg, int, num, deno, reste rac, facteur, #n, y1, y2 )
		2GETEVAL NINE PICK DUPTYPESYMB? ITE INNERCOMP ONE
		DUP #4+PICK INDEX@#- DUP#1=
		ITE_DROP
			:: UNCOERCE ' x^ ROT #2+ ;
		SYMBN x/ 8ROLL SWAP x+ 7UNROLL
		( facteuralg, int, num, deno, reste rac, facteur, #n, y1 )
		LOOP
	3DROP 5ROLLDROP
	( int, num, deno, reste rac)
REPEAT
ABND 3DROP 
internalflag ClrUserFlag
;
***********
ASSEMBLE
         CON(1)  8
RPL
xNAME EXEC
::
CK2&Dispatch
2LIST :: CK3NOLASTWD MEVALext ;
symb :: DUPDUP LENCOMP NTHCOMPDROP EQ: x=
        NcaseTYPEERR
        xOBJ\-> 2DROP 
	( obj, o1, o2 )
	( si o1 est une fnct, on recherche les derivees dans obj )
	( sinon on isole si possible 1 idnt a gauche et on cree 2 listes )
	OVER DUPTYPESYMB? NOTcasedrop MEVALext
	( obj, o1, o2, o1 )
	DUPDUP LENCOMP NTHCOMPDROP
	( obj, o1, o2, o1, operateur )
	EQ: xFCNAPPLY
	( obj, o1, o2, o1, ?fnct utilisateur )
	ITE ::	' xOBJ\-> EvalNoCK
		( obj, o1, o2, arg1, ..., argk, %arg, idnt )
		SWAP COERCE DUPUNROT #2+UNROLL {}N
		( obj, o1, o2, idnt, { arg1 ... argk } )
		5PICK LIDNText
		( obj, o1, o2, idnt, { arg1 ... argk }, { idnt de obj } )
		( teste si obj2 est une fonction utilisateur )
		4PICK DUPTYPESYMB?
		ITE :: DUPLENCOMP NTHCOMPDROP EQ: xFCNAPPLY ;
		    DROPFALSE
		NOTcase2drop :: DROP RDROP MEVALext ;
		( obj, o1, o2, idnt, { arg1 ... argk }, { idnt de obj } )
		( cherche la liste des arg de fnct2 )
		4PICK ' xOBJ\-> EvalNoCK SWAP COERCE DUPUNROT #2+UNROLL {}N
		( ..., idnt, { args }, { idnt de obj }, newidnt, { newargs } )
		NULL{} DUP 5ROLL
		[BEGIN]
			DUPNULL{}?
		NOT_WHILE
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		( pour chaque idnt de obj, on teste si "idnt" de obj )
		( contient "idnt" )
		::
		DUP CDRCOMP SWAP CARCOMP
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt )
		DUP 
		( objidnt -> liste_der, stripped_idnt )
		ID>$ NULL{} SWAP
		BEGIN
			( liste, $ )
* a ameliorer car on recalcule chaque fois la chaine corresp. a
* l'idnt a remplacer
			TEN PICK ID>$ OVER EQUAL
			ITE FALSE :: DUP "d" ONE POS$ #1= ;
		WHILE
			CDR$ ZEROSWAP
			( liste, #, $ )
			BEGIN
				::	DUP CAR$ DUPNULL$? caseFALSE
					( liste, #, $, car$ )
					CHR># FORTYEIGHT OVER #>
					( liste, #, $, car#, ? )
					caseFALSE
					FORTYEIGHT #- DUP TEN #<
					;
			( liste, #, $, [ obj FALSE | # TRUE ] )
			WHILE
				ROT TEN #* #+ SWAP CDR$
			REPEAT
			DROP
			( liste, #, $ )
			UNROT >TCOMP SWAP
			( liste, $ )
		REPEAT
		( liste, $ )
		$>ID	
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, stripped_idnt )
		TEN PICK EQUAL NOTcase2DROP
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste )
		DUPNULL{}? case2DROP
		( creation de newidnt[newargs] )
		6PICK INNERDUP #8+ PICK ONE SYMBN SWAP xFCNAPPLY
		SWAPDUP LENCOMP
		ZERO_DO 
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste )
			DUP CDRCOMP SWAP CARCOMP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste, no de derivee )
			8PICK OVER NTHELCOMP NcaseTYPEERR
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste, no de derivee, newarg_no )
			4ROLLSWAP 3PICK 
			:: 
			SWAP DUPTYPESYMB? 
			IT :: ' TYPEIDNT? Find1stTrue NOTcase %1 ;
			idntlamcase :: SWAPDROP DERIVext ;
			( symb, #, obj )
			DROP UNCOERCE DO>STR SWAPINCOMP get1 5ROLL 
			CARCOMP ID>$ &$ CHR_d >H$ $>ID ONE SYMBN 4UNROLL SYMBN
			;
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, no de derivee, resultat )
			TEN PICK ROT NTHELCOMP NcaseTYPEERR
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, resultat, arg_no )
			DUPTYPESYMB? 
			ITE ::	DUP ' TYPEIDNT? Find1stTrue 
				NOTcaseDROP DERIVext RDIVext
				;
				DROP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, resultat )
			SWAPLOOP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste )
		DROP 4ROLLSWAP >TCOMP UNROT
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt )
		4ROLL 7PICK INNERDUP #3+ ROLL ONE SYMBN SWAP xFCNAPPLY >TCOMP UNROT
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		;
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		[REPEAT]
		DROP 6UNROLL 6UNROLL 4DROP
		( obj, o1, o2, l1, l2 )
		; 
	    ::	' TYPEIDNT? Find1stTrue
		( obj, o1, o2, [ indt, TRUE | FALSE ] )
		NOTcase :: RDROP MEVALext ;
		( obj, o1, o2, idnt )
		UNROT 2DUP ' x- EvalNoCK 
		( obj, idnt, o1, o2, o1-o2 )
		4ROLL
		( obj, o1, o2, o1-o2, idnt )
		ISOLext
		( obj, o1, o2, idnt, valeur )
		ONE{}N SWAP ONE{}N SWAP
		( obj, o1, o2, l1, l2 )
		;
	( obj, o1, o2, l1, l2 )
	ROT >HCOMP UNROTSWAP
	( obj, l2, l1, o1 )
	>HCOMP SWAP MEVALext
        ;
seco :: ' QOBJext SWAP 2Ob>Seco EVAL ;
idnt :: ISOLext ' x= EvalNoCK ;
;
***************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME tEVAL
::
CK1
GARBAGE CLKTICKS 1LAMBIND EVAL CLKTICKS 1GETABND
bit- HXS>% % 8192 %/ % 0.0067 %- %4 RNDXY "s" >TAG
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME der
::
CK2&Dispatch
any ::	internalflag SetUserFlag
	DERIVext
	internalflag ClrUserFlag
	;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME PTAYL
::
CK2&Dispatch
any :: CK2FPOLY ZERO BINEVALext PTAYLext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME DIV1
::
CK2&Dispatch
any :: CK2FPOLY TRIMext ZERO BINEVALext RDIVext ;
;
**********
ASSEMBLE
         CON(1)  8
RPL
xNAME HORN
::
CK2&Dispatch
any :: CK2FPOLY
       internalflag TestUserFlag case HORNext
       TWO TOLISText
       HORNext
       ZEROZEROZERO THREE{}N FROMLISText
       ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME LU2
::
CK1
DTYPENDO? NcaseSIZEERR
( endomorphisme )
TRANext DUP xidn x+ TRANext
( { A idn } )
ONE REDLIBext DUP' NULLLAM SIX NDUPN DOBIND 
' 5PICK 3GETLAM EVAL 
ABND
( { l u } )
TRANext
INNERCOMP #2/
( l1, ...ln, u1, ..., un, #n )
DUPDUP #2+UNROLL
( l1, ..., ln, #n , u1, ..., un, #n )
{}N TRANext OVER#2+UNROL {}N
( u, l )
TRANext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME FDER
::
CK1
' ::	dLISTcase DERext 
	' ID VX XEQRCL 
	( ici il faudrait traiter les reels/complexes par SYMCOMP )
	internalflag SetUserFlag
	DERIVext
	internalflag ClrUserFlag
	;
( objet, prg )
SWAP
FXNDext
( prg, n, d )
num1=case :: DROPSWAP EVAL ;
2DUP
( prg, n, d, n, d )
5PICK EVAL
( prg, n, d, n, d' )
4UNROLL 5ROLL EVAL
( d', n, d, n' )
OVER 5UNROLL
FOUR {}N LVARext VXXLext
INCOMPDROP
( symb-d, lvar,  d', n, d, n' )
4UNROLLROT
( symb-d, lvar,  n', n, d, d' )
SIMPext
( symb-d, lvar,  n', n, d/gcd, d'/gcd )
OVER 5UNROLL
( symb-d, lvar,  d/gcd, n', n, d/gcd, d'/gcd )
4UNROLLROT
( symb-d, lvar,  d/gcd, d'/gcd, n, d/gcd, n' )
RMULText UNROT RMULText RSUBext
( symb-d, lvar, d/gcd, num )
TWO{}N ONE SWAPROT VALOBJext
INCOMPDROP
( symb-d, d/gcd, num )
UNROT
NUMEVALext :: RMULText
*              DUPTYPELIST? ?SKIP xCOLCT
              RDIVext
              ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME  FINT
::
CK1
dLISTcase INTEGRext
xPF ' ID  ' ID VX XEQRCL ROTOVER x\.S
;
*************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME add
::
CK2&Dispatch
any :: asopext RADDext
       ;
;
*********
ASSEMBLE
         CON(3)	000
RPL
xNAME SUBT
::
CK2&Dispatch
any :: asopext RSUBext
       ;
;
******************
ASSEMBLE
         CON(3)	000
RPL
xNAME MULT
::
CK2&Dispatch
SIXTYEIGHT x*
TWENTY x*
THIRTYSIX x*
* ARRYREAL x*
* FOURTWO x*
FOUR :: AXLext xMULT ;
any ::	internalflag TestUserFlag case RMULText
	::	CK&DISPATCH1
		2LIST TWO ( matr/vect * matr/vect )
		SIXTYFOUR ONE
		list THREE
		EIGHTY ONE
		any ZERO
		;
	( o1, o2, # )
	DUP#0=csedrp :: ZERO BINEVALext RMULText ;
	DUP#1= casedrop :: SWAP xMULT ;
	#2- #6* OVER DEPTHext #1= IT #1+
	UNCOERCE xMMULT
	;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME  DIV2
::
CK2 CK2FPOLY TEN SetUserFlag
BIN2EVALext :: TRIMext DIVext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME POWER
::
CK2&Dispatch
# 81 :: RESOROMP QMULText MPext ;
SYMREAL :: x^ SIMP1ext
           ;
ARRYREAL :: 'x* MPext ;
any :: RESOROMP xMULT MPext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME CHS
::
CK1&Dispatch
any :: DMONOEVALext RNEGext ;
;
**********
ASSEMBLE
         CON(1)  8
RPL
xNAME VER
::
*  0123456789012345678901
*  "GNU GPL ALGB Library 2"
*  DISPROW1
*  "      Bernard.Parisse"
*  DISPROW3
*  "@ujf-grenoble.fr"
*  DISPROW4
*  "http://www-fourier.ujf"
*  DISPROW5
*  "-grenoble.fr/~parisse"
*  DISPROW6
*  "  and Ram Gudavalli"
*  DISPROW7
"http://www-fourier.ujf"
DISPROW1
"-grenoble.fr/~parisse"
DISPROW2
SetDA1Temp
CONTEXT@
HOMEDIR % .0000000001 ' ID EPS STO 'IDX ' ID VX STO
CONTEXT!
SIXTEEN TWELVE DO INDEX@ SetUserFlag LOOP
TWENTYTWO SIXTEEN DO INDEX@ ClrUserFlag LOOP
TWENTYSEVEN SetSysFlag
VERNUMext
;
*********
* ASSEMBLE
*         CON(1)  8
* RPL
* xNAME RMSYM
* ::
* CK1&Dispatch
* symb RMSYMext
* ;
*********
