* -*- mode:Mail -*-
*	TITLE GNU ALGB Library User Words
*  (c) 08/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

	
INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h

*****************************************************************
* The user module contains the "xNames" - the user words.  These
* will be visible to the user.  The nibble that precedes each
* xName tells the parser that this is a non-algebraic.  Note that
* the user words are specified with the compiler directive
* "xNAME".
*****************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME XY
::
CK2
AXLext NOTLISTcase SETSIZEERR
SWAP AXLext NOTLISTcase SETSIZEERR
CK2FPOLY
DUPLENCOMP 3PICK LENCOMP #= NcaseSIZEERR ZERO BINEVALext XYext
;
*********
ASSEMBLE
         CON(1)  8
RPL
* Renvoie la matrice identit\'e formelle (semblable \`a IDN)
xNAME idn
::
CK1&Dispatch
real :: DUP %0> NcaseTYPEERR
	DUPDUP %FLOOR %= NcaseTYPEERR
	idnext
	;
any ::	DTYPENDO? NcaseTYPEERR
	idnext
	;
;
******************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME TRAN
::
CK1
dARRYcase TRANext
DTYPFMAT? NcaseSIZEERR TRANext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME TR
::
CK1 DTYPENDO? NcaseSIZEERR TRext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME MAD
::
CK1
internalflag TestUserFlag case MADJext
CKFPOLYext LVARext VXXLext MADJext
{ ZERO TWO THREE ONE } FROMLISText
ZEROSWAP ID VX ONE{}N VAL2ext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME rref
::
CK1 rrefext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME GCD1
::
CK2 ZERO BINEVALext :: TWO{}N CKFPOLYext TRLPGCDext SWAPDROP ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME LCM1 ( P1, P2 -> PPMC[P1,P2] )
* Remarque, PPMC est obtenu par la formule PPMC*PGCD=P1*P2
::
CK2 BIN2EVALext :: 2DUP xGCD1 RDIVext ; RMULText 
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME SIMP2
::
CK2 CK2FPOLY SETQext BIN2EVALext SIMPext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME DIVIS
::
CK1 CKFPOLYext ONE MONOEVALext DIVISext
;
************
ASSEMBLE
         CON(1)  8
RPL
xNAME LGCD
::
CK1&Dispatch
list :: CKFPOLYext 
	internalflag TestUserFlag case TRLPGCDext
	ONE TOLISText TRLPGCDext { ONE ZERO } FROMLISText 
	;
;
***********

ASSEMBLE
         CON(1)  8
RPL
xNAME GCD3
::
CK2
::	internalflag TestUserFlag ?SEMI
	integerflag SetUserFlag 
	TWO TOLISText 'REVAL ZEROZEROZERO THREE{}N FROMLISText
	;
EGCDext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME FCOEF
::
CK1 
NOTLISTcase SETSIZEERR
DUPLENCOMP TWO #/ DROP #1=case SETSIZEERR
CKFPOLYext 
::	internalflag TestUserFlag ?SEMI
	ONE TOLISText 'REVAL SWAP' ID VX XEQRCL >HCOMP VALext
	;
RACPOLext 
;
*****************************
ASSEMBLE
         CON(3)  000
RPL
xNAME SQRT
::
CK1&Dispatch
any :: CKFPOLYext ZERO MONOEVALext XSQRext ;
;
****************
ASSEMBLE
         CON(1)  8
RPL
xNAME COLC
::
CK1&Dispatch
list :: CKFPOLYext SQFFext ;
symb :: FOUR RFACText 
	( lvar, obj interne, { facteurs mult } )
	SWAPDROP ONESWAP ROT VALOBJext 
	( { fact mult } )
        internalflag ClrUserFlag ONE MONOEVALext NOP
	( { fact1 num1 fact2 num2 ... } )
	TRUE 'x* ' x^ FACTOOBJext
        ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME EXPA
::
CK1 SETQext QOBJext SIMP1ext 
;
*************
ASSEMBLE
         CON(1)  8
RPL
xNAME  FACTO
::
CK1 CKFPOLYext
internalflag TestUserFlag case FACTOext
FACTOext ROTDUP 2SWAP
{ ZERO ONE } FROMLISText
( lvar, poly, facteurs )
;
*************
ASSEMBLE
         CON(1)  8
RPL
xNAME  FROOTS
::
CK1
dREALNcase ::	CKFPOLYext 
		internalflag TestUserFlag case FACT1ext
		FACT1ext
		( lvar, poly-l, root-l )
		SWAP3PICK VALext
		( lvar, root-l, poly )
		ONE ROT
		( lvar, poly, #1, root-l )
		4PICK CDRCOMP VALOBJext
		( lvar, poly, roots )
		;
%ABSCOERCE CK3NOLASTWD
CK&DISPATCH1
# 510 SOLVext			
;
**************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME AXL
::
CK1&Dispatch
list :: DTYPFMAT?
        ITE LXAext
            xOBJ\->
        x\->ARRY
        ;
arry AXLext
any NOP
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME SXL
::
CK1&Dispatch
list :: CKFPOLYext
        DUP CARCOMP
        CK&DISPATCH1
        ELEVEN :: DROP DUPLENCOMP #2+ UNCOERCE CKNNOLASTWD DROP
                  QOBJext HXS>#
                  FROMLISText
                  ;
        any :: DROP' ID VX XEQRCL VALext ;
        ;
ELEVEN :: internalflag ClrUserFlag #>% CKNNOLASTWD TOLISText
          ;
any :: DUP FXNDext
       :: CK&DISPATCH1
          list TRUE
          EIGHTY TRUE
          any FALSE
          ;
       UNROT2DROP ' ID VX XEQRCL SWAP
       case VALext VXXLext
       ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME S2L
::
CK2
VXXLext
;
**********
ASSEMBLE
         CON(1)  8
RPL
xNAME XNUM
::
CK0
real_intflag ClrUserFlag 
pgcdflag ClrUserFlag
DEPTH #0=?SEMI
QOBJext CRUNCH
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME XQ
::
CK0
SETQext
DEPTH #0=?SEMI
ID EPS dREALNcase SETSIZEERR 
%LOG %ABSCOERCE DOFIX QOBJext x\->Q DOSTD
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME L2S
::
CK2&Dispatch
any VALext
;
**************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME LVAR
::
CK1 LVARext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME MMULT
::
CK3
dREALNcase SETSIZEERR
( multiplication avec des matrices et vecteurs )
* %0 matrice*matrice
* %1 matrice*vecteur colonne
* %2 matrice*scalaire, %6 scalaire*matrice
* %3 vecteur*scalaire, %7 scalaire*vecteur
%ABSCOERCE
FOUR #/
( o1, o2, reste, quot )
#0=ITE UNROTSWAP UNROT
( reste, o2, o1 )
( teste o1 )
DUPTYPEARRY? ?SKIP ::	NOTLISTcase SETSIZEERR 3PICK #3=
			ITE	CKFPOLYext 
				:: DTYPFMAT? NcaseSIZEERR ;
			;
( teste o2 )
SWAP3PICK #>1
ITE	CKFPOLYext 
	::	DUPTYPEARRY? ?SEMI
		NOTLISTcase SETSIZEERR 
		3PICK 
		#0=ITE :: DTYPFMAT? NcaseSIZEERR ;
			CKFPOLYext
		;
( reste, o1, o2 )
ROT 
( reste, o1, o2 )
DUP#0=csedrp :: TWO BINEVALext MMULText ;
DUP#1= casedrop :: ONE BINEVALext MVMULText ;
#2= case :: TWO BINEVALext MPMULText ;
ONE BINEVALext VPMULText
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME EPSX0
::
CK1 ELMGext TRIMext
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME re
::
CK1&Dispatch
any :: DMONOEVALext RREext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME im
::
CK1&Dispatch
any :: DMONOEVALext RIMext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME conj
::
CK1&Dispatch
any :: DMONOEVALext RCONJext ;
;
***********
ASSEMBLE
         CON(1)  8
RPL
xNAME  FXND
::
CK1 FXNDext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME NDXF
::
CK2 CK2FPOLY NDXFext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME PF
::
CK1
DUPTYPESYMB? NOT?SEMI
TWO RFACText
( lvar, numl/denol, liste rac )
DUPNULL{}? 
casedrop :: ZEROSWAP ROT VALOBJext internalflag ClrUserFlag ;
RESOROMP MPext
RESOROMP RMULText
' :: ZEROSWAP 1GETLAM VAL2ext ;
6ROLL
( num-liste/deno-list, liste rac, x^, x*, prog lxx, lvar )
4NULLLAM{} BIND

SWAP FXNDext DUPUNROT DIVext
( liste rac, deno-l, partie entiere-l, nouveau num-l  )
4UNROLL 2GETEVAL
( num-liste, liste rac, deno list, partie entiere  )
4UNROLL SWAP
( partie entiere, num-list, deno-list, liste rac  )
{	BlankDA12 FIFTEEN SEVENTEEN &$ DISPROW1
	DUP EDITDECOMP$ :: TWO FIVE ; Disp5x7 
	} 
User1IT
BEGIN
	( partie entiere, num-list, deno-list, liste rac  )
	DUPLENCOMP #0<>
WHILE
	INNERCOMP #2- {}N UNROT
	( p. entiere, num-l, deno-l, { reste }, rac, mul )
	{	SEVENTEEN DISPROW6 
		OVER DO>STR APPEND_SPACE 
		OVER DO>STR &$ DISPROW7 
	} User1IT
	( p. entiere, num-l, deno-l, { reste }, rac, mul )
	%ABSCOERCE SWAP ONE{}N RACTOFACext CARCOMP
	( p. entiere, num-l, deno-l, { reste }, #mul, fact )
	DUP 2GETEVAL 7UNROLL
	( facteuralg, ent., num-l, deno-l, { reste }, #mul, fact  )
	SWAP2DUP 3GETLAM 4GETLAM EVAL
	( facteuralg, int, num-l, deno-l, { reste }, facteur, #n, fact^#n )
	5PICK OVER DIVext DROP
	( .., num, deno, reste rac, facteur, #n, fact^#n, deno/fact^#n )
	7PICK UNROT
	( .., num, deno, reste rac, facteur, #n, num, fact^#n[x], deno/fact^#n[y] )

	( ID CAB )
	( c, a, b )
	EGCDext
	( c, d, u, v )
	2SWAP DIVext TRIMOBJext
	( u, v, c div d, c mod d )
	%0 EQUAL NcaseSIZEERR
	( u, v, c div d )
	ROTOVER RMULText UNROT RMULText
	( u*[c div d], v*[c div d])
	( fin de CAB )

	( .., num, deno, reste rac, facteur, #n, x, y )
	SWAPDROP
	( .., num, deno, reste rac, facteur, #n, y )
	OVER
	( .., num, deno, reste rac, facteur, #n, y , #n)
	ZERO_DO (DO)
		( .., num, deno, reste rac, facteur, #n, y )
		3PICK DIVext
		( facteuralg, int, num, deno, reste rac, facteur, #n, y1, y2 )
		2GETEVAL NINE PICK DUPTYPESYMB? ITE INNERCOMP ONE
		DUP #4+PICK INDEX@#- DUP#1=
		ITE_DROP
			:: UNCOERCE ' x^ ROT #2+ ;
		SYMBN x/ 8ROLL SWAP x+ 7UNROLL
		( facteuralg, int, num, deno, reste rac, facteur, #n, y1 )
		LOOP
	3DROP 5ROLLDROP
	( int, num, deno, reste rac)
REPEAT
ABND 3DROP 
internalflag ClrUserFlag
;
***********
ASSEMBLE
         CON(1)  8
RPL
xNAME EXEC
::
CK2&Dispatch
2LIST :: CK3NOLASTWD MEVALext ;
symb :: DUPDUP LENCOMP NTHCOMPDROP EQ: x=
        NcaseTYPEERR
        xOBJ\-> 2DROP 
	( obj, o1, o2 )
	( si o1 est une fnct, on recherche les derivees dans obj )
	( sinon on isole si possible 1 idnt a gauche et on cree 2 listes )
	OVER DUPTYPESYMB? NOTcasedrop MEVALext
	( obj, o1, o2, o1 )
	DUPDUP LENCOMP NTHCOMPDROP
	( obj, o1, o2, o1, operateur )
	EQ: xFCNAPPLY
	( obj, o1, o2, o1, ?fnct utilisateur )
	ITE ::	' xOBJ\-> EvalNoCK
		( obj, o1, o2, arg1, ..., argk, %arg, idnt )
		SWAP COERCE DUPUNROT #2+UNROLL {}N
		( obj, o1, o2, idnt, { arg1 ... argk } )
		5PICK LIDNText
		( obj, o1, o2, idnt, { arg1 ... argk }, { idnt de obj } )
		( teste si obj2 est une fonction utilisateur )
		4PICK DUPTYPESYMB?
		ITE :: DUPLENCOMP NTHCOMPDROP EQ: xFCNAPPLY ;
		    DROPFALSE
		NOTcase2drop :: DROP RDROP MEVALext ;
		( obj, o1, o2, idnt, { arg1 ... argk }, { idnt de obj } )
		( cherche la liste des arg de fnct2 )
		4PICK ' xOBJ\-> EvalNoCK SWAP COERCE DUPUNROT #2+UNROLL {}N
		( ..., idnt, { args }, { idnt de obj }, newidnt, { newargs } )
		NULL{} DUP 5ROLL
		[BEGIN]
			DUPNULL{}?
		NOT_WHILE
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		( pour chaque idnt de obj, on teste si "idnt" de obj )
		( contient "idnt" )
		::
		DUP CDRCOMP SWAP CARCOMP
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt )
		DUP 
		( objidnt -> liste_der, stripped_idnt )
		ID>$ NULL{} SWAP
		BEGIN
			( liste, $ )
* a ameliorer car on recalcule chaque fois la chaine corresp. a
* l'idnt a remplacer
			TEN PICK ID>$ OVER EQUAL
			ITE FALSE :: DUP "d" ONE POS$ #1= ;
		WHILE
			CDR$ ZEROSWAP
			( liste, #, $ )
			BEGIN
				::	DUP CAR$ DUPNULL$? caseFALSE
					( liste, #, $, car$ )
					CHR># FORTYEIGHT OVER #>
					( liste, #, $, car#, ? )
					caseFALSE
					FORTYEIGHT #- DUP TEN #<
					;
			( liste, #, $, [ obj FALSE | # TRUE ] )
			WHILE
				ROT TEN #* #+ SWAP CDR$
			REPEAT
			DROP
			( liste, #, $ )
			UNROT >TCOMP SWAP
			( liste, $ )
		REPEAT
		( liste, $ )
		$>ID	
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, stripped_idnt )
		TEN PICK EQUAL NOTcase2DROP
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste )
		DUPNULL{}? case2DROP
		( creation de newidnt[newargs] )
		6PICK INNERDUP #8+ PICK ONE SYMBN SWAP xFCNAPPLY
		SWAPDUP LENCOMP
		ZERO_DO 
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste )
			DUP CDRCOMP SWAP CARCOMP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste, no de derivee )
			8PICK OVER NTHELCOMP NcaseTYPEERR
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste, no de derivee, newarg_no )
			4ROLLSWAP 3PICK 
			:: 
			SWAP DUPTYPESYMB? 
			IT :: ' TYPEIDNT? Find1stTrue NOTcase %1 ;
			idntlamcase :: SWAPDROP DERIVext ;
			( symb, #, obj )
			DROP UNCOERCE DO>STR SWAPINCOMP get1 5ROLL 
			CARCOMP ID>$ &$ CHR_d >H$ $>ID ONE SYMBN 4UNROLL SYMBN
			;
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, no de derivee, resultat )
			TEN PICK ROT NTHELCOMP NcaseTYPEERR
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, resultat, arg_no )
			DUPTYPESYMB? 
			ITE ::	DUP ' TYPEIDNT? Find1stTrue 
				NOTcaseDROP DERIVext RDIVext
				;
				DROP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, resultat )
			SWAPLOOP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste )
		DROP 4ROLLSWAP >TCOMP UNROT
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt )
		4ROLL 7PICK INNERDUP #3+ ROLL ONE SYMBN SWAP xFCNAPPLY >TCOMP UNROT
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		;
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		[REPEAT]
		DROP 6UNROLL 6UNROLL 4DROP
		( obj, o1, o2, l1, l2 )
		; 
	    ::	' TYPEIDNT? Find1stTrue
		( obj, o1, o2, [ indt, TRUE | FALSE ] )
		NOTcase :: RDROP MEVALext ;
		( obj, o1, o2, idnt )
		UNROT 2DUP ' x- EvalNoCK 
		( obj, idnt, o1, o2, o1-o2 )
		4ROLL
		( obj, o1, o2, o1-o2, idnt )
		ISOLext
		( obj, o1, o2, idnt, valeur )
		ONE{}N SWAP ONE{}N SWAP
		( obj, o1, o2, l1, l2 )
		;
	( obj, o1, o2, l1, l2 )
	ROT >HCOMP UNROTSWAP
	( obj, l2, l1, o1 )
	>HCOMP SWAP MEVALext
        ;
seco :: ' QOBJext SWAP 2Ob>Seco EVAL ;
idnt :: ISOLext ' x= EvalNoCK ;
;
***************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME tEVAL
::
CK1
GARBAGE CLKTICKS 1LAMBIND EVAL CLKTICKS 1GETABND
bit- HXS>% % 8192 %/ % 0.0067 %- %4 RNDXY "s" >TAG
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME der
::
CK2&Dispatch
any ::	internalflag SetUserFlag
	DERIVext
	internalflag ClrUserFlag
	;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME PTAYL
::
CK2&Dispatch
any :: CK2FPOLY ZERO BINEVALext PTAYLext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME DIV1
::
CK2&Dispatch
any :: CK2FPOLY TRIMext ZERO BINEVALext RDIVext ;
;
**********
ASSEMBLE
         CON(1)  8
RPL
xNAME HORN
::
CK2&Dispatch
any :: CK2FPOLY
       internalflag TestUserFlag case HORNext
       TWO TOLISText
       HORNext
       ZEROZEROZERO THREE{}N FROMLISText
       ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME LU2
::
CK1
DTYPENDO? NcaseSIZEERR
( endomorphisme )
TRANext DUP xidn x+ TRANext
( { A idn } )
ONE REDLIBext DUP' NULLLAM SIX NDUPN DOBIND 
' 5PICK 3GETLAM EVAL 
ABND
( { l u } )
TRANext
INNERCOMP #2/
( l1, ...ln, u1, ..., un, #n )
DUPDUP #2+UNROLL
( l1, ..., ln, #n , u1, ..., un, #n )
{}N TRANext OVER#2+UNROL {}N
( u, l )
TRANext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME FDER
::
CK1
' ::	dLISTcase DERext 
	' ID VX XEQRCL 
	( ici il faudrait traiter les reels/complexes par SYMCOMP )
	internalflag SetUserFlag
	DERIVext
	internalflag ClrUserFlag
	;
( objet, prg )
SWAP
FXNDext
( prg, n, d )
num1=case :: DROPSWAP EVAL ;
2DUP
( prg, n, d, n, d )
5PICK EVAL
( prg, n, d, n, d' )
4UNROLL 5ROLL EVAL
( d', n, d, n' )
OVER 5UNROLL
FOUR {}N LVARext VXXLext
INCOMPDROP
( symb-d, lvar,  d', n, d, n' )
4UNROLLROT
( symb-d, lvar,  n', n, d, d' )
SIMPext
( symb-d, lvar,  n', n, d/gcd, d'/gcd )
OVER 5UNROLL
( symb-d, lvar,  d/gcd, n', n, d/gcd, d'/gcd )
4UNROLLROT
( symb-d, lvar,  d/gcd, d'/gcd, n, d/gcd, n' )
RMULText UNROT RMULText RSUBext
( symb-d, lvar, d/gcd, num )
TWO{}N ONE SWAPROT VALOBJext
INCOMPDROP
( symb-d, d/gcd, num )
UNROT
NUMEVALext :: RMULText
*              DUPTYPELIST? ?SKIP xCOLCT
              RDIVext
              ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME  FINT
::
CK1
dLISTcase INTEGRext
xPF ' ID  ' ID VX XEQRCL ROTOVER x\.S
;
*************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME add
::
CK2&Dispatch
any :: asopext RADDext
       ;
;
*********
ASSEMBLE
         CON(3)	000
RPL
xNAME SUBT
::
CK2&Dispatch
any :: asopext RSUBext
       ;
;
******************
ASSEMBLE
         CON(3)	000
RPL
xNAME MULT
::
CK2&Dispatch
SIXTYEIGHT x*
TWENTY x*
THIRTYSIX x*
* ARRYREAL x*
* FOURTWO x*
FOUR :: AXLext xMULT ;
any ::	internalflag TestUserFlag case RMULText
	::	CK&DISPATCH1
		2LIST TWO ( matr/vect * matr/vect )
		SIXTYFOUR ONE
		list THREE
		EIGHTY ONE
		any ZERO
		;
	( o1, o2, # )
	DUP#0=csedrp :: ZERO BINEVALext RMULText ;
	DUP#1= casedrop :: SWAP xMULT ;
	#2- #6* OVER DEPTHext #1= IT #1+
	UNCOERCE xMMULT
	;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME  DIV2
::
CK2 CK2FPOLY TEN SetUserFlag
BIN2EVALext :: TRIMext DIVext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME POWER
::
CK2&Dispatch
# 81 :: RESOROMP QMULText MPext ;
SYMREAL :: x^ SIMP1ext
           ;
ARRYREAL :: 'x* MPext ;
any :: RESOROMP xMULT MPext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME CHS
::
CK1&Dispatch
any :: DMONOEVALext RNEGext ;
;
**********
ASSEMBLE
         CON(1)  8
RPL
xNAME VER
::
*  0123456789012345678901
*  "GNU GPL ALGB Library 2"
*  DISPROW1
*  "      Bernard.Parisse"
*  DISPROW3
*  "@ujf-grenoble.fr"
*  DISPROW4
*  "http://www-fourier.ujf"
*  DISPROW5
*  "-grenoble.fr/~parisse"
*  DISPROW6
*  "  and Ram Gudavalli"
*  DISPROW7
"http://www-fourier.ujf"
DISPROW1
"-grenoble.fr/~parisse"
DISPROW2
SetDA1Temp
CONTEXT@
HOMEDIR % .0000000001 ' ID EPS STO 'IDX ' ID VX STO
CONTEXT!
SIXTEEN TWELVE DO INDEX@ SetUserFlag LOOP
TWENTYTWO SIXTEEN DO INDEX@ ClrUserFlag LOOP
TWENTYSEVEN SetSysFlag
VERNUMext
;
*********
* ASSEMBLE
*         CON(1)  8
* RPL
* xNAME RMSYM
* ::
* CK1&Dispatch
* symb RMSYMext
* ;
*********
* -*- mode:Mail -*-
	STITLE GNU ALGB Library Main Module
*  (c) 01/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

*****************************************************************
NULLNAME VERNUMext
VERSION%
*****************************************
NULLNAME TRIMOBJext ( obj -> obj )
* comme TRIM mais sans rendre forcement une liste
::
' ::	( LAM5 complex -> complex / real )
	DUP C%>% %0= NOTcaseDROP SWAPDROP
	;
' :: ( LAM4 irrquad -> irrquad )
     QXNDext THREE ZERO_DO (DO) 1GETLAM EVAL EVAL UNROT LOOP NDXQext
     ;
' ::	( LAM3 fraction -> obj )
	FXNDext num1=case DROP 
	1GETLAM EVAL EVAL SWAP 1GETLAM EVAL EVAL SWAP SIMPNDXFext
	;
' :: ( LAM2 list -> obj': obj'=obj si non liste, sinon supprime les 0 en-tete )
     DTYPELIST? NOT?SEMI
     DUPNULL{}? ?SEMI
     INNERCOMP FALSE SWAPDUP
     ( an, ..., a1, false, #n, #n )
     ZERO_DO (DO)
             ( ak-1,...,an, ..., ak, flag, #n )
             get1 1GETLAM EVAL EVAL
             ( ak-2,...,an,..., ak, flag, #n, ak-1' )
             3PICK
             :: case UNROT
                ( ak-2,...,an,..., ak, false, #n, ak-1'  )
                num0=case DROP#1-
                ROTDROPSWAP TRUE SWAP
                ( ak-2,...,an,..., ak, ak-1', TRUE, #n )
                ;
             LOOP
     SWAP NOTcasedrop %0
     DUP#1= NOTcase {}N
     DROP
     CK&DISPATCH1
     real NOP
     TWO NOP
     any ONE{}N
     ;
' :: ( LAM1 )
     CK&DISPATCH1
     real 'NOP
     TWO 5GETLAM
     list 2GETLAM
     symb 3GETLAM
     seco 4GETLAM
     any 'NOP
     ;
' NULLLAM FIVE NDUPN DOBIND
1GETLAM EVAL EVAL ABND
;
*********************************
NULLNAME LXAext ( liste -> meta-array )
* Explose un vecteur ou une matrice formelle comme ARRY\->
::
DTYPELIST? NOT?SEMI DUPNULL{}? ?SEMI
QOBJext CRUNCH
DUP CARCOMP
dLISTcase :: LENCOMP UNCOERCE SWAP DUPLENCOMP UNCOERCE
             ROT TWO{}N SWAPINCOMP reversym
             #1+_ONE_DO (DO)
                        INNERCOMP INDEX@ #* #1+ROLL
                        LOOP
             ;
DROP INNERCOMP UNCOERCE
;
*****************************************************************
NULLNAME  AXLext ( array -> liste )
* Transforme un tableau en liste
::
DUPTYPEARRY? NOT?SEMI
' xARRY\-> EvalNoCK INNER#1=
SWAP COERCESWAP
case {}N
SWAP COERCE NULL{} SWAP
ZERO_DO (DO)
        OVER#2+UNROL {}N DUPLENCOMP
        UNROT >HCOMP
        LOOP
SWAPDROP
;
**************
NULLNAME EGCDext ( a, b -> d, u, v t.q. d=pgcd[a,b], au+bv=d )
* identit de Bezout pour des polynomes
::
num0case :: DROP %1 %0 ;
DUPTYPELIST? ITE DUPLENCOMP ONE
#1=case :: SWAPDROP %0 %1 ;
SWAP 
num0case :: DROP %0 %1 ;
DUPTYPELIST? ITE DUPLENCOMP ONE
#1=case :: SWAPDROP %1 %0 ;
( on determine le ppcm des denominateurs de b et de a -> travail en entiers)
( b, a )
DUP DENOLCMext
( b, a, ppcmb )
DUPROT LOPMext
( b, ppcma, a*ppcma )
ROTDUP DENOLCMext
( ppcma, a*ppcma, b, ppcmb )
DUP4UNROLL SWAP LOPMext
( ppcma, ppcmb, a*ppcma, b*ppcmb )

( a, b avec a polynome de degre >=1 )
RESOROMP RMULText
' ::	( LAM1 : a, b  -> d, u, v )
	( avec d=au+bv )
	( a, b )
	num0case :: DROP %1 %0 ;
	DUPTYPELIST? ITE DUPLENCOMP ONE
	#1=case :: SWAPDROP %0 %1 ;
	( a, b )
	LPGCDext
	( a, b, beta=lpgcd[b] )
	DUP4UNROLL LOPDext
	( beta, a, B=b/lpgcd[b] )
	( alpha= B.1^#a-#B+1 )
	DUPLENCOMP OVER CARCOMP
	( beta, a, B, #B, B.1 )
	4PICK LENCOMP ROT
	( beta, a, B, B.1, #a, #B )
	2DUP#< ITE	:: 3DROP %1 ;
			:: #-+1 2GETLAM MPext ; 
	( beta,  a, B, alpha )
	DUP 4ROLL LOPMext
	( beta,  B, alpha, A=alpha*a )
	ROT DUPUNROT DIVext
	( beta, alpha, B, A div B, A mod B )
	ROTSWAP
	( beta, alpha, A div B, B, A mod B )
	1GETLAM EVAL 
	( beta, alpha, A div B, d, u1, v1 )
	( avec : d= B*u1+[A mod B]*v1 )
	( [A mod B]=a*alpha-[A div B]*B )
	( donc: d= a*[alpha*v1]+ B*[u1-[A div B]*v1] )
	( beta, alpha, A div B, d, u1, v1 )
	5ROLL OVER 2GETEVAL
	( beta, A div B, d, u1, v1, alpha*v1 )
	UNROT 5ROLL 2GETEVAL
	( beta, d, alpha*v1, u1, v1*A div B )
	RSUBext 4ROLL SIMPext
	( d, alpha*v1, u1-v1*A div B, beta )
	2SWAP 3PICK 2GETEVAL
	( u1-v1*A div B, beta, d, alpha*v1*beta )
	4UNROLL 2GETEVAL UNROT
	( d*beta, v1*alpha*beta, u1- [A div B]* v1 )
	;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL ABND
( ppcma, ppcmb, d, u, v )
( d=a*ppcma*u+b*ppcmb*v )
4ROLL RMULText SWAP4ROLL RMULText
( d, v*ppcmb, u*ppcma )
SWAP THREE{}N LPGCDext LOPDext INCOMPDROP
( d, u, v )
( d, u, v )
;
**********************
NULLNAME MONOEVALext 
( o, # depth, [operande du runstream] -> operande[o] )
* # est la profondeur de operande[o] 
::
internalflag TestUserFlag caseDROP
SWAP LVARext VXXLext 'REVAL SWAP 
VALOBJext internalflag ClrUserFlag
;
**************
NULLNAME ELMGext ( obj -> obj )
* Remplace par 0 les reels inferieurs a epsilon
::
ID EPS dREALNcase SETNONEXTERR
' :: CK&DISPATCH1
     real :: DUP %ABS 2GETLAM %< casedrop %0
             ;
     TWO :: C%>% ( re, im ) SWAPDUP ( im, re, re ) %ABS 2GETLAM %<
            ( im , re, re<eps? )
            ITE %0 DUP
            SWAPDROPSWAP
            ( re ou %0, im )
            DUP %ABS 2GETLAM %< caseDROP %>C%
            ;
     list LISTSECOext
     symb LISTSECOext
     arry :: DUP xABS 2GETLAM %< NOT?SEMI
             %0 xCON
             ;
     ZERO NOP
     ;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL ABND
;
**************
NULLNAME DIVISext ( objet -> liste des diviseurs )
* objet peut etre algebrique ou entier
* dans le premier cas, DIVISext renvoie une liste de facteurs premiers
* dans le second cas, la liste des diviseurs si l'entier est < a #FFFFFh
::
FACTOext UNROT2DROP
( { facteurs, multiplicite } )
' ::	( LAM2 metadiv, d, lfact -> metadiv )
	DUPNULL{}? case2DROP
	INNERCOMP #2- {}N
	( d1, ..., dk, #k, d, f, m, lfact )
	3PICK num1=case :: DROP UNROT2DROP 2GETEVAL ;
	DROPSWAP COERCE #1+
	ZERO_DO (DO)
		( d1, ..., dk, #k, d, f, lfact )
		ROTSWAP 1GETLAM EVAL 
		( d1, ..., dk, #k, f, d, lfact )
		SWAP3PICK RMULText 
		( d1, ..., dk, #k, f, lfact, d*f )
		UNROT
		LOOP
	( d1, ..., dk, #k, d, f, lfact )
	3DROP
	;
' ::	( LAM1 )
	( metadiv, facteur, d, lfact -> metadiv, facteur, d,lfact )
	DUPNULL{}? casedrop :: ROT#1+UNROT DUP4UNROLL NULL{} ;
	( d1, ..., dk, #k, facteur, d, lfact )
	THREE psh
	( facteur, d, lfact, #3, d1, ..., dk, #k )
	DUP #4+PICK
	( facteur, d, lfact, #3, d1, ..., dk, #k, d )
	OVER #4+PICK
	( save_meta, d1, ..., dk, #k, d, lfact )
	2GETEVAL
	( save_meta, metadiv )
	psh 
	( metadiv, save_meta )
	DROP 
	( metadiv, facteur, d, lfact )
	;
' NULLLAM DUPTWO DOBIND
ZERO %1 ROT 2GETEVAL {}N
ABND
DUPNULL{}? casedrop { %1 }
;
**************
NULLNAME RACPOLext ( liste de racines ou de facteurs -> objet )
* Inverse de FACTO.
* Selon le flag 10 il s'agit de facteurs ou de racines.
::
TEN TestUserFlag  ( -> lam3 )
RESOROMP RMULText ( -> lam2 )
' :: 2GETLAM MPext ; ( -> lam1 )
FACTOOBJext
;
**************
NULLNAME FACT1ext
( polynome -> lvar, poly-liste, {liste des racines/multiplicite} )
::
( obj )
ZERO RFACText
;
**************
NULLNAME FACTOext
* entier -> liste des facteurs premiers
* objet -> lvar, poly-liste, liste des facteurs
::
FOUR RFACText
( lvar, poly-l, liste facteurs / multiplicite )
;
**************
NULLNAME SOLVext ( polynome-liste -> liste des racines )
::

* Routine de factorisation pour S/SX
INCLUDE alsolv.s
* Fin de routine de factorisation pour S/SX

* Routine de factorisation pour G/GX
* INCLUDE alsolv.g
* Fin de routine de factorisation pour S/SX

( reconstruction des racines sous forme formelle si possible )
complexflag TestUserFlag real_intflag TestUserFlag AND
NOTcase SWAPDROP
# 31415 JstGETTHEMSG DISPROW7
NULL{} UNROT
( froot-l, deno, nroot-l )
:: INNERDUP FOUR #<case :: {}N SWAPDROP ;
   get1 OVERDUP
   ( formal-root-list, allroots, #n, deno, #n, #n )
   ONE_DO (DO)
          ( formal-root-list, allroots, #racines, deno, #racines_a_tester )
          4ROLLOVER
          ( formal-root-list, roots, #n, deno, #t, rk, #t )
          ONE_DO (DO)
          :: ( formal-root-list, roots, #n, deno, #t, rk )
             5ROLL 2DUP 2DUP x+ xNEG
             ( formal-root-list, roots, #n, deno, #t, rk, rl, rk, rl, -rk-rl )
             7PICK x* UNROT x*
             ( formal-root-list, roots, #n, deno, #t, rk, rl, -rk-rl, rk*rl )
             6PICK x* 6PICK UNROT
             ( froot-list, roots, #n, deno, #t, rk, rl, deno, -rk-rl, rk*rl )
             THREE{}N
             ( froot-list, roots, #n, deno, #t, rk, rl, P-list )
             DUP QOBJext :: %0 xRND ;
             SWAPOVER RSUBext ELMGext TRIMOBJext %0 EQUAL
             ( froot-list, roots, #n, deno, #t, rk, rl, P-list, flag )
             NOTcasedrop :: 3PICK #3+ UNROLL ;
             UNROT2DROP DEG2ext
             ( froot-list, roots, #n, deno, #t, P-list )
             4ROLL DUP #3+ ROLL
             ( roots, deno, #t, P-list, #n, froot-list )
             ROT &COMP OVER#2+UNROL
             ( froot-list, roots, deno, #t, #n )
             #2- DUP#1+ JSTOPSTO ExitAtLOOP
             ( froot-list, roots, deno, #t, #n-2 )
             UNROT #1-
             ( froot-list, roots, #n-2, deno, #t-1 )
             4ROLL
             ( froot-list, roots, #n-2, deno, #t-1, rk' )
             ;
             LOOP
          ( froot-list, roots, #n, deno, #t, rk )
          4PICK #3+ UNROLL #1-
          ( froot-list, roots, #n, deno, #t-1 )
          ( en fait #n, #t -> #n-2,#t-2 si 2 racines sont trouves )
          ( ou -> #n, #t-1 si aucune racine formelle n'est trouve )
          LOOP
   ( froot-list, roots, #n, deno , #t )
   ( ou zero, froot-list, deno, #t )
   2DROP NOTLISTcase {}N SWAPDROP RDROP
   ( froot-list, {roots} )
   ;
SWAP DUPNULL{}? NOTcase &COMP
DROP real_intflag ClrUserFlag
;
**************
NULLNAME EVIDENText ( polynome-liste -> liste de racines, reste de poly )
* Recherche les racines rationnelles d'un polynome (permet aussi de
* factoriser certains polynomes a coefficients formels)
::
( polynome-liste -> liste de racines, reste de poly )
DUPNULL{}? caseSIZEERR
NULL{} SWAP
( null{}, obj )
NOTLISTcase ONE{}N
symbolicflag TestUserFlag NOT?SEMI
( null{}, list )
TRIMext
( null{}, list )
SWAPDROPDUP CARCOMP ONE{}N
( list, { 1er lment } )
SWAP
DUPLENCOMP FOUR
#<case :: DEG2ext SWAP ;
( { 1er lment }, list )
LPGCDext LOPDext
INNERCOMP get1 OVER
* Elimine les zros en queue de polynome -> liste des racines
ZERO_DO (DO)
        ( a0, ..., ak, #k+1 , {root} )
        :: ROT num0case :: >TCOMP SWAP#1-SWAP ;
           UNROT ExitAtLOOP
           ;
        LOOP
* Calcule les numrateurs et les dnominateurs
( a0, ..., ak, #k+1, {root} )
OVER#2+UNROL
2DUP #2+UNROLL
( {root}, ak, a0, ..., ak , #k+1 )
{}N DUP CARCOMP
( {root}, ak, l, a0 )
ROT
( {root}, l, a0, an )
SWAPDUP DIVISext
( {root}, l, an, a0, { diviseurs } )
{ BlankDA12 FOUR TWO &$ DISPROW1
  FIVE 3PICK DO>STR &$ DISPROW7
  DUP EDITDECOMP$ #TWO#TWO Disp5x7 }
User1IT
SWAPDROP
( {root}, l, an, { diviseurs } )
SWAPDUP DIVISext
( {root}, l, {diviseurs}, an, {num} )
* Binding des nulllam
ONEONE ( LAM 4 et 3 )
RESOROMP HORNext ( LAM 2 )
'    :: ( LAM1 { root-liste }, P, test  -> { root-liste } , P )
        OVER ( root, P, test, P)
        ( test appui d'une touche )
        kcMenuKey6 GETTOUCH
        ITE #=
            DROPFALSE
        ( test si le poly est de degre <= 2 )
        :: caseTRUE
           DUPLENCOMP FOUR #<
           ;
        case2drop :: ZEROZERO ISTOPSTO JSTOPSTO ;
        SWAP 2GETEVAL
        ( root, P, P', test, test-value )
        num0case :: DROP
                    { DUP DO>STR ELEVEN TWO &$ &$ DISPROW7 } User1IT
                    ROTDROP ROTOVER >TCOMP UNROT 1GETLAM EVAL
                    ;
        3DROP
        ( root, P, P', test )
        ;
4NULLLAM{} BIND
( LAM4=dnominateur ,3= nombre de numrateurs, 2= HORN, 1 =prg test )
* suite du prg
( {root}, l, {diviseurs}, an, {num} )
DUPLENCOMP 3PUTLAM
{ 3PICK LENCOMP #>$ ONE &$ DISPROW1
  FIVE 3PICK DO>STR &$ DISPROW6
  5GETLAM #>$ TWELVE &$ DISPROW3
  DUP EDITDECOMP$ #TWO#FOUR SWAP Disp5x7
  }
User1IT
SWAPDROP
( stack={root},  l, { denominateurs } , { numrateurs } )
"HALT" NULL$ DUPDUP 2DUP MENUext
2SWAP
( { deno}, { num }, { root }, P )
* boucle principale de test
4PICK LENCOMP
#1+_ONE_DO (DO)
           4PICK INDEX@ NTHCOMPDROP 4PUTLAM
           ( lam4 = denominateur )
           3GETLAM ( nombre de numerateurs )
           #1+_ONE_DO (DO)
                      ( { deno}, { num }, { root }, P )
                      3PICK INDEX@ NTHCOMPDROP 4GETLAM RDIVext DUP4UNROLL
                      ( { deno}, { num }, test, { root }, P , test )
                      { TWENTYSIX OVER FXNDext DO>STR SWAP
                        DO>STR "/" &$ SWAP&$ &$ DISPROW6 } User1IT
                      1GETLAM EVAL
                      ROT RNEGext 1GETLAM EVAL
                      LOOP
           LOOP
( { deno}, { num }, { root }, P )
ABND ROTDROP ROTDROP
( { 1er lment, root } , P )
SWAPDUP CARCOMP SWAP CDRCOMP
( P, 1er lment, { root } )
3PICK LENCOMP
FOUR #<case :: ROT DEG2ext &COMP SWAP ONE{}N DispMenu.1 ;
UNROTOVER
( { root }, P, 1er element, P )
CARCOMP QUOText SWAP LOPMext
DispMenu.1
;
**************
NULLNAME DEG2ext ( polynome-liste de degre < 3 -> liste des racines )
* Factorisation d'un polynome de degre 2 (eventuellement formel) ou plus
::
DUPNULL{}? ?SEMI
TRLPGCDext LOPDext
DUPLENCOMP #1-
DUP#0= case2drop NULL{}
DUP#1= casedrop :: INCOMPDROP RNEGext SWAP RDIVext ONE{}N ;
#>2case SOLVext
( list )
RESOROMP RMULText
RESOROMP RSUBext
' NULLLAM DUPTWO DOBIND
( LAM1= x-, LAM2= x* )
DUPINCOMP DROP
( list, a, b, c )
FXNDext ROT FXNDext 5ROLL FXNDext
( list, cn, cd, bn, bd, an, ad )
3PICK 6PICK 2GETEVAL ROT 2GETEVAL %2 2GETEVAL 6UNROLL
( list, A, cn, cd, bn, bd, ad )
4ROLLOVER 2GETEVAL 4ROLL 2GETEVAL RNEGext 4UNROLL
( list, A, B, cn, bd, ad )
2GETEVAL 2GETEVAL %2 2GETEVAL
( list, A, B, C )
OVERDUP 2GETEVAL
( list, A, B, C, B^2 )
SWAP4PICK
( list, A, B, B^2, C, A )
2GETEVAL 1GETLAM EVAL
( list, A, B, delta )
:: complexflag TestUserFlag ?SEMI
   DUPTYPEREAL? NOT?SEMI
   DUP %0< NOT?SEMI 3DROP NULL$ >TAG ONE{}N ABND RDROP
   ;
XSQRext
( list, A, B, D )
2DUP 1GETLAM EVAL
( list, A, B,D, B-D )
4PICK RDIVext
4UNROLL
( list, root1, A, B, D )
RADDext SWAP RDIVext
TWO{}N
SWAPDROP ABND
;
**************
NULLNAME PIext ( liste -> produit des elements de liste )
::
INNERCOMP
DUP#0=csedrp %1
DUP#1= caseDROP
ONE_DO (DO)
       SWAP RMULText
       LOOP
;
******************************
NULLNAME POSITIFext ( obj -> obj, flag )
* essaie de determiner si on est + a l'infini 
::
( obj -> obj, flag )
DUP' ::	CARCOMP
	1GETLAM EVAL
	;
' ::	CK&DISPATCH1
	TWO	C>Re%
	list	2GETEVAL
	symb	2GETEVAL
	EIGHT	2GETEVAL
	any	NOP
	;
' NULLLAM DUPTWO DOBIND
( n/d, n/d )
FXNDext 1GETLAM EVAL
( n/d, n, D )
DUPTYPEREAL? 
ITE ::	%0> ?SEMI 
	DROP FXNDext RNEGext SWAP RNEGext
	( -d, -n )
	DUPROT NDXFext SWAP
	( -n/-d, -n )
	;
	DROP
( n/d, n )
1GETLAM EVAL
( n/d, N )
DUPTYPEREAL? ITE %0> DROPTRUE
ABND
;
*****************************************************************
NULLNAME DENOLCMext
::
( liste -> ppcm des denos ) 
INNERCOMP
DUP#0=csedrp %1
#1-SWAP FXNDext SWAPDROPSWAP
( o1, ..., on-1, res, #n-1 )
DUP#0=csDROP
ZERO_DO (DO)
	( o1, ..., on-1, res )
	SWAP FXNDext SWAPDROP 
	TWO{}N TRLPGCDext SWAP INCOMPDROP RMULText SWAP RDIVext
	LOOP
;
*******************
NULLNAME asopext
::
CK2FPOLY internalflag TestUserFlag ?SEMI
DUP DEPTHext 3PICK DEPTHext 2DUP#= NcaseSIZEERR
#MAX COLA BINEVALext
;
***************
NULLNAME rrefext
::
AXLext DTYPFMAT? NcaseTYPEERR
ONE REDLIBext DUP' NULLLAM SIX NDUPN DOBIND ONE 3GETLAM EVAL ABND
;
********************
NULLNAME LOPAext ( liste, objet, oprateur binaire -> liste )
* List Operation All
::
' :: dLISTcase LISTSECOext
     3GETLAM 2GETEVAL
     ;
' NULLLAM DUPDUP THREE DOBIND
1GETLAM EVAL
ABND
;
**************
NULLNAME LOPMext ( objet, liste -> { objet * elements de liste } )
* List Operation Multiplication
::
SWAP
num1=case DROP
RESOROMP RMULText
LOP1ext
;
**************
NULLNAME DIVOBJext ( f, obj  -> f/obj )
::
num1=case DROP RESOROMP RDIVext LOPAext
;
***********************************************************
NULLNAME DIVext ( obj2, obj1 -> obj2 DIV obj1 , obj2 MOD obj1 )
* Division euclidienne de 2 polynomes-listes ou de 2 reels
* calcule le quotient et le reste
* Note: il faudrait aussi faire symb div symb
::
{ %0 } UNROT
CK&DISPATCH1
2REAL :: ROTDROP TEN TestUserFlag
         case :: 2DUP %MOD
                 ( a, b, a mod b )
                 DUP4UNROLL ROTSWAP %- SWAP %/ SWAP
                 ;
         RDIVext %0
         ;
2LIST :: DIV2LISText SWAP TRIMext SWAP ;
EIGHTY ::	( { %0 }, liste, objet )
		FXNDext 
		( { %0 }, liste, obj-n, obj-d )
		DUP 4ROLL RMULText
		( { %0 }, obj-n, obj-d, liste*obj-d )
		ROT
		( { %0 }, obj-d, liste*obj-d, obj-n )
		NOTLISTcase :: DIVOBJext SWAPDROPSWAP ;
		4ROLLDROP DIVext
		( obj-d, liste*obj-d/obj-n, mod )
		ROT DIVOBJext
		;
list :: ( { %0 }, objet, liste )
	SWAP FXNDext
        ( { %0 }, liste, obj-n, obj-d )
	DUP 4ROLL RMULText
        ( { %0 }, obj-n, obj-d, liste )
	3PICK TYPELIST? 
	case :: ( { %0 }, obj-n, obj-d, liste )
		4ROLLDROP ROTSWAP 
		( obj-d, obj-n, liste )
		DIVext ROT DIVOBJext
		;
        ( { %0 }, obj-n, obj-d, liste )
	DUPLENCOMP #1= NOTcasedrop :: NDXFext ONE{}N ;
	SWAPDROP
        TRIMOBJext
        NDXFext
        ( le probleme vient de 0 sur liste -> recursion avec SIMPNDXFext )
        SWAP
        ;
any :: ROTDROP RDIVext DUP %0 RMULText ;
;
**************
NULLNAME LOPDext ( liste, objet -> { elements de liste / objet } )
* List Operation Division,
* attention les elements de liste doivent etre divisibles par objet
::
num1=case DROP
RESOROMP QUOText
( liste, obj, prg )
LOP1ext
;
**************
NULLNAME DERext ( polynome-liste -> derivee )
::
INNERDUP
#1=case :: DROP %0 RESOROMP RMULText LOPAext ONE{}N ;
DUP #2= case2drop ONE{}N
UNROTDROP OVER UNROLL DUPTWO
    DO
    SWAPINDEX@ UNCOERCE RESOROMP RMULText LOPAext OVER UNROLL
    LOOP
#1-{}N
;
*************
NULLNAME INTEGRext ( polynome-liste -> primitive )
* calcule la primitive s'annulant en 0
::
INNERCOMP #1+DUP
ONE_DO (DO)
       SWAPINDEX@ UNCOERCE RESOROMP RDIVext LOPAext OVER UNROLL
       LOOP
%0 SWAP {}N
;
**************
NULLNAME LRDMext ( liste #entier -> liste )
* Left ReDiMension
* Rajoute des 0  gauche pour obtenir un polynome "de degre" egal a
* l'entier specifie
::
#1+ OVER LENCOMP 2DUP#<
( liste, entier+1, longueur de liste , ?entier+1<longueur de liste)
case :: ( liste trop longue: on supprime a gauche )
        DUPROT #-+1 SWAP SUBCOMP
        ;
#-OVER CARCOMP %0 RMULText SWAP NDUPN {}N SWAP &COMP
;
**************
NULLNAME RRDMext ( liste entier -> liste )
* Right ReDiMension: comme LRDM mais cree des zeros a droite
::
#1+ OVER LENCOMP 2DUP#<
( liste, entier+1, longueur de liste , ?entier+1<longueur de liste)
casedrop :: ( liste trop longue: on supprime a droite )
            ONESWAP SUBCOMP
            ;
#-OVER CARCOMP %0 RMULText SWAP NDUPN {}N &COMP
;
**************
NULLNAME TRIMext ( liste -> liste )
* Enleve les zeros en tete de liste
::
:: CK&DISPATCH1
   list TWO
   seco ONE
   symb ONE
   any ZERO
   ;
DUP#0=csDROP
SWAP
TRIMOBJext
SWAP#1- #0=?SEMI
NOTLISTcase ONE{}N
;
************************
NULLNAME DEGREext ( objet -> degre )
* renvoie le degre d'un polynome-liste
::
CK&DISPATCH1
list :: TRIMext LENCOMP #1-
        ;
real %ABSCOERCE
TWO :: C%ABS COERCE ;
any DROPZERO
;
**************
NULLNAME COMPRIMext ( liste -> liste comprimee au sens ensembliste )
::
DUPNULL{}? ?SEMI INNERCOMP reversym NULL{} SWAP
ZERO_DO (DO)
        SWAP apndvarlst
        LOOP
;
**************
NULLNAME NEXTPext ( liste -> liste1, liste2 )
* liste=liste1+liste2, liste2 est formee d'elements identiques
( { o1 o2 ... } -> { liste1 }, { o1 ... o1 } )
( liste1=liste-{o1 ... o1 } )
::
NULL{} SWAPDUP LENCOMP #>1 NOT?SEMI
SWAPDROP
( liste )
INNERDUP
( o1, ..., on, #n, #n )
get1 ONE
( o2, ..., on, #n, #n, o1, #1 )
ROT #1-
ZERO_DO (DO)
	( o2, ..., on, #n, o1, #m )
	ROT
	( o2, ..., on, o1, #m, #n )
	get1
	( o3, ..., on, o1, #m, #n, o2 )
	4PICKOVER
	( o3, ..., on, o1, #m, #n, o2, o1, o2 )
	::	EQUALcasedrp #1-UNROT ( o3, ..., on, #n-1,o1,#m)
		( o3, ..., on, o1, #m, #n, o2 )
		4UNROLL 
		( o3, ..., on, o2, o1, #m, #n )
		UNROT #1-
		( o3, ..., on, o2, #n, o1, #m-1 )
		;
	( o3, ..., on, o2, #n, o1, #m )
	#1+
	LOOP
( o2, ..., on, #n, o1, #m )
NDUPN {}N SWAP#1-SWAP OVER#2+UNROL {}N SWAP
;
**************
NULLNAME QOBJext ( objet [ runstream: programme ] -> objet )
* Exexute programme sur les elements de objet (pour des objets
* de type liste, algebrique ou array en les decomposant)
::
'R
CK1TONOext
' :: CK&DISPATCH1
     real 2GETEVAL
     TWO 2GETEVAL
     sym 2GETEVAL
     ELEVEN 2GETEVAL
     list LISTSECOext
     TAGGED :: xOBJ\-> SWAP 1GETLAM EVAL SWAP x\->TAG ;
     arry :: AXLext 1GETLAM EVAL ;
     seco ::	QXNDext THREE 
		ZERO_DO (DO) 
			1GETLAM EVAL UNROT 
			LOOP 
		NDXQext 
		;
     any NOP
     ;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL
ABND
;
**************
NULLNAME FXNDext ( objet -> numerateur, denominateur )
* Decompose une fraction
::
( o -> num, deno )
DUPTYPESYMB? NOTcase %1
%1 OVER
( symb, 1, symb )
INNERCOMP
OVER EQ: xNEG
( symb, 1, meta, flag )
:: NOTcaseFALSE
   SWAPDROP
   #1- TRUE
   ;
OVER#2+UNROL
( symb, 1, flag, meta )
OVER EQ: x/
NOTcase #1+NDROP
SWAPDROP
( symb, 1, flag, meta_sans_x/ )
#1- pshzerpsharg
SYMBNext
OVER#2+UNROL
SYMBNext
( symb, 1, flag, num, deno )
2SWAP SWAPDROP
( symb, num, deno, flag )
4ROLLDROP
NOT?SEMI
SWAP QOBJext xNEG SWAP
;
**************
NULLNAME NDXFext ( numerateur, denominateur -> algebrique )
* inverse de FXND
::
( o2, o1 )
num1=case DROP
OVER num0=case 2DROP
DROP
%-1 EQUALcasedro RNEGext
CK&DISPATCH1
SYMSYM :: ' x/ EvalNoCK ;
# 90 :: SWAPINCOMP get1 ' x/ ROT #2+ SYMBN ;
symb :: INNERCOMP ' x/ SWAP #2+ SYMBN ;
any :: ' x/ THREE SYMBN ;
;
**************
NULLNAME DEPTHext ( objet -> # )
* renvoie la profondeur maximale d'un objet
::
ZEROSWAP 
DUPTYPEREAL? caseDROP
DUPTYPECMP? caseDROP
idntlamcase DROP
SWAP#1+ DEPTHOBJext
;
**********************
NULLNAME LVARext ( objet -> objet, liste des idnt globaux )
::
LLVARDext ROTDROP
;
**************
NULLNAME VXXLext ( algebrique ID -> polynome-liste par rapport a ID )
* si le polynome-liste depend encore de ID, le flag 11 est mis a 0
::
( objet, idnt/symb/lvar -> lvar, liste )
vxxlflag SetUserFlag
* etait a la fin precedemment
internalflag SetUserFlag
* 
DUPTYPELIST? ?SKIP ONE{}N
( o, lvar )
DUPUNROT
( lvar, objet, lvar )
' :: ( LAM21 )
     ROTDROP SWAP#1-SWAP OVER#2+UNROL
     ( oper, o1, ..., on-1, #n-1 )
     pshzerpsharg
     ( oper, meta2, meta1 )
     2GETEVAL EVAL
     ( oper, meta2, liste1 )
     OVER#2+UNROL 2GETEVAL EVAL
     ( oper, list1, list2 )
     ROT EVAL
     ;
' :: ( LAM20 )
     DUP CARCOMP
     EQ: x<<
     case :: INNERCOMP #5= NcaseTYPEERR
             4UNROLL THREE
             ZERO_DO (DO) 1GETLAM EVAL UNROT LOOP
             4ROLL FIVE ::N
             ;
     EVAL 5GETLAM EVAL ?SEMI
     cmp_i EQUALcasedro C% 0 1
     ;
( LAM19 ) RESOROMP RADDext
( LAM18 ) RESOROMP RSUBext
( LAM17 ) RESOROMP RMULText
( LAM16 ) RESOROMP RDIVext
( LAM15 ) RESOROMP RCONJext
( LAM14 ) RESOROMP RNEGext
( LAM13 ) RESOROMP RIMext
( LAM12 ) RESOROMP RREext
( LAM11 inutilise RESOROMP NDXFext ) 'NOP
( LAM10 ) RESOROMP FXNDext
' :: ( LAM9 x\v/ )
     real_intflag UserITE
     :: SIMPEVALext XSQRext ;
     :: ' x\v/ TWO SYMBN ;
     ;
' :: ( LAM8 x= )
     18GETLAM EVAL
     ZEROSWAP 22GETLAM VAL2ext
     %0 ' x= EvalNoCK
     vxxlflag ClrUserFlag 4GETLAM EVAL
     ;
' :: ( LAM7 xINV ) 10GETLAM EVAL SWAP 16GETLAM EVAL ;
' :: ( LAM6 xSQ ) DUP 17GETLAM EVAL ;
' :: ( LAM5 objet -> objet, false ou liste, true )
     22GETLAM OVER EQUALPOSCOMP
     DUP#0=csedrp FALSE
     SWAPDROP
     ( #pos )
     { %1 %0 } SWAP
     DUP#1= casedrop TRUE
     ONE_DO (DO) ONE{}N LOOP TRUE
     ;
' :: ( LAM4 : objet -> objet dans des listes )
     22GETLAM LENCOMP
     DUP#0=csDROP
     ZERO_DO (DO) ONE{}N LOOP
     ;
' :: ( LAM3 o1,..., on-1, x^, #n -> liste ou objet )
     3PICK DUPTYPEREAL?
     NOTcasedrop :: vxxlflag ClrUserFlag SYMBN 4GETLAM EVAL ;
     DUPDUP %FLOOR %=
     ( o1, ..., on-1, x^, #n, on-1, ?on-1=bint )
     NOTcasedrop :: vxxlflag ClrUserFlag SYMBN 4GETLAM EVAL ;
     ( o1, ..., on-1, x^, #n, on-1 )
     %0< OVER#2+UNROL SWAPDROPSWAP %ABSCOERCE
     ( ?negatif, o1, ..., on-2, #n, #exposant )
     OVER UNROLL
     ( ?negatif, #exposant, o1, ..., on-2, #n )
     #2-
     ( stk=?negatif, #exposant, meta )
     DUP#1+ NDUP DUP#1= ITE_DROP SYMBN
     ( stk= ?negatif, #exposant, meta, symb )
     22GETLAM NTHOF
     ( ?negatif, #exposant, o1, ..., on-2, #n-2, #pos )
     :: DUP#0=csedrp :: 2GETEVAL EVAL SWAP 17GETLAM MPext ;
        ( ?negatif, #exp, meta, #pos )
        OVER#2+UNROL NDROP
        ( ?negatif, #exp, #pos )
        %1 %0 4ROLL NDUPN #1+ {}N
        ( #pos, {} )
        SWAPDUP #1= caseDROP
        ONE_DO (DO) ONE{}N LOOP
        ;
     SWAP NOT?SEMI 10GETLAM EVAL SWAP 16GETLAM EVAL
     ;
' :: ( LAM2 de VXXL meta -> liste ou objet )
     DUP#1=
     casedrop 1GETLAM
     DUP#1+ NDUP SYMBN 5GETLAM EVAL
     case :: OVER#2+UNROL NDROP ;
     ( teste l'oprateur x^ )
     ( o1, ..., on, #n, symb )
     DROP
     AEQ1stcase x^ 3GETLAM
     :: AEQ1stcase x+ 19GETLAM
        AEQ1stcase x* 17GETLAM
        AEQ1stcase x- 18GETLAM
        AEQ1stcase x/ 16GETLAM
        AEQ1stcase x= 8GETLAM
        ;
     ( o1, ..., on, #n, lam | o1,...,on,#n )
     DUPTYPEBINT?
     NOTcase 21GETLAM
     ( o1, ..., on, #n )
     :: AEQ1stcase x\v/ 9GETLAM
        AEQ1stcase xNEG 14GETLAM
        AEQ1stcase xSQ 6GETLAM
        AEQ1stcase xINV 7GETLAM
        complexflag TestUserFlag ?SEMI
        AEQ1stcase xRE 12GETLAM
        AEQ1stcase xIM 13GETLAM
        AEQ1stcase xCONJ 15GETLAM
        ;
     DUPTYPEBINT?
     NOTcase :: ( o1, ..., on, #n, prg )
                ROTDROP SWAP#1-SWAP OVER#2+UNROL
                ( oper, meta2, #0 )
                2GETEVAL EVAL
                ( oper unaire, liste1 )
                SWAP
                ;
     ( operateur non reconnu )
     SYMBN
     ( symb )
     ( teste si symb est dans la liste LAM22 )
     5GETLAM EVAL
     ( symb, false ou liste, true )
     ?SEMI
     vxxlflag ClrUserFlag
     4GETLAM
     ;
( LAM1 objet -> liste ou objet )
' :: CK&DISPATCH1
     real NOP
     list LISTSECOext
     symb :: INNERCOMP 2GETEVAL EVAL
             ;
     sym :: 5GETLAM EVAL ?SEMI
            4GETLAM EVAL
            ;
     seco :: 20GETLAM EVAL
             ;
     any NOP
     ;
' NULLLAM TWENTYTWO NDUPN DOBIND
( lvar, o )
1GETLAM NOSIMPEVALext EVAL ABND
( elimination des zeros et simplification eventuelle )
;
**************
NULLNAME VALext ( P, x -> P[x] ou P, { x1,..., xn } -> P[x1,...,xn] )
* appelle VALOBJext apres avoir devine la profondeur
::
( P, lvar )
internalflag ClrUserFlag
DUPTYPELIST? ?SKIP ONE{}N
( P, lvar )
DUPLENCOMP 3PICK DEPTHext
( P, lvar, #lvar, #profondeur de P )
2DUP#> IT 2DROP00
SWAP#-
( P , lvar, #- )
UNROT VALOBJext
;
******************
NULLNAME %PGCDext  ( r1, r2 -> pgcd )
* PGCD de 2 rels
( r, r' -> pgcd )
CODE
* entree non supportee mais stable
	GOSBVL	=POP2%SPLITAC
loop	GOSBVL	=STCD2	( sauvegarde de y )
	GOSBVL	=aMODF	( x= x mod y )
	GOSBVL	=RCCD2	( restaure y )
	GOSBVL	=XYEX	( donc y est le reste, x est le precedent )
	?D#0 W		( le reste est-il nul ? )
	GOYES	loop
	A=0	S	( pour prendre la valeur absolue )
	GOSBVL	=XYEX	( le pgcd est le dernier reste non nul: x, x -> y )
	LA(5)	=%1	( comparaison avec %1 )
	D1=A
	D1=D1+	5
	A=DAT1	W
	GOSBVL	=SPLITA	( x=%1, y=pgcd )
	P=	1
	GOSBVL	=TST15
	P=	0
	SETHEX
	GONC	%pgcdf
	A=C	W
	C=D	W
	B=C	W
%pgcdf	GOSBVL	=PACK 
	GOVLNG	=PUSH%LOOP
ENDCODE
( pgcd )
************************
NULLNAME TRLPGCDext
::
TRIMext LPGCDext
;
**************
NULLNAME LPGCDext ( liste -> liste, PGCD de la liste )
::
NOTLISTcase DUP
pgcdflag TestUserFlag NOTcase %1
' ::	( LAM10 C%PGCD, C%, C% -> C% )
	( a, b )
	[BEGIN]
		DUP C%0=
	NOT_WHILE
		::	DUPUNROT ' x/ EvalNoCK
			( b, q )
			DUP C%>% 
			( b, q, re, im )
			%0 RNDXY SWAP %0 RNDXY SWAP%>C%
			( b, q, int[q] )
			' x- EvalNoCK OVER 'x* EvalNoCK
			( b, r )
			C%>% %0 RNDXY SWAP %0 RNDXY SWAP%>C%
			( b, r )
			;
	[REPEAT]
	DROPDUP C%0= casedrop %1
	( pgcd )
	C%>%
	( re, im )
	DUP%0= casedrop %ABS
	SWAPDUP DUP%0= case2drop %ABS
	( im, re, re )
	%ABS SWAP %0< ROTDUP 
	( re, re<0, im, im )
	%ABS UNROT %0<
	( re, im, re<0?, im<0? )
	XOR IT SWAP %>C%
	;
' :: ( LAM 9 )
     QXNDext DROPROT QXNDext DROP 2GETEVAL EVAL 2GETEVAL EVAL 2GETEVAL EVAL
     ;
' :: ( LAM 8 TCOMPLPGCD )
     num0=case DROP >TCOMP
     1GETLAM EVAL SWAPDROP
     ;
( LAM 7 ) RESOROMP RMULText
( LAM 6 ) RESOROMP %PGCDext
' :: ( LAM5 %C%PGCDext %, C% -> pgcd )
     C%>% ROT 6GETLAM EVAL 6GETLAM EVAL
     ;
' ::	( LAM4 o2, o1 -> pgcd pour des non listes )
	2DROP %1
*	TWO{}N LVARext
*	( { o2 o1 }, lvar )
*	DUPLENCOMP
*	#0= case2drop %1
*	( { o2 o1 }, lvar )
*	VXXLext
*	( lvar, { l1 l2 } )
*	1GETLAM EVAL SWAPDROP
*	( lvar, pgcd )
*	ZERO UNROTSWAP VALOBJext
*	internalflag ClrUserFlag
*	( pgcd )
	;
' :: ( LAM3: list1, list2 -> pgcd )
     ( l1, l2 )
     DUPLENCOMP
     ( l1, l2, #l2 )
     3PICK LENCOMP
     ( l1, l2, #l2, #l1 )
     2DUP #MIN 5UNROLL
     ( #min, l1, l2, #l2, #l1 )
     #>ITE SWAPROT ROT
     ( l1, l2 avec l1 plus long que l2, #min )
     #1=case :: &COMP 1GETLAM EVAL SWAPDROP ONE{}N TRIMOBJext ;
     ( l1, l2 )
     1GETLAM EVAL DUP4UNROLL LOPDext
     ( pgcd[l2] / autres var, l1, l2' )
     SWAP 1GETLAM EVAL
     ( pgcd[l2] / autres var, l2', l1, pgcd[l1] )
     DUP4UNROLL LOPDext
     ( pgcd[l2], pgcd[l1], l2', l1' )
     2SWAP 2GETEVAL EVAL ONE{}N UNROTSWAP
     ( rmult,  pgcd[l1,l2] par rapport aux autres var, l1', l2' )
     BEGIN
          ( lpgcd, l1, l2 )
          DUPLENCOMP #1<>
     WHILE
          ( multiplication du numrateur par un inversible )
          DUPDUP CARCOMP DUPROT LENCOMP
          ( lpgcd, l1, l2, a2.1, a2.1, #l2 )
          5PICK LENCOMP SWAP#-
          ( lpgcd, l1, l2, a2.1, a2.1, #l1-#l2 )
          DUP#1= ITE_DROP :: 7GETLAM MPext ;
          ( lpgcd,  l1, l2, a2.1, coef )
          SWAP4PICK CARCOMP
          ( lpgcd,  l1, l2, coef, a2.1, a1.1 )
          OVER 2GETEVAL EVAL
          ( lpgcd,  l1, l2, coef, a2.1, pgcd )
          QUOText
          ( lpgcd,  l1, l2, coef, a2.1/pgcd )
          7GETLAM EVAL
          ( lpgcd,  l1, l2, coef )
          ROT LOPMext
          ( lpgcd,  l2, l1' )
          ( division de l1' par l2 )
          { %0 } SWAP3PICK DIV2LISText
          ( lpgcd,  l2, l1 div l2, l1 mod l2 )
          SWAPDROP
          ( lpgcd,  l2, l1 mod l2 )
          TRIMext 1GETLAM EVAL LOPDext
          ( lpgcd,  l1'=l2, l2'=l1 mod l2 )
     REPEAT
     ( lpgcd,  l1, l2 avec degre=0 )
     CARCOMP
     :: num0=case DROP
        2DROP %1
        ;
     7GETLAM EVAL
     ;
' :: ( LAM2: PGCDext obj1, obj2 -> pgcd )
     CK&DISPATCH1
     2REAL 6GETLAM
     2LIST 3GETLAM
     EIGHTY 8GETLAM
     list :: SWAP 8GETLAM ;
     seco 9GETLAM
     BINT80h 9GETLAM
     EIGHTEEN 5GETLAM
     THIRTYFOUR 10GETLAM
     THIRTYTHREE :: SWAP 5GETLAM ;
     any 4GETLAM
     ;
' :: ( LAM1: liste -> liste, lpgcd )
     DUPINCOMP
     DUP#0=csedrp %1
     DUP#1=
     ITE_DROP
        :: ( o1, ..., on, #n )
           MINUSONE
           ( o1, .., on, #n, length )
           SWAPDUP
           ZERO_DO (DO)
                   ( o1, ..., on, length, #n )
                   :: get1
                      num0=case DROP#1-
                      NOTLISTcase :: UNROT ExitAtLOOP ;
                      ( o2, ..., on, length, #n, o1 )
                      DUPLENCOMP 4ROLL
                      ( o2, ..., on, #n, o1, #l1, length )
                      2DUP #MIN 5UNROLL
                      #<case UNROT 4UNROLL
                      ;
                   LOOP
           ( o1, ..., on, length, #n )
           SWAPDROP
           DUP#0=csedrp %1
           DUP#1= caseDROP
           ONE_DO (DO)
                  DUP %1
                  :: EQUALNOTcase 2GETEVAL
                     ISTOP-INDEX #1+NDROP ExitAtLOOP %1
                     ;
                  EVAL
                  LOOP
           ;
     %0 EQUALcasedro %1
     ;
' NULLLAM TEN NDUPN DOBIND
1GETLAM EVAL
ABND
;
**************
NULLNAME SIMPext ( o1, o2 -> o1' o2' )
* Simplifie o1/o2 en o1'/o2' par division par le PGCD de o1 et o2
::
pgcdflag TestUserFlag NOT?SEMI
:: CK&DISPATCH1
   real :: DUP %0> ?SEMI %CHS SWAP RNEGext SWAP ;
   TWO :: DUP C%CONJ DUPUNROT 'x* EvalNoCK C>Re% UNROT RMULText SWAP ;
   any NOP
   ;
CK&DISPATCH1
2REAL :: 2DUP %PGCDext
         ( r1, r2, pgcd )
         ROTOVER %/ UNROT %/
         ( r1, r2 simplifies )
         ;
THIRTYTHREE :: 2DUPSWAP C%>% %PGCDext %PGCDext ROTOVER ' x/ EvalNoCK UNROT %/ ;
list SIMPLISText
EIGHTY SIMPLISText
seco :: QCONJext DUP QNORMext UNROT QMULText SWAP SIMPLISText ;
BINT80h SIMPLISText
* any :: symbolicflag TestUserFlag NOT?SEMI
*       NDXFext SIMP1ext FXNDext
*       ;
any NOP
;
**************
NULLNAME SIMP1ext ( symb -> symb simplifie )
::
internalflag TestUserFlag SWAP
LLVARDext VXXLext TRIMext SWAP
( retransforme en symbolique )
internalflag ClrUserFlag VALOBJext
SWAP NOT?SEMI internalflag SetUserFlag
;
***********************************************************
NULLNAME SIMPLISText ( list, list -> list ou %0, list )
* Simplification par division par le PGCD de deux polynome-listes
::
( o2, o1 )
TWO{}N TRLPGCDext LOPDext INNER#1= IT :: %0 SWAP ;
{ %1 } EQUALcasedro %1
;
**************
NULLNAME NUMEVALext
* evalue l'objet suivant du runstream en mode num
::
'R real_intflag TestUserFlag
2Ob>Seco real_intflag ClrUserFlag EVAL
NOT?SEMI real_intflag SetUserFlag
;
*****************************************************************
NULLNAME NOSIMPEVALext
* evalue l'objet suivant du runstream sans faire de simplifications
::
'R pgcdflag TestUserFlag 2Ob>Seco pgcdflag ClrUserFlag EVAL
NOT?SEMI pgcdflag SetUserFlag
;
*****************************************************************
NULLNAME SQFFext ( liste -> liste des facteurs )
::
( obj )
DUPNULL{}? ?SEMI
TRIMext
' ::	( LAM3: objet -> liste facteurs )
	NOTLISTcase 
	::	dREALNcase ONE{}N
		DUP %0< ITE { %-1 } NULL{}
		( reel, liste )
		SWAP %ABS DUP %FP %0= NOTcase >TCOMP
		%2
		BEGIN
			2DUP DUP %* %>=
		WHILE
			2DUP %MOD %0=
			NOTcase %1+
			ROTOVER >TCOMP UNROTSWAP OVER %/ SWAP
		REPEAT
		DROP >TCOMP
		;
	( p )
	LPGCDext %1 EQUALcasedro ( liste ) 2GETEVAL
	( p, lpgcd )
	DUP 3GETLAM EVAL
	( p, lpgcd, liste facteurs du lpgcd )
	LISTSECOext
	( affectue ONE{}N sur les facteurs du LPGCD )
	( p, lpgcd, liste facteurs de p )
	UNROT LOPDext
	( liste facteurs, p/lpgcd )
	2GETEVAL
	&COMP
	;
' :: ( LAM2 polynome-liste -> liste de facteurs )
     DUPDUP DERext TWO{}N LPGCDext SWAPDROP
     ( p, pgcd )
     DUPTYPELIST? NOTcasedrop ONE{}N
     ( p, pgcd[p,p'] )
     ( le terme de degre n est-il positif?)
     POSITIFext
     ( p, pgcd[p,p'], ?terme principal positif )
     ?SKIP RNEGext
     ( fin du test de positivite )
     DUPLENCOMP #1=
     ( p, pgcd[p,p'], degre=0? )
     casedrop ONE{}N
     DUP 2GETEVAL
     ( p, pgcd[p,p'], { facteurs du pgcd } )
     DUP COMPRIMext
     ( p, pgcd[p,p'], { facteurs du pgcd }, { facteurs comprimes du pgcd } )
     DUP PIext
     ( p, pgcd[p,p'], { fact_pgcd }, { fact_comp pgcd }, produit )
     4ROLL RMULText
     ( p, { fact_pgcd }, { fact_comp pgcd }, produit )
     4ROLLSWAP QUOText
     ( {fact_pgcd }, { fact_comprime pgcd }, quotient )
     DUPLENCOMP #1= IT CARCOMP
     %1 EQUALcasedro &COMP >TCOMP &COMP
     ;
' ONE{}N
' NULLLAM DUPDUP THREE DOBIND
( p )
3GETLAM EVAL TRIMext
ABND
;
**************
NULLNAME XSQRext ( objet -> racine carree de l'objet )
::
( obj -> sqrt[obj] )
TRIMOBJext
CK&DISPATCH1
real :: DUP %0< SWAP %ABS
        ( RACext  reel positif -> racine carree )
        :: real_intflag TestUserFlag NOTcase %SQRT
           DUPDUP %FLOOR %<> case %SQRT
           DUP %SQRT DUPDUP %FLOOR %=
           case SWAPDROP
           DROP SQFFext
           INNERCOMP %1 DUPDUP 4ROLL
           ZERO_DO (DO)
                   ( facteurs, liste_simples, liste_doubles, dernier facteur )
                   :: 4ROLL 2DUP
                      EQUALcasedrp :: %* %1 ;
                      SWAPDROP ROTOVER %* UNROT
                      ;
                   LOOP
           DROP 2DUP %/
           %1=case 2DROP
           ROTDROP internalflag TestUserFlag
           case :: %0 UNROT NDXQext ;
           ' x\v/ TWO SYMBN 'x* EvalNoCK
           ;
        ( fin de RACext )
        SWAP NOT?SEMI
        C% 0 1 RMULText
        ;
TWO :: DUP C>Re% DUPDUP %FLOOR %= NOTcasedrop C%SQRT
       OVER C%>%% DUP %%* SWAPDUP %%* %%+ %%>% XSQRext
       2DUP RADDext %2 RDIVext XSQRext UNROTSWAP
       RSUBext %2 RDIVext XSQRext ROT C>Im%
       %0< ITE C% 0 -1 C% 0 1 RMULText 
	num0=case DROP RADDext
       ;
seco :: DUP QNORMext 
        ( x, |x| )
        DUP XSQRext
        ( x, |x|, sqrt[|x|] )
	:: ( teste si |x| est un carre parfait )
           ( si sqrt|x| est un seco, alors il doit avoir le meme radical que x)
           CK&DISPATCH1
           real TRUE
           list TRUE
           seco :: OVER DUPTYPECOL? NOTcase DROPFALSE
                   FOUR NTHCOMPDROP OVER FOUR NTHCOMPDROP EQUAL
                   ;
	   any FALSE
           ;
        ROTDROP
        NOTcasedrop :: %0 %1 ROT NDXQext ; 
        ( x, sqrt[|x|] )
        SWAP QXNDext 
        ( sqrt, d, e, c )
        2SWAP
        ( e, c, sqrt, d )
        2DUPSWAP RSUBext %2 RDIVext XSQRext
        ( e, c, sqrt, d, a )
        :: ( le test n'est probablement le meilleur! )
           NOTSECOcase UNROT2DROP
           DROP RADDext %2 RDIVext XSQRext
           ;
        ( e, c, a )
        ROTSWAP DUP4UNROLL
        ( a, c, e, a )
        %2 RMULText RDIVext 
        ( a, c, b )
	SWAP
	( a, b, c )
        ( teste la positivit\'e pour des r\'eels ) 
	CK&DISPATCH1
	# 111 :: 2DUP 5PICK UNROT NDXQext 4UNROLL %SQRT %* %+ %0< IT RNEGext ;
        any NDXQext
        ;
list :: SQFFext
        NULL{} DUPROT
        ( liste_rac_s, liste_rac_d, liste_rac )
        [BEGIN]
             DUPNULL{}?
        NOT_WHILE
             :: ( liste_rac_s, liste_rac_d, liste_rac )
                NEXTPext
                ( liste_rac_s, liste_rac_d, reste_rac, racine_act )
                DUPLENCOMP TWO #/ ROT CARCOMP
                ( liste_rac_s, liste_rac_d, reste_rac, mult_s, mult_d, rac )
                DUPROT NDUPN {}N
                ( liste_rac_s, liste_rac_d, reste_rac, mult_s, rac, rac_d )
                5ROLL &COMP 4UNROLL
                ( liste_rac_s, liste_rac_d, reste_rac, mult_s, rac )
                SWAP #0=case DROP
                ( liste_rac_s, liste_rac_d, reste_rac, rac )
                4ROLLSWAP >HCOMP UNROT
                ;
        [REPEAT]
        ( liste_rac_s, liste_rac_d, null{} )
        DROP
        PIext
	( change le signe si n\'ecessaire ) 
	POSITIFext
	?SKIP RNEGext
	( fin du changement de signe )
        SWAP PIext
        ( sym=doubles, simples )
        ' :: ( obj -> symf = sqrt[objet] )
             TRIMOBJext NOTLISTcase XSQRext
             internalflag TestUserFlag
             case :: %0 %1 ROT NDXQext ;
             ' x\v/ TWO SYMBN
             ;
        UNROT LPGCDext DUPUNROT LOPDext
        ( prg, doubles, lpgcd[simples], simples/lpgcd[simples] )
        4PICK EVAL 4UNROLL ONE{}N ROT EVAL
        ( symf_simples, doubles, symf_lpgcd )
        ROT NOSIMPEVALext 
	::	RMULText SWAP
	        ( symf, doubles )
		RMULText
		;
        ;
sym ::  FXNDext 
        %1 EQUALcasedro x\v/
*        :: 
*	   internalflag TestUserFlag SWAP 
*           LLVARDext
*           ( flag17, #prof, symb, lvar )
*           VXXLext FXNDext DUPUNROT RMULText
*           ( #prof, lvar, deno, num*deno )
*           XSQRext SWAP NDXFext SWAP
*           VALOBJext 
*           SWAP ?SEMI internalflag ClrUserFlag
*           ;
        DUPUNROT RMULText XSQRext SWAP RDIVext
        ;
; 
**************
NULLNAME idnext ( cre la matrice identite)
* liste, arry, real ou # -> identite
::
DUPTYPELIST? IT LENCOMP
DUPTYPEBINT? IT UNCOERCE
' xIDN EvalNoCK AXLext
;
**************
* -*- mode:Mail -*-
*  TITLE ALGB Main module, 2eme partie
*  (c) 08/1996 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the GNU ALGB package.
*  This program can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.
	
NULLNAME ERR$EVALext ( seco  -> action )
* Pour un # effectue :: SWAP NOTcase :: AL#MSG #+ DO#EXIT ; DROP ;
* Donc on peut faire un test puis # ERR$EVALext, ou # dsigne
* le numro d'erreur a executer si le test est false,
* Pour un % effectue teste le flag utilisateur %, si le test
* est ngatif, depile l'objet situ au niveau 2, sinon revient
*  l'excution normale, ceci permet un programme du type
* { ONE TWO &$ DISPROW1 } %1 ERR$EVALext qui affiche la concatnation
* des messages 1 et 2 lorsque le flag 1 est arm.
* Sinon excute le programme, la liste ou le symbolique
* (EVAL de chaque objet) mais pour les entiers
* systmes non taggus, remplace ces entiers par #31400+# et
* excute JstGETTHEMESG (rappelle le message d'erreur # de ALGB)
* Exemple { ONE TWO &$ DISPROW1 } ERR$EVALext
* rappelle les messages 1,2 les concatne et affiche le rsultat
* en ligne 1.
* Attention, les NULLLAM sont decales de 2 et les compteurs de
* boucles de 1
::
DUPTYPEREAL? IT :: COERCE TestUserFlag ?SEMI DROP RDROP ;
DUP TYPEBINT? case :: SWAP caseDROP AL#MSG #+ DO#EXIT ;
DUP1LAMBIND LENCOMP
#1+_ONE_DO (DO)
           1GETLAM INDEX@ NTHCOMPDROP DUPTYPEBINT?
           ITE :: AL#MSG #+ JstGETTHEMSG ; EVAL
           LOOP
ABND
;
*************************************************************
NULLNAME User1IT
* Execute l'objet au niveau 1 a la maniere de ERR$EVALext si UF1 est arme.
::
displayflag UNCOERCE ERR$EVALext
;
*****************************************************************
NULLNAME MENUext ( $6, $5, $4, $3, $2, $1  -> affichage du menu )
* Affiche les 6 chanes dans les 6 cases du menu
::
ZERO SIX
ZERO_DO (DO)
        ( strings, # )
        TWENTYTWO OVER#+ UNROTSWAP Str>Menu
        LOOP
DROP
;
**********************
NULLNAME SYMCOMPext ( obj -> sym/lam/idnt )
::
idntlamcase NOP
DUPTYPESYMB? ?SEMI
ONE SYMBN
;
********************************************
NULLNAME XYext ( vecteur x et y -> x.y produit scalaire )
*
::
INNERCOMP #1+ROLL INNERCOMP
DUP#1= casedrop RMULText
RESOROMP RMULText
RESOROMP RADDext
' NULLLAM DUPTWO DOBIND
get1
( y1, ..., yn-1, x1, ..., xn, #n, yn )
ROTSWAP 2GETEVAL
( y1, ..., yn-1, x1, ..., xn-1, #n, xn*yn )
OVER
ONE_DO (DO)
     ROT 3PICK #2+PICK 2GETEVAL 1GETLAM EVAL
     LOOP
( y1, ..., yn-1, #n, X.Y )
OVER #1+UNROLL #1- NDROP
ABND
;
**************
NULLNAME MMULText ( matrice 1, matrice 2 -> produit des 2 matrices )
::
MMULTOBJext NOTcase x*ext
( A et B doivent etre des matrices listes valides )
( teste compatibilite #colonnes de A=#lignes de B )
DUPLENCOMP 3PICK CARCOMP LENCOMP #= NcaseSIZEERR
( A, B )
TRANext INNERCOMP get1
( vecteurs colonnes de B b1, ..., bc, #c, A )
INNERCOMP get1
( b1, ..., bc, a1, ..., an, #n, #c )
RESOROMP RMULText
RESOROMP RADDext
' NULLLAM DUPDUP THREE DOBIND
( b1, ..., bc, a1, ..., an, #n )
DUP #3+ THREE
           [DO]
           DUPDUP 3GETLAM #+ INDEX@ #+SWAP
           ( b1, ..., bc, a1, .., an, ..., ck-1, #n, #n+#c+k+3, #n)
           #2+PICK
           ( b1, ..., bc, a1, ..., an, ..., ck-1, )
           ( #n, #n+#c+3+k, ak )
           SWAP 3GETLAM
           ZERO_DO (DO)
                   ( b1, ..., bc, a1, ..., an, ..., ck-1, )
                   ( #n, ak, #n+#c+k+3 )
                   DUPPICK 3PICK
                   ( XYext )
                   :: INNERCOMP #1+ROLL INNERCOMP
                      DUP#1= casedrop 2GETEVAL
                      get1
                      ( y1, ..., yn-1, x1, ..., xn, #n, yn )
                      ROTSWAP 2GETEVAL
                      ( y1, ..., yn-1, x1, ..., xn-1, #n, xn*yn )
                      OVER
                      ONE_DO (DO)
                             ROT 3PICK #2+PICK 2GETEVAL 1GETLAM EVAL
                             LOOP
                      ( y1, ..., yn-1, #n, X.Y )
                      OVER #1+UNROLL #1- NDROP
                      ;
                   ( fin de XYext )
                   UNROT
                   LOOP
           ( b1, ..., bc, an, ..., a1, ..., ck-1, )
           ( #n, ak.b1, ..., ak.bc, ak, #2n+3+k )
           2DROP 3GETLAM {}N
           ( apres swap avant loop: b1, ..., bn, an, ..., a1, ...,ck , #n )
           SWAPLOOP
( b1, ..., bc, an, ..., a1, c1, ..., cn, #n )
DUP 3GETLAM #+ OVER#2+UNROL {}N
( b1, ..., bc, an, ..., a1, #n+#c, C )
OVER#2+UNROL NDROP
ABND
;
**************
NULLNAME MPMULText ( matrice, scalaire -> matrice )
::
SMULTOBJext NOTcase x*ext
RESOROMP RMULText TWO MLAM1LAM2ext
;
***************
NULLNAME TRANext ( matrice -> matrice transposee )
*
::
CK&DISPATCH1
list :: INNERCOMP OVER LENCOMP
        ( l1, l2, ..., lm, #m, #n )
        DUP
        #1+_ONE_DO (DO)
                INDEX@ 3PICKOVER #2+ #+
                ( l1, ..., lm, ..., tk-1 ,#m, #n, #1+k, #m+3+k )
                4PICK
                ZERO_DO (DO)
                        DUP#1+PICK 3PICK NTHCOMPDROP UNROT
                        LOOP
                SWAPDROP
                ( l1, ..., lm , .., tk-1, #m, #n, e1, ..., em, #m+3+k)
                INDEX@#- #2- {}N
                ( l1, ..., lm, #m, #n , tk )
                UNROT
                LOOP
        ( l1, ..., lm, t1, ..., tn, #m, #n)
        DUPUNROT
        ( l1, ..., lm, t1, ..., tn, #n, #m, #n)
        #2+UNROLL {}N
        ( l1, ..., lm, #m, At )
        OVER#2+UNROL NDROP
     ;
arry :: MATTRN xCONJ ;
;
**************
NULLNAME TRext ( matrice -> trace )
*
::
CK&DISPATCH1
list :: INNERCOMP reversym SWAP CARCOMP SWAP
        #1+DUP #2=
        caseDROP
        TWO DO
            SWAPINDEX@ NTHCOMPDROP RADDext
            LOOP
        ;
arry :: xARRY\-> INCOMPDROP DROP COERCEDUP
        #1=case DROP
        DUP1LAMBIND
        ( a11, ..., a1n, ..., an1, ..., ann, #n )
        ONE_DO (DO)
               1GETLAM DUPUNROT #2+UNROLL NDROP x+
               LOOP
        ABND
        ;
;
**************
NULLNAME MADJext ( matrice M -> M^-1, P[M], P[lambda] )
* Calcule le polynome caracteristique et le polynome matrice adjoint
* d'une matrice donnee.
::
CK&DISPATCH1
list ::	( matrice-liste )
	DTYPENDO? 
	NOTcase :: TRIMOBJext %1 OVER NDXFext NULL{} DUP ;
	( A )
	DUP idnext DUPUNROT DUPLENCOMP
	( I_n, A, I_n, #n )
	MADJOBJext
	( [-1]^n*det[A], inv[A]=1/det[A]* com[A], pmadj, pcar )
	;
arry :: ( array )
       DUP MDIMS NcaseSIZEERR
       OVER#= NcaseSIZEERR
       ( A, #n )
       SWAPDUP xIDN
       ( #n, A, I_n )
       DUPUNROT 4ROLL
       ( I_n, A, I_n, #n )
       MADJOBJext
       ( det[A], inv[A]=1/det[A]* com[A], pmadj, pcar )
       ;
any :: %1 OVER NDXFext NULL{} DUP ;
;
*******************
NULLNAME DTYPFMAT? ( objet -> objet TRUE ou -> objet FALSE )
* Teste si on a affaire  une matrice formelle
::
( obj -> matrice formelle, true ou obj, false )
NOTLISTcase FALSE
CKFPOLYext
DUP CARCOMP
NOTLISTcase DROPFALSE
OVERSWAP LENCOMP
( liste, liste, longueur de la 1re liste de liste )
' :: ( obj, longueur -> false si obj est une liste de longueur #= )
     SWAP DUPTYPELIST? NOTcase2drop TRUE
     LENCOMP #<>
     ;
POSCOMP
( liste, 1re occurence )
#0=
( liste, flag )
;
**************
NULLNAME DTYPENDO? ( objet -> objet TRUE ou FALSE )
* Teste si objet est la matrice d'un endomorphisme (matrice carre)
::
AXLext DTYPFMAT? NOTcaseFALSE
DUPLENCOMP OVER CARCOMP LENCOMP #=
;
**************
NULLNAME CK2FPOLY ( -> )
* teste les niveaux 1 et 2 de la pile, si une liste vide est rencontre
* sinon Bad Argument Value
::
CKFPOLYext SWAP CKFPOLYext SWAP
;
***************
NULLNAME MEVALext ( objet, l1, l2 -> obj' )
* obj, l1, l2 -> obj': remplace dans obj les elements de l1 par ceux de l2
::
DUPNULL{}? case2DROP
DUPTYPELIST? ?SKIP ONE{}N DUPLENCOMP
( obj, l1, l2, #l2 )
ROT DUPTYPELIST? ?SKIP ONE{}N DUP4UNROLL
( obj, l1, l2, #l2, l1 )
LENCOMP #= NcaseTYPEERR
( obj, l1=LAM5, l2=LAM4 )
' NULLLAM DUPTWO DOBIND QOBJext
::	( LAM2 obj -> obj' remplace les elements de LAM2/5 par ceux de LAM1/4)
	idntlamcase ::	4GETLAM 5GETLAM 3PICK EQUALPOSCOMP 
			( idnt, l2, pos )
			DUP#0=csedrp DROP
			( idnt, l2, pos )
			NTHCOMPDROP SWAPDROP
			;
	DUPTYPESYMB? NOT?SEMI
	DUPLENCOMP #1=case :: CARCOMP 2GETEVAL ;
	4GETLAM 5GETLAM 3PICK EQUALPOSCOMP
	( symb, l2, pos )
	DUP#0= NOTcase :: NTHCOMPDROP SWAPDROP ;
	2DROP ' xOBJ\-> EvalNoCK
	( objets, %nbre, oper )
	SWAP DUP%0= casedrop EvalNoCK
	COERCEDUP
	( objets, oper, #, # )
	ZERO_DO (DO)
		get1 2GETEVAL SYMCOMPext UNROT
		LOOP
	SWAP
	( objets, #nombre, oper )
	NOTSECOcase :: real SYMBN SWAP' xFCNAPPLY OVER #3+ SYMBN ;
	4GETLAM 5GETLAM 3PICK ' EQ POSCOMP
	( objets, #, oper, liste, #position )
	DUP#0= ITE 2DROP :: NTHCOMPDROP SWAPDROP ;
	( objets, #nombre, oper )
	SWAPDROPDUP
	( objets, oper, oper )
	EQ: x\.S NOTcase EVAL ( ou bien :: CK1TONOext EVAL ; )
	( inf, sup, func, t^2, int )
	OVER
	( inf, sup, func, t^2, int, t^2 )
	DUPTYPESYMB? NOTcasedrop EvalNoCK
	( inf, sup, func, t^2, int, t^2 )
	( ici il faudrait determiner la liste des idnt, eliminer )
	( celles qui sont dans la fonction et demander a l'utilisateur )
	( la nouvelle variable d'integration )
	' TYPEIDNT? Find1stTrue
	( inf, sup, func, t^2, int, [ t, true | false ] )
	NcaseTYPEERR
	ROTSWAP
	( inf, sup, func, int, t^2, t )
	OVER' ID  ' x= EvalNoCK SWAP 
	( inf, sup, func, int, t^2, 't^2=Bidon', t )
	ISOLext 
	( inf, sup, func, int, t^2, t, sqrt[Bidon] )
	' ID  2DUP
	( inf, sup, func, int, t^2, t, sqrt[Bidon], Bidon, sqrt[Bidon], Bidon )
	TEN ROLL MEVALext
	( sup, func, int, t^2, t, sqrt[Bidon], Bidon, newinf )
	8UNROLL 7ROLL MEVALext
	( newinf, func, int, t^2, t, newsup )
	5UNROLL DUP4UNROLL DERIVext
	( newinf, newsup, func, t, int, d[t^2]/dt )
	4ROLL x* UNROT EvalNoCK
	;
ABND
;
**************
NULLNAME CK1TONOext ( prg -> prg en remplacant CK1&Dispatch par CK&DISPATCH1 )
::
DUPTYPECOL?
NOT?SEMI
DUP CARCOMP
{ CK1&Dispatch CK2&Dispatch }
matchob?
( seco, [ first, FALSE ] | TRUE )
NOTcaseDROP
( o1, ..., on, #n )
CDRCOMP
' CK&DISPATCH1
>HCOMP
;
**************************************
NULLNAME HORNext ( polynome-liste P, r -> P[X] div [X-r], r, P[r] )
* Schma de Horner
::
CK&DISPATCH1
EIGHTY
:: OVER LENCOMP
   #1=case :: SWAPINCOMP DROPDUP %0 RMULText ONE{}N UNROT
              ;
   ( poly, r )
   SWAPINCOMP  ( stack= r, a0, .., an, #n+1)
   DUP #2+PICK
   ( r, a0, ..., an, #n+1, r )
   SWAP get1
   ( r, a1, ..., an, r, #n+1, a0)
   DUP4UNROLL
   ( r, a1, ...., an, b0, r, #n+1 , a0)
   3PICK
   mpmultflag UserITE
   :: RESOROMP MPMULText ;
   :: RESOROMP RMULText ;
   RESOROMP RADDext
   ' NULLLAM DUPTWO DOBIND
   2DROP DUP
   ONE_DO (DO)
          ( r, ak,...,an, b0, b1, ..., bk-1, r, #n+1 )
          get1 2OVER 2GETEVAL 1GETLAM EVAL UNROT
          LOOP
   ABND
   ( r, b0, b1, ..., bn, r, #n+1)
   UNROTDROP
   ( r, b0, ..., bn-1, #n+1, bn )
   OVER #1+UNROLL #1-{}N
   ( r, bn , {b0 ... bn-1 } )
   UNROT
   ( [lvar,] B, r, bn )
   ;
BINT80h :: SWAP QXNDext
	   ( r, l1, l2, q )
	   4UNROLLROT
	   ( q, l1, l2, r )
	   HORNext
	   ( q, l1, l2 div, r, l2[r] )
	   4ROLLROT
	   ( q, l2 div, l2[r], l1, r )
	   HORNext
	   ( q, l2 div, l2[r], l1 div, r, l1[r] )
	   ROT 5ROLL 6PICK NDXQext
	   ( q, l2[r], r, l1[r], div )
	   5UNROLL ROT 4ROLL NDXQext
	   ( div, r, quot )
	   ; 
any :: %0 UNROTSWAP ; 
;
**************
NULLNAME PTAYLext
( polynme-liste P, r -> dvpt Taylor de P en r )
( P r )
::
CK&DISPATCH1
EIGHTY :: OVER LENCOMP
          ( P r #n )
          DUP4UNROLL
          ZERO_DO (DO)
                  HORNext 4UNROLL
          LOOP
          2DROP reversym {}N
	  ;
BINT80h :: SWAP QXNDext
	    ( r, P1, P2, q )
	    4UNROLL SWAP3PICK PTAYLext
	    ( q, r, P2, P1t )
	    UNROT SWAP PTAYLext
	    ( q, P1t, P2t )
	    ROT NDXQext
	    ;
any DROP
;
**************
NULLNAME SIMPEVALext
* evalue l'objet suivant du runstream en simplifiant
::
'R pgcdflag TestUserFlag 2Ob>Seco pgcdflag SetUserFlag EVAL
?SEMI pgcdflag ClrUserFlag
;
******************************
NULLNAME LISTSECOext ( list, seco ou symb -> list, seco, symb )
* Excute 1GETLAM sur les composants de list ou de seco
::
DUPINCOMP
( liste, o1, ..., on, #n )
DUP#0=csDROP
DUP#0_DO
       ( liste, o1, ..., on, #n )
       DUP #1+ROLL 1GETLAM EVAL
       SWAPLOOP
get1 DTYPELIST? casedrop {}N
TYPESYMB? case SYMBN ::N
;
***************
NULLNAME TOLISText ( o1, ..., on, #n -> lvar, l-o1,..., l-on )
* conversion au format interne de plusieurs objets selon flag 17
::
internalflag TestUserFlag case :: NULL{} SWAP#1+ UNROLL ;
P{}N DUP LVARext SWAPDROP
VXXLext INCOMPDROP
;
*********************
NULLNAME LISTOPext ( -> liste d'oprateurs )
{ x+ x* x- x/ x^ x= xNEG xSQ xINV xi }
************************
NULLNAME ADDMATOBJext ( array,obj -> array,obj | obj, array -> obj, array )
* Prepare une operation entre un array et un objet
::
DTYPEARRY?
' :: ( obj, array -> array, obj )
     DUP xIDN ROT
     ( array, idn, objet )
     CK&DISPATCH1
     real x*
     TWO x*
     any :: ROT AXLext UNROT
            ( array, idn, objet )
            DTYPFMAT? case SWAPDROP
            SWAP AXLext SWAP 'x* LOPAext
            ;
     ;
( obj, array , TRUE, prg | array, obj, FALSE, prg )
SWAP case :: EVAL SWAP ;
ROTSWAP EVAL
;
***********************
NULLNAME RADDext ( o2, o1 -> somme )
::
COLA
CODE
debut	GOSUB	raddrcl
* stk2 et stk1 reels?
	LC(5)	=DOREAL
	?C#A	A
	GOYES	not%%
	A=R0
	?C#A	A
	GOYES	not%%
	LA(5)	=%+
	PC=(A)
* on teste si stk2 ou stk1 est un seco (irrquad) ou un symb (fraction)
not%%	A=R0
	LC(5)	=DOCOL
	?C=A	A
	GOYES	seco
	A=R1	A
	?C#A	A
	GOYES	notseco
seco	A=PC
	LC(5)	(qadd!)-(*)
	GOTO	fin
notseco	LC(5)	=DOSYMB
	?C=A	A
	GOYES	symb
	A=R0	A
	?C#A	A
	GOYES	tlist
symb	A=PC
	LC(5)	(rradd!)-(*)
	GOTO	fin
tlist	LC(5)	=DOLIST
	?C#A	A	
	GOYES	obj
obj10	A=PC
	LC(5)	(robjlist!)-(*)
	GOTO	fin
obj	A=R1
	?C#A	A
	GOYES	objobj
obj11	A=PC
	LC(5)	(rlistobj!)-(*)
	GOTO	fin
objobj	A=PC
	LC(5)	(raddext!)-(*)
fin	A=A+C	A
	PC=(A)
raddrcl	C=DAT1	A	( adresse sommet de la pile )
	CD1EX		( mise dans D1 )
	A=DAT1	A	( A= prologue du 1er objet )
	R0=A	A	( RO sauvegarde prologue stk1 )
	D1=C		( restaure D1 )
	D1=D1+	5
	A=DAT1	A	( meme chose mais avec niveau 2 )
	D1=A
	A=DAT1	A
	R1=A	A	( R1=prol. stk2 )
	D1=C
	RTN
	ENDCODE
LABEL raddext!
::	CK&DISPATCH1
	SIXTYEIGHT x+ ( matrice + matrice )
	# 3F3F %%+
	# 1F1F #+
	SIXTYFOUR :: ADDMATOBJext RADDext ;
	FOUR :: ADDMATOBJext RADDext ;
	any :: ' x+ EvalNoCK ;
	;
LABEL qadd!
QADDext
LABEL rradd!
::
NOSIMPEVALext RASOPext
	CODE
	GOSUB	raddrcl
	A=R0
	LC(5)	=DOLIST
	?A=C	A
	GOYES	radd10
	A=R1
	?A=C	A
	GOYES	radd11
	LC(5)	=DOSYMB
	?A=C	A
	GOYES	radd12
	A=R0
	?A=C	A
	GOYES	radd12
	GOTO	debut
radd10	GOTO	obj10
radd11	GOTO	obj11
radd12	GOTO	objobj
	ENDCODE
SWAP SIMPNDXFext
;
LABEL rlistobj!
::	( list, o -> )
	SWAPINCOMP DUP#0=csDROP
	get1 ROTSWAP 
	CODE 
	GOTO	debut
	ENDCODE
	SWAP {}N
	;
LABEL robjlist!
::	( list A, list B -> listA peut etre un objet non liste )
*	SWAP DUPTYPELIST? ITE INNERCOMP ONE	
	CODE
	C=DAT1	A
	D1=D1+	5
	A=DAT1	A
	DAT1=C	A
	D1=D1-	5
	DAT1=A	A
	CD1EX
	D1=A
	A=DAT1	A
	CD1EX
	LC(5)	=DOLIST
	?C=A	A
	GOYES	inner
	LA(5)	=ONE
	PC=(A)
inner	LA(5)	=INNERCOMP
	PC=(A)
	ENDCODE
	DUP#0= caseDROP
	get1
	( a1, ..., aa, #a, B )
	INNERCOMP
	DUP#0= casedrop {}N
	get1
	( a1, ..., aa, b1,...,bb, #b, #a )
	SWAP2DUP #MIN TOTEMPOB
	( a1, ..., aa, b1, ..., bb, #a, #b, #min+2 )
LABEL rbegloop!
	( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b+2, index )
	CODE
* test si index=FFFFF
	C=D1	
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	GONC	sloop
	GOTO	finloop
sloop	DAT1=A	A
	D1=C
* rappeler ak sur la pile
	D=D-1	A	
	GONC	dsuite
dgarb	GOSBVL	=GARBAGE1
dsuite	C=D1
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A= #b )
	A=A+CON	A,3
	C=C+A	A	( C=pointeur sommet de pile )
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	( C pointe sur ak )
	CD1EX
	C=DAT1	A
	CD1EX
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	CD1EX
	D1=D1-	5
	DAT1=C	A	
* rappeler bk sur la pile ( 5ROLL )
	RSTK=C
	D1=D1+	5
	C=DAT1	15
	D1=D1+	15
	A=DAT1	A
	D1=D1-	10
	DAT1=C	15
	D1=D1-	5
	C=RSTK
	DAT1=C	A
	D1=D1-	5
	DAT1=A	A
	GOTO	debut
finloop	D1=C
	A=D0
	LC(5)	(rendloop!)-(rmilieu!)
	A=A+C	A
	D0=A
	GOVLNG	=DropLoop
	ENDCODE
	( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b, index, ak+bk )
LABEL rmilieu!
	CODE
	C=DAT1	A	( C contient un pointeur sur ck )
	R0=C
	C=D1		( C sauvegarde la valeur de D1 )
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A= #b )
	A=A+CON	A,3
	C=C+A	A	( C=pointeur sommet de pile )
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	( C pointe sur l'objet #b+2 )
	D1=C
	C=R0
	DAT1=C	A	( ecrit la valeur du sommet de pile en stk#b+2 )
	C=D1
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	D1=C
* on modifie l'adresse du prochain objet RPL a executer
	A=D0
	LC(5)	(rendloop!)-(rbegloop!)
	A=A-C	A
	D0=A
	GOVLNG	=DropLoop
	ENDCODE
	( a1, ..., ak-1, ck, ck+1, ..., cb, b1, ..., bk, #a, #b )
LABEL rendloop!
	( si #a<=#b: c[b-a]+1, ..., cb, b1,..., b[b-a], #a, #b )
	( si #a>=#b: a1,..., a[a-b], c[a-b]+1,...,ca, #a, #b )
	( si #a<#b, il faut continuer avec %0 comme oprande )
	2DUP#< NOTcasedrop ( #b=#a ) {}N
	( #a < #b : c[b-a]+1,...,cb, b1,...,b[b-a],#a, #b )
	OVER#-
	( c[b-a]+1,...,cb, b1,...,b[b-a], #a, #b-a )
	DUPUNROT #2+UNROLL
	( c[b-a]+1,...,cb, #a, b1,...,b[b-a], #b-a )
	psh get1 #+
	{}N
	;
;
**************
NULLNAME RSUBext ( o2, o1 -> difference )
::
COLA
CODE
sdebut	GOSUB	rsubrcl
* stk2 et stk1 reels?
	LC(5)	=DOREAL
	?C#A	A
	GOYES	snot%%
	A=R0
	?C#A	A
	GOYES	snot%%
	LA(5)	=%-
	PC=(A)
* on teste si stk2 ou stk1 est un seco (irrquad) ou un symb (fraction)
snot%%	A=R0
	LC(5)	=DOCOL
	?C=A	A
	GOYES	sseco
	A=R1	A
	?C#A	A
	GOYES	snotseco
sseco	A=PC
	LC(5)	(qsub!)-(*)
	GOTO	sfin
snotseco	LC(5)	=DOSYMB
	?C=A	A
	GOYES	ssymb
	A=R0	A
	?C#A	A
	GOYES	stlist
ssymb	A=PC
	LC(5)	(rrsub!)-(*)
	GOTO	sfin
stlist	LC(5)	=DOLIST
	?C#A	A	
	GOYES	sobj
sobj10	A=PC
	LC(5)	(sobjlist!)-(*)
	GOTO	sfin
sobj	A=R1
	?C#A	A
	GOYES	sobjobj
sobj11	A=PC
	LC(5)	(slistobj!)-(*)
	GOTO	sfin
sobjobj	A=PC
	LC(5)	(rsubext!)-(*)
sfin	A=A+C	A
	PC=(A)
rsubrcl	C=DAT1	A	( adresse sommet de la pile )
	CD1EX		( mise dans D1 )
	A=DAT1	A	( A= prologue du 1er objet )
	R0=A	A	( RO sauvegarde prologue stk1 )
	D1=C		( restaure D1 )
	D1=D1+	5
	A=DAT1	A	( meme chose mais avec niveau 2 )
	D1=A
	A=DAT1	A
	R1=A	A	( R1=prol. stk2 )
	D1=C
	RTN
	ENDCODE
LABEL rsubext!
::	CK&DISPATCH1
	SIXTYEIGHT x- ( matrice + matrice )
	# 3F3F %%-
	# 1F1F #-
	SIXTYFOUR :: ADDMATOBJext RSUBext ;
	FOUR :: ADDMATOBJext RSUBext ;
	any :: ' x- EvalNoCK ;
	;
LABEL qsub!
QSUBext
LABEL rrsub!
::
NOSIMPEVALext RASOPext
	CODE
	GOSUB	rsubrcl
	A=R0
	LC(5)	=DOLIST
	?A=C	A
	GOYES	rsub10
	A=R1
	?A=C	A
	GOYES	rsub11
	LC(5)	=DOSYMB
	?A=C	A
	GOYES	rsub12
	A=R0
	?A=C	A
	GOYES	rsub12
	GOTO	sdebut
rsub10	GOTO	sobj10
rsub11	GOTO	sobj11
rsub12	GOTO	sobjobj
	ENDCODE
SWAP SIMPNDXFext
;

LABEL slistobj!
::	( list, o -> )
	SWAPINCOMP DUP#0=csDROP
	get1 ROTSWAP 
	CODE 
	GOTO	sdebut
	ENDCODE
	SWAP {}N
	;
LABEL sobjlist!
::	( list A, list B -> listA peut etre un objet non liste )
	CODE
	C=DAT1	A
	D1=D1+	5
	A=DAT1	A
	DAT1=C	A
	D1=D1-	5
	DAT1=A	A
	CD1EX
	D1=A
	A=DAT1	A
	CD1EX
	LC(5)	=DOLIST
	?C=A	A
	GOYES	sinner
	LA(5)	=ONE
	PC=(A)
sinner	LA(5)	=INNERCOMP
	PC=(A)
	ENDCODE
	DUP#0= caseDROP
	get1
	( a1, ..., aa, #a, B )
	INNERCOMP
	DUP#0= casedrop {}N
	get1
	( a1, ..., aa, b1,...,bb, #b, #a )
	SWAP2DUP #MIN TOTEMPOB
	( a1, ..., aa, b1, ..., bb, #a, #b, #min+2 )
LABEL sbegloop!
	( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b+2, index )
	CODE
* test si index=FFFFF
	C=D1	
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	GONC	ssloop
	GOTO	sfinloop
ssloop	DAT1=A	A
	D1=C
* rappeler ak sur la pile
	D=D-1	A	
	GONC	sdsuite
sdgarb	GOSBVL	=GARBAGE1
sdsuite	C=D1
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A= #b )
	A=A+CON	A,3
	C=C+A	A	( C=pointeur sommet de pile )
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	( C pointe sur ak )
	CD1EX
	C=DAT1	A
	CD1EX
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	CD1EX
	D1=D1-	5
	DAT1=C	A	
* rappeler bk sur la pile ( 5ROLL )
	RSTK=C
	D1=D1+	5
	C=DAT1	15
	D1=D1+	15
	A=DAT1	A
	D1=D1-	10
	DAT1=C	15
	D1=D1-	5
	C=RSTK
	DAT1=C	A
	D1=D1-	5
	DAT1=A	A
	GOTO	sdebut
sfinloop	D1=C
	A=D0
	LC(5)	(sendloop!)-(smilieu!)
	A=A+C	A
	D0=A
	GOVLNG	=DropLoop
	ENDCODE
	( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b, index, ak+bk )
LABEL smilieu!
	CODE
	C=DAT1	A	( C contient un pointeur sur ck )
	R0=C
	C=D1		( C sauvegarde la valeur de D1 )
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A= #b )
	A=A+CON	A,3
	C=C+A	A	( C=pointeur sommet de pile )
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	
	C=C+A	A	( C pointe sur l'objet #b+2 )
	D1=C
	C=R0
	DAT1=C	A	( ecrit la valeur du sommet de pile en stk#b+2 )
	C=D1
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	C=C-A	A
	D1=C
* on modifie l'adresse du prochain objet RPL a executer
	A=D0
	LC(5)	(sendloop!)-(sbegloop!)
	A=A-C	A
	D0=A
	GOVLNG	=DropLoop
	ENDCODE
	( a1, ..., ak-1, ck, ck+1, ..., cb, b1, ..., bk, #a, #b )
LABEL sendloop!
	( si #a<=#b: c[b-a]+1, ..., cb, b1,..., b[b-a], #a, #b+1 )
	( si #a>=#b: a1,..., a[a-b], c[a-b]+1,...,ca, #a, #b+1 )
	( si #a<#b, il faut continuer avec %0 comme oprande )
	2DUP#< NOTcasedrop ( #b=#a ) {}N
	( #a < #b : c[b-a]+1,...,ca, b1,...,b[b-a],#a, #b )
	DUPROT #-
	( c[b-a]+1,...,ca, b1,...,b[b-a], #b, #b-a )
	ZERO_DO (DO)
		( ck+1,...,ca, b1,...,bk, #b )
		%0 ROT 
	CODE
	GOTO	sdebut
	ENDCODE
		OVER #1+UNROLL
		LOOP
	{}N
	;
;
**************
NULLNAME RMULText
::
::	( LAM1 ) RESOROMP RADDext
		1LAMBIND 'REVAL RDROP ABND
	;
CODE
mdebut	GOSUB	mget
* on teste 2 reels -> %*
	LC(5)	=DOREAL
	?C#A	A
	GOYES	mobj0
	A=R0	A
	?C#A	A
	GOYES	mobj0
	LA(5)	=%*
	PC=(A)
* y-a-t-il un symbolique?
mobj0	A=R0
	LC(5)	=DOCOL
	?C#A	A
	GOYES	mobjb
mobja	A=PC
	LC(5)	(qmult!)-(*)
	GOTO	mfin
mobjb	A=R1
	?C=A	A
	GOYES	mobja
* y-a-t-il un seco
	A=R0
	LC(5)	=DOSYMB
	?C#A	A
	GOYES	mobjd
mobjc	A=PC
	LC(5)	(rrmult!)-(*)
	GOTO mfin
mobjd	A=R1
	?C=A	A
	GOYES	mobjc
* y-a-t-il une liste?
mobje	A=R0
	LC(5)	=DOLIST
	?C#A	A
	GOYES	mobj2
mobj1	A=PC
	LC(5)	(mobjlist!)-(*)
	GOTO	mfin
mobj2	A=R1	( stk1 n'est pas une liste )
	?C=A	A
	GOYES	mobj1
mobjobj	A=PC
	LC(5)	(rmultext!)-(*)
mfin	A=A+C	A
	PC=(A)
mget	C=DAT1	A	
	CD1EX		
	A=DAT1	A	
	R0=A	A	( R0= prologue du 1er objet )
	D1=C
	D1=D1+	5
	A=DAT1	A
	D1=A
	A=DAT1	A
	D1=C
	R1=A	A	( A=R1= prologue stk2 )
	CD1EX
	RTN
	ENDCODE
LABEL rrmult!
::	num1=case DROP
	FXNDext ROT FXNDext
	( n2, d2, n1, d1 )
	ROT 
	CODE
	GOTO	mdebut
	ENDCODE
	( n2, n1, d1*d2 )
	UNROTSWAP
	( d1*d2, n1, n2 )
	CODE
	GOSUB	mget
	LC(5)	=DOLIST
	?A=C	A
	GOYES	mobj11
	A=R0
	?A=C	A
	GOYES	mobj11
	LC(5)	=DOSYMB
	?A=C	A
	GOYES	mobj12
	A=R1
	?A=C	A
	GOYES	mobj12
	GOTO	mdebut
mobj11	GOTO	mobj1
mobj12	GOTO	mobjobj
	ENDCODE
	SWAP SIMPNDXFext
	;
LABEL qmult!
QMULText
LABEL rmultext!
::	CK&DISPATCH1
	# 3F3F %%*
	# 1F1F #*
	# 1F1 :: COERCE #* ;
	# 3F1 :: %>%% %%* ;
	any x*ext
	;
LABEL lmeta!
::	SWAP 
	CODE
	goto inner#1
	ENDCODE
	get1
	CODE
tomlistobj	A=PC
	LC(5)	(mlistobj!)-(*)
	GOTO	mfin	
	ENDCODE
	;
LABEL mlistobj!
::	( b1, ..., bb, #b, OBJ -> list d'[OBJ* element] )
	num0=case :: ONE{}N OVER#2+UNROL NDROP ;
	%1 EQUALcasedro {}N
	OVER
	TOTEMPOB
	LABEL ml!
	( bb-1, ..., b0, #b, a, #j )
	CODE
* decremente j et decremente la memoire libre de 2* 5 quartets
	D=D-CON	A,2
	GONC	ml1
	GOSBVL	=GARBAGE1
ml1	C=D1
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A
	D1=C
	GONC	ml2
* fin de boucle
	D=D+CON	A,4
	D1=D1+	10
	A=D0
	LC(5)	(mlf!)-(mlm!)
	A=A+C	A
	D0=A
	LA(5)	={}N		
	PC=(A)
* rappel a et bj sur la pile
ml2	A=A+CON	A,3
	C=A	A
	GOSUB	=cpick
	D1=D1+	10
	A=DAT1	A
	D1=D1-	15
	DAT1=A	A
	GOTO	mdebut
	ENDCODE
	( bb-1, ..., b0, #b, a, #j, bj*a )
	LABEL mlm!
	CODE
* replace bj*a a la place de bj
	C=D1
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	A=A+CON	A,4	( A=j+3 )
	D1=C
	C=C+A	A
	A=A+A	A
	A=A+A	A
	C=C+A	A
	A=DAT1	A
	CD1EX
	DAT1=A	A
	CD1EX
* ajuste D0 pour retour en debut de boucle
	A=D0
	LC(5)	(mlf!)-(ml!)
	A=A-C	A
	D0=A
	GOVLNG	=DropLoop	
	ENDCODE
	LABEL mlf!
	;
LABEL mobjlist!
::	( list, list ou objet, list ou list, objet -> list*list )
	CODE
inner#1	A=DAT1	A
	CD1EX
	D1=A
	A=DAT1	A
	CD1EX
	LC(5)	=DOLIST
	?C#A	A
	GOYES	push#1
	LA(5)	=INNERCOMP
	PC=(A)
push#1	LA(5)	=ONE
	PC=(A)
	ENDCODE
	( l2, m1 )
	DUP#0= caseDROP
	DUP#1= casedrop 
	CODE
	A=PC
	LC(5)	(lmeta!)-(*)
	GOTO	mfin	
	ENDCODE
	get1
	CODE
	goto inner#1
	ENDCODE
	( m1, m2 )
	DUP#0= casedrop {}N
	( a_a-1, ..., a0, #a, b_b-1, ..., b0, #b )
	DUP#1= casedrop
	CODE
	GOTO	tomlistobj	
	ENDCODE
	get1
	( a_a-1, ..., a0, b_b-1, ..., b0, #b, #a )
* creation des ck
	2DUP#+ %0 SWAP#1- NDUPN
	( a_a-1, ..., a0, b_b-1, ..., b0, #b, #a, %0, ..., %0, #a+b-1 )
	get1 #1- TOTEMPOB
	( a_a-1, ..., a0, b_b-1, ..., b0, #b, %0, ..., %0, #a+b-1, #i )
	SWAP#1+ get1
	( a_a-1, ..., a0, b_b-1, ..., b0, %0, ..., %0, #i, #a+b, #b )
	ROTOVER TOTEMPOB
* calcul des indices: i varie de a-1 a 0 et j de b-1 a 0
* i est l'indice de boucle exterieur, j interieur
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j )
	LABEL mloopb!
	CODE
* decremente j
	C=D1
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A
	D1=C
	GONC	loop2
* decremente i
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A
	D1=C
	GONC	loop1
	GOTO	loopf
* j=b-1
loop1	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	R0=A	A
	D1=C
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=R0
	DAT1=A	A
	D1=C
* rappel de c_i+j sur la pile
* ( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j )
loop2	D=D-CON	A,3
	GONC	loop5
	GOSBVL	=GARBAGE1	
loop5	RSTK=C
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	C=DAT1	A
	D1=C
	D1=D1+	5
	C=DAT1	A
	A=A+C	A   ( A=i+j )
	C=RSTK
	D1=C
	C=A	A
	C=C+CON	A,4
	GOSUB	cpick
* ( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j, c )
* rappel de a_i
	C=D1
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R0=A	A	( R0=i )
	D1=C
	D1=D1+	15
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	C=R0	A
	A=A+C	A
	R0=A	A	( R0=i+b )
	C=D1
	D1=D1+	15
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	C=R0	A
	C=A+C	A	( A=i+a+b+b )
	C=C+CON	A,4
	GOSUB	cpick
* ( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j, c, a )
* rappel de b_i
	C=D1
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R0=A	A	( R0=j )
	D1=C
	D1=D1+	15
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	C=R0	A
	C=A+C	A	( C=j+a+b )
	C=C+CON	A,5
	GOSUB	cpick
*	GOVLNG	=Loop
	GOTO	mdebut
* routine C pick
cpick	A=C	A
	A=A+A	A
	A=A+A	A
	A=A+C	A	( A= 5*[i+j+4] )
	C=D1
	C=C+A	A
	CD1EX		( D1 pointe sur c_i+j, C sur le sommet de la pile )
	A=DAT1	A	( A= @c_i+j )
	CD1EX
	D1=D1-	5
	DAT1=A	A	( copie de c_i+j au sommet de la pile )
	RTN
* ajuste D0 pour sauter la boucle
loopf	A=D0
	LC(5)	(mloopf!)-(mloopm!)
	A=A+C	A
	D0=A
	GOVLNG	=Loop
	ENDCODE
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j, c, a*b )
	LABEL mloopm!
	1GETLAM EVAL
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j, c+a*b )
	CODE
* on recopie c a sa place
	C=D1
	RSTK=C
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	D1=D1+	5
	C=DAT1	A
	D1=C
	D1=D1+	5
	C=DAT1	A
	A=A+C	A
	A=A+CON	A,5
	C=A	A
	C=C+C	A
	C=C+C	A
	A=A+C	A
	C=RSTK	( A=i+j )
	D1=C
	C=C+A	A
	A=DAT1	A
	CD1EX
	DAT1=A	A
	CD1EX
* modifie D0 pour revenir en debut de boucle
	A=D0
	LC(5)	(mloopf!)-(mloopb!)
	A=A-C	A
	D0=A
	GOVLNG	=DropLoop
	ENDCODE
	LABEL mloopf!
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #b, #i, #j )
	3DROP
	DUP#1-
	( a_a-1, ..., a0, b_b-1, ..., b0, c_a+b-2, ..., c0, #a+b, #a+b-1 )
	DUPUNROT #2+UNROLL {}N
	( a_a-1, ..., a0, b_b-1, ..., b0, #a+b, C )
	OVER#2+UNROL NDROP
	;
;
****************
NULLNAME RDIVext
::
COLA
CODE
rdivrcl	C=DAT1	A	
	LA(5)	=%0
	?A#C	A
	GOYES	non%0
	A=PC
	LC(5)	(ndxf!)-(*)
	GOTO	rdivfin	
non%0	CD1EX		
	A=DAT1	A	
	R0=A	A	( R0= prologue du 1er objet )
	D1=C
	D1=D1+	5
	A=DAT1	A
	D1=A
	A=DAT1	A
	D1=C
	R1=A	A	( A=R1= prologue stk2 )
	CD1EX
	LC(5)	=DOREAL
	?A#C	A
	GOYES	vrdiv1
	A=R0	A
	?A=C	A
	GOYES	rdiv%
	GOTO	rdiv2
vrdiv1	GOTO	rdiv1
* real/real
rdiv%	LC(5)	=sFLUSH
	D=D-C	A
	GONC	rok1
	GOSBVL	=GARBAGE1
rok1	C=DAT1	10
	D1=D1-	10
	DAT1=C	10
	GOSBVL	=POP2%SPLITAC
	GOSBVL	=aMODF	( x=x mod y )
	SETHEX
	P=	0
	?B#0	W
	GOYES	rdiv0
	GOSBVL	=GETPTR
	LA(5)	=%/
	PC=(A)
rdiv0	GOSBVL	=GETPTR
	GOTO	rsimpndxf
rdiv1	LC(5)	=DOCMP
	?A#C	A
	GOYES	rdivobj
* complex/real?
	A=R0	A
	LC(5)	=DOREAL
	?A#C	A
	GOYES	rdiv2
rsimpndxf	A=PC
	LC(5)	(r15simp!)-(*)
rdivfin	A=A+C	A
	PC=(A)
* complex|real/complex ?
rdiv2	LC(5)	=DOCMP
	?A=C	A
	GOYES	rsimpndxf
* real|complex / real|complex exclus, test irrquad
rdivobj	A=R0	A
	LC(5)	=DOCOL
	?A#C	A
	GOYES	rdiv4
rdiv3	A=PC
	LC(5)	(qdivext!)-(*)
	GOTO	rdivfin
rdiv4	A=R1	A
	?A=C	A
	GOYES	rdiv3
* test symbolique
	LC(5)	=DOSYMB
	?A#C	A
	GOYES	rdiv6
rdiv5	A=PC
	LC(5)	(rrdivext!)-(*)
	GOTO	rdivfin
rdiv6	A=R0	A
	?A=C	A
	GOYES	rdiv5
* test liste
	LC(5)	=DOLIST
	?A#C	A
	GOYES	rdiv7
	A=PC
	LC(5)	(robjl!)-(*)
	GOTO	rdivfin
rdiv7	A=R1	A
	?A#C	A
	GOYES	rdiv8
	A=PC
	LC(5)	(rlobj!)-(*)
	GOTO	rdivfin
rdiv8	LC(5)	=DOEREL
	?A#C	A
	GOYES	rdiv9
	A=R0	A
	?A#C	A
	GOYES	rdiv9
	LA(5)	=%%/
	PC=(A)
rdiv9	A=R0	A
	LC(5)	=DOBINT
	?A#C	A
	GOYES	rdiv10
	A=R1	A
	?A#C	A
	GOYES	rdiv10
	A=PC
	LC(5)	(rbint!)-(*)
	GOTO	rdivfin
rdiv10	A=PC
	LC(5)	(EvalNoCKx/!)-(*)
	GOTO	rdivfin
ENDCODE
LABEL robjl!
::	pgcdflag TestUserFlag NOTcase NDXFext
	( n, d )
        2DUP DIVext TRIMOBJext
	( n, d, q, r )
	%0 EQUALcasedro UNROT2DROP
	( n, d, q, r )
        2DROP 
	LABEL rlobj!
	SIMPNDXFext
        ;
LABEL qdivext!
QDIVext
LABEL rbint!
::	2DUP #/ #0=case UNROT2DROP
	DROP 
	LABEL ndxf!
	::	' x/ THREE SYMBN
		;
	;
LABEL rrdivext!
::	FXNDext ROT FXNDext
	( n2, d2, n1, d1 )
	4UNROLL SWAP
	( d1, n2, n1, d2 )
	RMULText UNROTSWAP RMULText
	LABEL r15simp!
	::	num0=case NDXFext
		real_intflag TestUserFlag
		case SIMPNDXFext
		LABEL EvalNoCKx/! 
		:: ' x/ EvalNoCK ;
		;
	;

;

*******************
NULLNAME MPext ( objet, #entier, prg de multiplication -> objet^#entier )
::
( obj1, obj2, prg de multiplication -> obj1^obj2 )
UNROT DUPTYPEREAL?
IT :: ( real -> #ip ou real )
      DUPDUP %FLOOR %= NOT?SEMI
      ( prg, objet, reel entier )
      DUP %0< NOTcase COERCE
      ( prg, objet, entier negatif )
      %ABSCOERCE SWAP MADJext
      ( prg, #puissance, determinant, inverse, polynome adjoint, poly car )
      2DROP SWAP num0case SETIVLERR
      DROPSWAP
      ( prg, #puissance, inverse )
      ;
( prg, obj1, obj2 ou #entier )
DUPTYPEHSTR? IT HXS>#
DUPTYPEBINT? NOTcase :: ROTDROP x^ ;
( prg, objet, #entier )
DUP#0=csedrp :: :: CK&DISPATCH1
                   list :: DTYPENDO? ITE %1 { %1 } ;
                   THIRTYONE ONE
                   SIXTYTHREE %%1
                   any %1
                   ;
                UNROT2DROP
                ;
ONESWAP
( prg, A, #1, # )
( par convention #1 comme rsultat signifie l'identit )
( ce qui vite de faire la premire multiplication identit* A^[2^k] )
[BEGIN]
( prg, A^[2^k], result , # )
DUP#0<>WHILE
:: TWO #/
   ( prg, A^[2^k], result, remainder, quotient )
   4UNROLL
   #0=?SKIP :: ( prg, quotient, A^[2^k], result )
               ONE EQUALcasedro DUP ( id*A^[2^k] )
               OVER5PICK EVAL
               ;
   ( prg, quotient, A^[2^k], result )
   3PICK #0=case ROT
   ( inutile de calculer A^[2^k+1] si le quotient est nul )
   SWAPDUP 5PICK EVAL SWAPROT
   ;
[REPEAT]
DROP UNROT2DROP
;
*******************
NULLNAME RASOPext ( routine commune a RADDext et RSUBext )
::
FXNDext ROT FXNDext ( n2, d2, n1, d1 )
3PICKOVER RMULText 5UNROLL
( d1*d2, n1,d1,n2,d2 )
SWAPROT RMULText
( d1*d2, n1, d2, n2*d1 )
UNROT RMULText
;
**************************************************************
NULLNAME x*ext ( execute x* )
::
'x* EvalNoCK
;
*************************************
NULLNAME RREext ( f -> re[f] )
::
CK&DISPATCH1
real NOP
TWO :: C>Re% %0 %+ ; 
( le %0 %+ est destine a renvoyer des pointeurs en ROM si possible )
list QOBJREext
seco :: QXNDext UNROT RREext UNROT RREext UNROT NDXQext ;
symb :: FXNDext %1 EQUALcasedro :: ' xRE EvalNoCK ;
        2DUP QOBJREext SWAP QOBJREext RMULText UNROT
        (  aa' z z')
        DUP4UNROLL QOBJIMext SWAP QOBJIMext RMULText RADDext
        ( z' aa'+bb')
        RREIMext
        ;
any :: ' xRE EvalNoCK ;
;
***********************************************************
NULLNAME RIMext ( f -> im[f] )
::
CK&DISPATCH1
TWO :: C>Im% %0 %+ ;
( le %0 %+ est destine a renvoyer des pointeurs en ROM si possible )
list QOBJIMext
seco :: QXNDext UNROT RIMext UNROT RIMext UNROT NDXQext ;
symb :: FXNDext %1 EQUALcasedro :: ' xIM EvalNoCK ;
        2DUP QOBJREext SWAP QOBJIMext RMULText UNROT
        DUP4UNROLL QOBJIMext SWAP QOBJREext RMULText RSUBext
        RREIMext
        ;
any :: ' xIM EvalNoCK ;
;
***********************************************************
NULLNAME RCONJext ( f -> conj[f] )
::
CK&DISPATCH1
list QOBJCONJext
seco :: QXNDext UNROT RCONJext UNROT RCONJext UNROT NDXQext ;
symb :: FXNDext :: DUPTYPESYMB? NOTcase QOBJCONJext ' xCONJ EvalNoCK ;
        SWAP :: DUPTYPESYMB? NOTcase QOBJCONJext ' xCONJ EvalNoCK ;
        SWAP NDXFext
        ;
any :: ' xCONJ EvalNoCK ;
;
***********************************************************
NULLNAME RNEGext ( f -> -f )
::
CK&DISPATCH1
list QOBJNEGext
seco :: QXNDext UNROT RNEGext UNROT RNEGext UNROT NDXQext ;
symb :: FXNDext 
        SWAP :: DUPTYPESYMB? NOTcase QOBJNEGext ' xNEG EvalNoCK ;
        SWAP NDXFext
        ;
any :: ' xNEG EvalNoCK ;
;
************************************************************
NULLNAME SETQext
::
real_intflag SetUserFlag symbolicflag SetUserFlag pgcdflag SetUserFlag
;
*************************************************************
NULLNAME MMULTOBJext ( o1, o2 -> o1, o2, flag )
* Prpare un produit matrice/matrice ou matrice/vecteur symbolique
* flag = true pour resulat symbolique
* flag = false pour numerique
::
CK&DISPATCH1
2LIST TRUE
FIVEFOUR :: AXLext TRUE ;
SIXTYEIGHT FALSE
FOURFIVE :: SWAP AXLext SWAPTRUE ;
;
***********************************
NULLNAME SIMPNDXFext
::
SIMPext NDXFext
;
**********************************
NULLNAME SYMBNext
( meta -> sym ou obj )
::
DUP#1= NOTcase SYMBN
DROP DUPTYPECOL? case EVAL
;
*******************************
NULLNAME MLAM1LAM2ext ( obj1, obj2, prg1, #lev -> matrice )
* effectue obj2 prg1 sur tous les elements de obj1
* situee au niveau 1, le schema de pile de prg1
* doit etre obj obj2 -> obj
* par exemple obj2=%5 et prg1=RMULText
* ou obj2='X' et prg1=VALext
* #lev designe le niveau de recursion
::
( obj1, obj2, op, # -> obj1 op obj2: recursion liste au niveau # )
( LAM4: obj2 )
( LAM3: operateur )
( LAM2: # )
' ::	( LAM1: obj -> obj )
	2GETLAM DUP#0=csedrp :: 4GETLAM 3GETLAM EVAL ;
	#1- 2PUTLAM 
	INNERDUP #1-SWAP
	ZERO_DO
		get1 1GETLAM EVAL
	SWAPLOOP
	#1+ {}N
	2GETLAM #1+ 2PUTLAM
	;
4NULLLAM{} BIND
1GETLAM EVAL
ABND
;
****************************
NULLNAME INSERT{}N ( liste, obj, # pos -> liste )
* insre objet dans la liste  la position # pos,
* # pos doit etre infrieur au nombre d'lments de liste
* si # pos est nul, l'lment est rajout en FIN de liste
::
DUP#0=csedrp >TCOMP
ROT INNERCOMP get1
( obj, v1,...,vk,#k, #pos )
SWAP#1+
( obj, v1,...,vk, #pos, #k+1 )
DUPROT #-SWAP
( obj, v1,..., vk, #k+1-pos, #k+1 )
get1
( v1,...,vk, #k+1-pos, #k+1, obj )
ROT #2+UNROLL {}N
;
***************************
NULLNAME REDLIBext ( # -> 3 ou 6 programmes )
*( rappelle sur la pile selon la valeur de stk1 )
*( #0: PIVOT, EXL, ELEM )
*( #1: PIVOT, EXL, ELEM, XRED, LDISP )
*( Bind 6     5    4     3      2     1 )
::

' ( PIVOT: matrice, #l, #c -> )
( *** BUG: si le seul coeff non nul est dans la derni\`ere colonne )
:: 3PICK 3PICK MINUSONE SUBCOMP
( matrice, #l, #c, reste matrice apr\`es suppression lignes 1 \`a l-1)
DUPNULL{}? case2drop DROPZERO
TRANext OVER MINUSONE SUBCOMP
( matrice, #l, #c, reste matr transpose )
( on recherche  partir de la ligne 1 et de la colonne 1 )
( le pivot partiel: de plus grand module )
( par ordre croissant: )
(  %0: -8 et -9, algbrique->-2, idnt->-1, scalaire -> >=0 )
( matrice, #l, #c, matr transposee )
DUPLENCOMP OVER CARCOMP LENCOMP ZEROZERO
( mat, #l,#c, reste, #lr, #cr,  #la=ligne actuelle, #cp=colonne du pivot )
BEGIN
     ( mat, #l,#c, reste, #lr, #cr,  #la, #cp )
     ( incrmente ligne actuelle )
     SWAP4PICK OVER#>
     ( mat, #l,#c, reste, #lr, #cr,  #cp, #la, ?#lr>#la )
     ( encore dans la matrice ? )
     SWAP#1+ UNROTDUP
     ( mat, #l,#c, reste, #lr, #cr,  #la+1, #cp, ?#la<#lr, ?#la<#lr )
     3PICK #0= AND
     ( si #cp=#0, on n'a pas trouv de pivot )
     ( mat, #l,#c, reste, #lr, #cr,  #la+1, #cp, ?#la<#lr, #la<#lr and #cp=0 )
WHILE
     DROP ( supprime flag de fin de matrice )
     ( mat, #l, #c, reste, #lr, #cr, #la, #cp )
     5PICK 3PICK NTHCOMPDROP
     ( mat, #l, #c, reste, #lr, #cr, #la, #cp, ligne actuelle de reste )
     INNERCOMP get1
     ( mat, #l, #c, reste, #lr, #cr, #la, e1,...,ek, #k, #cp )
     %-8 ROT
     #1+_ONE_DO  (DO)
             ( ..., e1, ..., ek, #cp, pivot prcdent )
             ROT
             ( pivot -> rel =valeur_15_off, valeur_15_on )
             ( pivot -> non rel=objet, # )
             :: CK&DISPATCH1
                real :: %ABS %2
                        ;
                TWO :: C%ABS %1
                       ;
                list :: TRIMOBJext dLISTcase DUPLENCOMP
                        ' xABS EvalNoCK dREALNcase ZERO %.5
                        ;
                symb DUPLENCOMP
                seco DUPLENCOMP
                sym ONE
                ;
             SWAP DUPTYPEREAL?
             :: NOTcasedrop :: UNCOERCE %180 %/ %CHS ;
                DUP%0= case2drop %-9
                real_intflag UserITE DROP SWAPDROP
                ;
             ( ..., e1, ..., ek-1, #cp, pivot prcdent, pivot actuel )
             2DUP %>
             ( teste si le pivot est plus grand que le prcdent )
             ( si c'est le cas modifie #cp )
             ITE_DROP
                 :: UNROT2DROP INDEX@ SWAP ;
             LOOP
     DROP ( efface la valeur absolue du pivot )
REPEAT
( mat, #l, #c, reste, #lr, #cr, #la, #cp, flag fin de matrice )
NOTcase :: 7DROP ZERO ;
( si #la<>2 changer #c, car #la est la ligne actuelle de la transpose )
( mat, #l, #c, reste, #lr, #cr, #la, #cp )
OVER #2<>
IT :: ( mat, #l, #c, reste, #lr, #cr, #la, #cp )
      6ROLL 3PICK#+ #2- 6UNROLL
      ;
( mat, #l, #c, reste, #lr, #cr, #la, #cp )
SWAPDROP ROTDROP ROTDROP
( mat, #l, #c, #cr, #cp )
( si #cp<>#cr code #2 et change lignes )
2DUP#= case2drop ONE
( mat, #l, #c, #cr, #cp )
#- 3PICK
( mat, #l, #c, #cr-#cp, #l )
DUPROT #+ TWO
( mat, #l, #c, #l_echange_1, #l_echange_2, #2 )
;

' ( EXL )
:: ( matr, #lex1, #lex2, lpivot -> matr, lpivot )
   ( change les lignes #lex1 et #lex2, rajoute -1  la liste lpivot )
   4UNROLL
   2DUP#= case2drop SWAP
   ( lpivot, matr, #lex1, #lex2 )
   3PICKOVER NTHCOMPDROP UNROT
   4PICK 3PICK NTHCOMPDROP SWAP 5ROLL
   PUTLIST PUTLIST
   ( lpivot, matr )
   SWAP %-1 >TCOMP
   ( matr, lpivot )
   ;

' ( ELEM stk= mat, list, prg, lpivot -> mat, lpivot )
  ( excute le programme d'affichage prg qui doit afficher de L3  L7 )
  ( la matrice mat puis effectue la manipulation lmentaire list sur mat )
  ( rajoute pivot simplifi avec -coef  la liste des pivots lpivot )
  ( schma de pile de prg: mat -> mat )
::
4UNROLL UNROT
( lpivot, prg, mat, list )
INCOMPDROP SWAP
( lpivot, prg, mat, coef1, #l1, #l2, coef2 )
( on doit faire #l1 de mat= coef1*#l1 + coef2*#l2 )
num0case :: 4DROP ( lpivot, prg, matr ) SWAPDROPSWAP ;
4ROLL
( lpivot, prg, mat, #l1, #l2, coef2, coef1 )
FXNDext ROT FXNDext
( lpivot, prg, mat, #l1, #l2, num1, deno1, num2, deno2 )
UNROT RMULText UNROT RMULText SIMPext
( lpivot, prg, mat, #l1, #l2, -coef=deno1*num2, pivot=num1*deno2 )
7ROLL OVER >TCOMP 7UNROLL
( lpivot, prg, mat, #l1, #l2, -coef=deno1*num2, pivot=num1*deno2 )
4UNROLL SWAP FOUR {}N
( lpivot, prg, mat, list simplifie )
( si flag 1 arm, affiche la manipulation lmentaire )
ONE
UserITE :: BlankDA12
           2DUP DUP INCOMPDROP TWO
           ZERO_DO (DO)
                   #>$ CHR_L >H$ SWAP DO>STR CHR_* >T$
                   CHR_Space >H$ SWAP&$ UNROT
                   LOOP
           ROT " +" &$SWAP &$SWAP TWO NTHCOMPDROP #>$
           CHR_L >H$ "= " &$SWAP &$ DISPROW1
           ( lpivot, prg, mat, list, mat )
           ;
        OVER
( lpivot, prg, mat, list, mat )
TEN PICK 5ROLL EVAL DROP  ( excute prg )
( lpivot, mat, list )
INCOMPDROP
( lpivot, mat, coef1, #l1, coef2, #l2 )
5PICK SWAP NTHCOMPDROP LOPMext
( lpivot, mat, coef1, #l1, coef2*l2 )
UNROT 4PICKOVER NTHCOMPDROP ROTSWAP LOPMext
( lpivot, mat, coef2*l2, #l1, coef1*l1 )
ROT RADDext
( lpivot, mat, #l1, coef1*l1+coef2*l2 )
* simplification ventuelle de la ligne: 25.5 octets
DUPLENCOMP SWAP TRIMext SWAP#1- LRDMext
* fin de simplification
SWAPROT PUTLIST
( lpivot, mat )
SWAP
( mat, lpivot )
;

4ROLL #0=?SEMI

' ( XRED )
( matr-liste, #1 ou 5PICK -> m-originale, part, matr-liste r\'eduite )
::
SWAPDUP CARCOMP LENCOMP
( prg#l1, matr, #colonnes )
TWO #<case :: SWAPDROP NULL{} SWAP ;
( 6     5     4  3 2   1 )
"HALT" NULL$ DUP 2DUP "CONT" MENUext
( prg#l1, matr )
ONE TOLISText
( prg#l1, lvar, matr )
ROTSWAP
( mo, [lvar], prg#l1, matr-liste )
NULL{} SWAP ONEONE
( mo, [lvar], prg#l1, cas part, matr, #1, #1 )
BEGIN
     6GETLAM EVAL ( -> pivot )
     DUP#0<>
WHILE
     #1=?SKIP :: { BlankDA12 "L" DUP3PICK UNCOERCE DO>STR &$ SWAP4PICK
                   UNCOERCE DO>STR &$ "<-->" &$ SWAP &$ DISPROW1
                   }
                 User1IT
                 ( mo, [lvar], prg#l1, lpivot, matr, #lp, #cp, #lex1, #lex2 )
                 5ROLL DUP NINE PICK 
                 ( mo, [lvar], prg#l1, lpivot, #lp, #cp, #lex1, #lex2, matr, matr, lvar )
		 2GETEVAL DROP ( appel de ldisp )
                 ( mo, [lvar], prg#l1, lpivot, #lp, #cp, #lex1, #lex2, matr )
                 UNROT 6ROLL
                 ( mo, [lvar], prg#l1, #lp, #cp, matr, #lex1, #lex2, lpivot )
                 5GETLAM EVAL ( exl ) 4UNROLL
                 ( mo, [lvar], prg#l1, lpivot, #lp, #cp, matr )
                 UNROT
                 ;
     ( mo, [lvar], prg#l1, lpivot, matr, #lp, #cp )
     ROTDUP 4PICK NTHCOMPDROP
     ( mo, [lvar], prg#l1, lpivot, #lp, #cp, matr, ligne#lp )
     3PICK NTHCOMPDROP RNEGext SWAP
     ( mo, [lvar], prg#l1, lpivot, #lp, #cp, pivot, matr )
     DUPLENCOMP #1+ 7PICK EVAL
     ( mo, [lvar], prg#l1, lpivot, #lp, #cp, pivot, matr, #lignes+1, #l1 )
     DO
       ( mo, [lvar], prg#l1, lpivot, #lp, #cp, pivot, matr )
       INDEX@ 5PICK
       #=?SKIP :: DUPINDEX@ NTHCOMPDROP
                  ( mo, [lvar], prg#l1, lpivot, #lp, #cp, pivot, matr,lignetr)
                  4PICK NTHCOMPDROP
                  ( mo, [lvar], prg#l1, lpivot, #lp, #cp, pivot, matr, coef )
                  3PICK INDEX@ ROT 7PICK
                  ( ..., lpivot, #lp, #cp, pivot, matr, pivot, #ltraite, -coef, #lp )
                  FOUR {}N 2GETLAM 7ROLL
                  ( ..., #lp, #cp, pivot, matr, list, prg ldisp, lpivot )
                  4GETLAM EVAL ( elem )
                  ( ..., #lp, #cp, pivot, matr, lpivot )
                  5UNROLL
                  ( ..., lpivot, #lp, #cp, pivot, matr )
                  ;
     LOOP
     ( mo, [lvar], prg#l1, lpivot, #lp, #cp, pivot, matr )
     SWAPDROP ROT#1+ ROT#1+
     ( mo, [lvar], prg#l1, lpivot, matr, #lp+1, #cp+1 )
REPEAT
DROPROT DROP
{ BlankDA12 TWENTYTHREE DISPROW1 } User1IT
3PICK
2GETEVAL
DispMenu.1
( mo, [lvar], lpivot, matr )
{ ONE TWO }
FROMLISText
( mo, matr, lpivot )
SWAP #31418 JstGETTHEMSG >TAG SWAP
( mo, lpivot, matr )
;

' ( LDISP matr, lvar -> matr, teste l'appui de la touche F )
  ( arrte l'excution si on a appuy sur F )
:: displayflag UserITE
     ::	TWO UNROT VAL2ext
	NOTLISTcase SETTYPEERR 
		DUPINCOMP reversym
		ZERO_DO (DO)
			( matr, ln, ..., lk )
		  DO>STR CDR$ INDEX@ DUP#1+ #:>$
                  ( matr, ln, ..., lk+1, "lk", #k, "k: " )
                  CHR_L >H$
                  ( matr, ln, ..., lk+1, "lk", #k, "Lk: " )
                  ROT &$
                  ( matr, ln, ..., lk+1, #k, "lk" )
                  DUPLEN$ #2- ONESWAP SUB$
                  ( matr, ln, ..., lk+1, #k, "lk" sans le " }" final )
                  SWAP FIVE #/
                  #0=?SKIP :: DUP#0= NOT?SEMI
                              WaitForKey 2DROP
                              ;
                  #3+ DISPN
                  LOOP
          % 300 % .2 DOBEEP WaitForKey DROPTRUE
          ;
   :: DROP GETTOUCH ; 
NOT?SEMI
kcMenuKey6 #= NOT?SEMI
DispMenu.1
#31419 JstGETTHEMSG DISPROW1 SetDA1Temp
xHALT
"HALT" NULL$ DUP 2DUP "CONT" MENUext
;

;
*************************
NULLNAME QOBJIMext
::
QOBJSECext RIMext
;
**************************
NULLNAME QOBJREext
::
QOBJSECext RREext
;
**************************
NULLNAME MADJOBJext
::
( I_n, A, I_n, #n )
NULL{} 5UNROLL { %1 } 5UNROLL
( {}, { %1 }, I_n, A, I_n, #n )
#1+_ONE_DO (DO)
           ( [lvar],  pmadj , pcar , I_n, A, A_k-1 )
           ( complete pmadj )
           5ROLL OVER AXLext
           >TCOMP 5UNROLL
           ( [lvar], pmadj , pcar , I_n, A, A_k-1 )
           OVER MMULText DUP TRext TRIMOBJext
           ( [lvar], pmadj , pcar , I_n, A, A_k-1*A, tr[A_k-1*A] )
           INDEX@ UNCOERCE %CHS RESOROMP RDIVext LOPAext
           ( [lvar], pmadj , pcar , I_n, A, A_k-1*A, -tr[A_k-1*A]/k )
           ( complete pcar )
           5ROLL OVER
           >TCOMP 5UNROLL
           ( [lvar], pmadj , pcar , I_n, A, A_k-1*A, -tr[A_k-1*A]/k )
           4PICKSWAP RESOROMP RMULText LOPAext RADDext
           ( [lvar], pmadj , pcar , I_n, A, A_k=A_k-1*A-tr[A_k-1*A]/k*I_n )
           LOOP
( [lvar], pmadj , pcar , I_n, A, A_n=det[A]*I_n )
3DROP 2DUPSWAP
( [lvar], pmadj, pcar, pcar, pmadj )
DUPLENCOMP NTHCOMPDROP AXLext
( [lvar], pmadj, pcar, pcar, com[A] )
SWAP DUPLENCOMP NTHCOMPDROP
( [lvar], pmadj, pcar, com[A], -det[A] )
DUP 5UNROLL RNEGext
( [lvar], [-1]^n*det[A], pmadj, pcar, com[A], det[A] )
RESOROMP RDIVext TWO MLAM1LAM2ext UNROT
( [-1]^n*det[A], inv[A]=1/det[A]* com[A], pmadj, pcar )
;
**************************
NULLNAME VALOBJext ( #depth, poly-liste, { x1 ... xn } -> poly-symb )
::
SLVARext VAL2ext
;
******************************
NULLNAME LVARDext 
( objet, liste d'operateurs -> profondeur, objet, liste des idnt globaux )
::
( obj, liste d'operateurs )
ZERO ( LAM10 profondeur actuelle )
NULL{} ( LAM9 liste des identificateurs )
'  :: ( LAM8: objet -> objet, type;  )
      CK&DISPATCH1
      idnt idnt
      SEVEN SEVEN
      symb symb
      any TEN
      ;
'  :: ( LAM 7 objet1, { type length crc } -> flag )
      ( teste si type[objet1]>type, si =, teste )
      ( la longueur de objet1 / length )
      ( si encore =, fait un tri par CRC )
      ( obj1, { type2, str2, len2 } )
      INCOMPDROP 4ROLL
      8GETLAM EVAL
      ( type2, str2, len2, obj1, type1 )
      5ROLL
      ( str2, len2, objet1, type1, type2 )
      2DUP#=
      case2drop :: ( str2, len2, obj1 )
                   DO>STR DUPLEN$
                   ( str2, len2, str1, len1 )
                   ROTSWAP
                   ( str2, str1, len2, len1 )
                   2DUP#= case2drop :: ' x<? EvalNoCK %0= ;
                   #> UNROT2DROP
                   ;
      #< 4UNROLL3DROP
      ;
( obj, listop, lam10, lam9, lam8, lam7 )
6PICK TWO DEPTHOBJext ( LAM6 )
' :: ( LAM5 sym -> sym )
     DUP
     :: ( mise  jour de lvar )
        ( sym -> liste )
        9GETLAM  DUPNULL{}?
        casedrop ONE{}N
        ( sym, liste )
        DUPUNROT
        ( liste, sym, liste )
        matchob? ?SEMI
        ( list, sym )
        2DUP 8GETLAM EVAL
        ( list, sym, list, sym, #type )
        SWAP DO>STR DUPLEN$ THREE{}N
        ( list, objet, list, { #type str len$ } )
        7GETLAM POSCOMP INSERT{}N
        ;
     9PUTLAM
     ( sym )
     DUP DEPTHext 10GETLAM #+
     6GETLAM
     2DUP#< NOTcase2DROP
     SWAP#-
     ( sym, # )
     ZERO_DO (DO) ONE{}N LOOP
     ;
' :: ( LAM4 seco d'un mta -> seco )
     DUP CARCOMP EQ: x<<
     case :: INNERCOMP #5= NcaseTYPEERR
             4UNROLL THREE
             ZERO_DO (DO)
                     1GETLAM EVAL EVAL UNROT
                     LOOP
             4ROLL FIVE ::N
             ;
     11GETLAM OVER' EQ POSCOMP
     ( seco, # )
     ( test de ^ )
     DUP FIVE
     #=ITE :: DROP 3PICK dREALNcase DROPFALSE DUP %FLOOR %= ;
           #0<>
     ?SEMI
     ( ok+1,..., on, comp, o1, ..., ok-1, #n, seco )
     SWAP ISTOP-INDEX
     ( ..., o1,...,ok, #n, #k )
     DUPUNROT #2+UNROLL
     ( ..., #n, o1, ..., ok, #k )
     pZpargSWAPUn
     ( ok+1,..., on, comp, #n, o1, ..., oj, #j, oj+1,...,ok, #k-j )
     DUP#1+ NDUP SYMBN OVER#2+UNROL
     ( ok+1,..., on, comp, #n, o1, ..., oj, #j, seco[idnt]", oj+1,...,ok, #k-j )
     #1-SWAP EQ: x\v/ ITE :: SYMBN 2GETEVAL DROP ; NDROP
     ( #n, o1,...,oj, #j, "seco[idnt]" )
     SWAPDUP #1+ ISTOPSTO ZERO INDEXSTO
     ( #n, o1,...,oj, "seco[idnt]", #j )
     #2+ROLL
     ( o1, ..., oj, seco[idnt], #n )
     OVER LENCOMP #-+1 SWAP
     ( ok+1, ..., on, comp, o1, ..., oj, #n-[k-j], seco[idnt] )
     5GETLAM EVAL
     ;
' :: ( LAM3 liste -> liste )
     10GETLAM #1+ 10PUTLAM
     2GETEVAL
     10GETLAM #1- 10PUTLAM
     ;
' :: ( LAM2 comp -> comp )
     DUPINCOMP
     ( comp, o1, ..., on, #n )
     DUP#0=csDROP
     DUP#0_DO (DO)
             ( comp, o1, ..., on, #n )
             SWAP 1GETLAM EVAL EVAL OVER#2+UNROL
             LOOP
     SWAP TYPELIST? case {}N SYMBN
     ;
' :: ( LAM1 : obj -> obj )
     CK&DISPATCH1
     symb 2GETLAM
     list 3GETLAM
     seco 4GETLAM
     sym 5GETLAM
     any NOP
     ;
' NULLLAM ELEVEN NDUPN DOBIND
1GETLAM EVAL EVAL
9GETLAM 6GETLAM ABND
UNROT
;
******************
NULLNAME DEPTHOBJext
::
( objet, # -> profondeur )
{ 2GETEVAL DROP }
SWAP NTHCOMPDROP
( LAM9 symb -> )
' ::	( LAM8 arry -> )
	MDIMS SWAPDROP ITE DROPONE ZERO #1+
	3GETLAM #+ 4GETLAM #MAX 4PUTLAM
	;
' :: ( LAM7 seco -> )
     DUP CARCOMP EQ: x<< NOTcaseDROP
     INNERCOMP #5= NcaseTYPEERR
     DROP 4ROLLDROP THREE
     ZERO_DO (DO) 1GETLAM EVAL EVAL LOOP
     ;
' DROP ( LAM6 )
' :: ( LAM5 liste -> )
     3GETLAM #1+DUP 3PUTLAM
     4GETLAM #MAX 4PUTLAM
     2GETEVAL
     3GETLAM #1- 3PUTLAM
     ;
ZEROZERO ( LAM4 et 3 profondeur maxi et actuelle )
' :: ( LAM2 comp -> )
     INNERCOMP DUP#0=csDROP
     ZERO_DO (DO)
             1GETLAM EVAL EVAL
             LOOP
     ;
' ::	( LAM1 : obj -> )
	CK&DISPATCH1
	symb 9GETLAM
	list 5GETLAM
	seco 7GETLAM
	arry 8GETLAM
	any 6GETLAM
	;
' NULLLAM NINE NDUPN DOBIND
1GETLAM EVAL EVAL
4GETLAM ABND
( fin de DEPTH )
;
******************************
NULLNAME FACTOBJext ( lfact, #, flag  -> lfact )
* Factorise les facteurs de lfact, en dtermine les racines ou
* les facteurs pour le numrateur/le dnominateur ou les 2
::
( lfact, #, flag )
' NULLLAM DUPTWO DOBIND
( lfact )
NULL{} SWAPINCOMP get1 SWAP #2/
ZERO_DO	(DO)
	( o1, m1, ..., on, mn, liste )
	::	2GETLAM DUP#0=csedrp TRUE
		3PICKSWAP #1=case %0> %0<
		;
	( o1, m1, ..., on, mn, liste, flag )
	::	NOTcase UNROT2DROP
		ROT EVIDENText
		( o1, m1, ..., mn-1, mn, liste, lrn, pn )
		1GETLAM ITE :: ONE{}N SWAP RACTOFACext ; SOLVext
		&COMP 
		( o1, m1, ..., mn-1, mn, liste, lrn )
		DUPNULL{}? casedrop SWAPDROP
		ROT num0=case 2DROP
		( o1, m1, ..., mn-1, liste, lrn, mn )
		SWAPINCOMP get1 SWAP DUPDUP #1+SWAP
		( o1, m1, ..., mn-1,liste, r1,...,rk,m,#k,#k+1,#k )
		ZERO_DO (DO)
			( r1,...,rk, m, #k, #j+1 )
			3PICK
			( r1,...,rk, m, #k, #j+1, m )
			OVER#2+UNROL
			( r1, m, r2, .., rk, m, #k, #j+1 )
			#1-
			LOOP
		DROPSWAPDROP #2* {}N &COMP
		;
	LOOP
ABND
COMPLISText
;
***************************************
NULLNAME VXLVARext ( symb -> symb, lvar )
* identique  LVAR mais en positionnant le contenu de VX en tte,
::
TRIMext
DUPTYPELIST? case NULL{}
LISTOPext
LVARDext ROTDROP
' ID VX XEQRCL
( symb, lvar, vx )
2DUP EQUALPOSCOMP
( symb, lvar, vx, # pos )
DUP#0= case2DROP
ROTDUP CARCOMP
( symb, vx, #pos, lvar, 1st of lvar )
UNROT PUTLIST
( symb, vx, lvar sans 1er lment )
ONESWAP PUTLIST
;
*******************************
NULLNAME RACTOFACext
::
' :: DUP TYPETAGGED? case STRIPTAGS
     RNEGext %1 SWAP TWO{}N
     ;
1LAMBIND LISTSECOext
ABND
;
*****************************
NULLNAME num0case
* comme num0=case mais accepte aussi les polynome-listes nuls
::
NOTLISTcase num0=case
TRIMOBJext DUP %0 EQUAL COLAcase
;
*****************************
NULLNAME LOP1ext ( liste, obj, prg -> liste )
* { o1, ..., on }, obj, prg -> { prg[o1,obj], ..., prg[on, obj] }
::
3PICK TYPELIST? NOTcase EVAL
1LAMBIND
SWAPINCOMP get1 OVER
ZERO_DO (DO)
        ( o1, ..., on , #n, o )
        ROTOVER 1GETLAM EVAL 3PICK #2+UNROLL
        LOOP
DROP {}N
ABND
;
*****************************
NULLNAME FROMLISText
( [lvar,] stack, liste de profondeurs -> liste d'objets )
::
( [lvar,] pile, liste de profondeurs -> pile )
internalflag ClrUserFlag
DUPLENCOMP #2+ROLL
SWAPINCOMP get1 SLVARext OVER
ZERO_DO ( pile, prof1, ..., profn, #n, lvar )
        ROT 3PICK #3+ ROLL
        ( pile, prof1, ..., #n, lvar, profn, on )
        ROTDUP
        ( pile, prof1, ..., #n, profn, on, lvar, lvar )
        5UNROLL
        ( reste pile, prof1, ...profn-1, lvar, #n, profn, on, lvar  )
        VAL2ext
        ( reste pile, prof1, ...profn-1, lvar, #n, on  )
        OVER#2+UNROL
        ( reste pile, on, prof1, ...profn-1, lvar, #n  )
        SWAPLOOP
2DROP
;
**********************************
NULLNAME RREIMext
::
SWAPDUP QOBJREext DUP RMULText SWAP QOBJIMext DUP RMULText RADDext
SIMPNDXFext
;
***********************************************************
NULLNAME QUOTOBJext
::
( a_a-1, ..., a0, bb_1, ..., b0, #b, #a , flag -> r, q )
* r est correct si flag est true, sinon r n'est pas calcule
UNROT 2DUPSWAP #-+1 TOTEMPOB ONE TOTEMPOB %0
( a_a-1, ..., a0, bb_1, ..., b0, false, #b, #a, #a-b=i, #0=j, q  -> r, q )
RESOROMP RDIVext
RESOROMP RMULText 
RESOROMP RSUBext
RESOROMP RADDext
4NULLLAM{} BIND
LABEL divdeb!
CODE
* on decremente j, -> si necessaire i, ?fini, sinon calcul de q et j=#b
	C=D1
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( A=#j )
	A=A-1	A
	?A=0	A
	GOYES	div0
	DAT1=A	A
	D1=C
	GOTO	div10
* q_a-b-1, ..., q_i+1, a_i+b, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q
div0	R0=C	A
	CD1EX
	D1=D1+	15
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	CD1EX
	DAT1=A	A	( #j=#b )
	R1=A	A	( R1=#b )
	C=R0	A
	D1=C
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-1	A
	DAT1=A	A	( #i decremente )
	D1=C
	GONC	div2
	A=D0
	LC(5)	(divfin!)-(divdiv!)
div1	A=A+C	A
	D0=A
	GOVLNG	=Loop
* calcul de q=a/b
* q_a-b-1, ..., q_i+1, a_i+b, ..., a0, b_b-1, ..., b0, flag, #b, #a, #i, #j, q
div2	C=R1	A	( R1=#b )
	C=C+C	A	( C=2*#b )
	C=A+C	A	( C=2*#b+#i )
	C=C+CON	A,5
	GOSUB	divpick	( pick a )
	C=R1	A
	C=C+CON	A,6
	GOSUB	divpick	( pick b )
	LA(5)	=4GETLAM
	PC=(A)
* rappelle a, b, q sur la pile
* q_a-b-1, ..., q_i, a_i+b-1, ..., a0, b_b-1, ..., b0, flag, #b, #a, #i, #j, q
div10	GOSUB	div?c
	C=C+CON	A,5
	GOSUB	divpick	( pick a )
	C=R0	A	( c=#j )
	C=C+CON	A,6
	GOSUB	divpick	( pick b )
	LC(5)	=sFLUSH
	GOSUB	divpick	( pick q )
	A=D0
	LC(5)	(divmul!)-(divdiv!)
	GOTO	div1
divpick	D=D-1	A
	GONC divp1
	GOSBVL	=GARBAGE1
divp1	A=C	A
	A=A+A	A
	A=A+A	A
	A=A+C	A	( A= 5*c )
	C=D1
	C=C+A	A
	CD1EX		( D1 pointe sur c_c, C sur le sommet de la pile )
	A=DAT1	A	( A= @c_c )
	CD1EX
	D1=D1-	5
	DAT1=A	A	( copie de c_c au sommet de la pile )
	RTN
* #b, #a, #i, #j, q -> semblable; r0=#j, r1=#b, c=#i+#j+#b
div?c	C=D1
	D1=D1+	5	( calcul i+j+b )
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R0=A	A	( r0= #j )
	D1=C
	D1=D1+	15
	D1=D1+	5
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	
	R1=A	A	( r1=#b )
	D1=C
	D1=D1+	10
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A	( a=#i )
	D1=C
	C=R0	A
	A=A+C	A
	C=R1	A
	C=A+C	A	( c=#i+#j+#b )
	RTN
ENDCODE
LABEL divdiv!
EVAL
( q_q-1, ..., q_i+1, a_i+b, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q, newq )
CODE
	A=DAT1	A
	D1=D1+	5
	DAT1=A	A	( q=newq )
	D1=D1-	5
* on teste si flag=false et i=1 -> fini
	C=D1
	D1=D1+	15
	D1=D1+	15
	A=DAT1	A
	D1=C
	LC(5)	=FALSE
	?A#C	A
	GOYES	div19
	C=D1
	D1=D1+	15
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	D1=C
	?A=0	A
	GOYES	div20
div19	A=D0
	LC(5)	(divmul!)-(divdeb!)
	A=A-C	A
	D0=A
	GOTO	divrep	( newq -> a_i+j=a_i+b )
div20	A=D0
	LC(5)	(divfin!)-(divmul!)
	A=A+C	A
	D0=A
	GOTO	divrep
ENDCODE
LABEL divmul!
3GETLAM
( executer le 2eme objet de lam3 x*, offset +61 ) 
CODE
	A=DAT1	A
	D1=D1+	5
	D=D+1	A
	A=A+CON	A,15
	A=A+CON	A,15
	A=A+CON	A,15
	A=A+CON	A,15
	A=A+1	A
	PC=A
ENDCODE
2GETLAM EVAL ( x- )
* q_q-1, ..., q_i+1, a_i+b-1, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q, a
CODE
	A=D0
	LC(5)	(divfin!)-(divdeb!)
	A=A-C	A
	D0=A
* on remplace stk_i+j+b+4 par le sommet de pile qu'on detruit
divrep	D1=D1+	5
	GOSUB	div?c
	C=C+CON	A,5
	A=C	A
	C=C+C	A
	C=C+C	A
	A=A+C	A
	C=D1
	C=C+A	A
	D1=D1-	5
	A=DAT1	A
	D1=D1+	5
	CD1EX
	DAT1=A	A
	CD1EX
	D=D+1	A
	GOVLNG	=Loop
ENDCODE
* q_q-1, ..., q_i+1, a_i+b-1, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q
LABEL divfin!
ABND 
( q_q-1, ..., q_0, a_b-1, ..., a0, bb_1, ..., b0, flag, #b, #a, #i, #j, q )
3DROP ROTDROP
( q_q-1, ..., q_i+1, a_i+b-1, ..., a0, bb_1, ..., b0, #b, #a )
OVER#2+UNROL DUPDUP #2+UNROLL NDROP
( q_q-1, ..., q_0, a_b-1, ..., a0, #a, #b )
#1- DUPUNROT #- OVER#2+UNROL {}N OVER#2+UNROL {}N
( r, q )
;
***********************************************
NULLNAME QUOText ( o2, o1 -> o2 div o1 )
* quotient euclidien de 2 objets
::
CK&DISPATCH1
2REAL :: TEN TestUserFlag NOTcase RDIVext
         %/ %IP
         ;
2LIST :: TEN ClrUserFlag
         2DUPEQ case2drop { %1 }
         ( l1, l2 )
         DUPLENCOMP
         DUP#1=
         casedrop :: ( list1, { elem2 } )
                     CARCOMP num1=case DROP
                     RESOROMP RDIVext LOP1ext
                     ( { elems1/elem2 } )
                     ;
         ( l1, l2, #l2 )
         3PICK LENCOMP
         ( l1, l2, #l2, #l1 )
         #> case2drop { %0 }
         ( l1, l2 )
	 SWAPINCOMP get1 INNERCOMP get1 
	 ( a_a-1, ..., a0, bb_1, ..., b0, #b, #a )
	 FALSE QUOTOBJext
	 ( r, q )
	 SWAPDROP TRIMext
         ;
EIGHTY ( liste, objet ) DIVOBJext
list :: ( objet, liste )
        2DROP { %0 }
        ;
any RDIVext
;
*********************************
NULLNAME QOBJCONJext
::
QOBJSECext RCONJext
;
*********************************
NULLNAME MVMULText
( mvmult : matrice, vecteur -> vecteur )
::
MMULTOBJext NOTcase x*ext
( matrice symb * vecteur symb -> matrice symb )
( teste la compatibilite des longueurs )
( matr-l, vect-l )
OVER CARCOMP
( matr-l, vect-l, 1ere ligne de matr )
LENCOMP OVER LENCOMP #= NcaseSIZEERR
( matr-l, vect-l )
SWAPINCOMP get1 NULL{} ROT
ZERO_DO (DO)
	OVER 4ROLL XYext >HCOMP
	LOOP
SWAPDROP
;
*************************************
NULLNAME DMONOEVALext
::
DUP DEPTHext COLA MONOEVALext
;
****************
NULLNAME BINEVALext
( o1, o2, #prof resultat [operande du runstream] -> o1 operande o2 )
::
internalflag TestUserFlag caseDROP
UNROT TWO TOLISText 'REVAL SWAP VALOBJext internalflag ClrUserFlag
;
********************************
NULLNAME DIV2LISText
* comme DIVext mais pour 2 listes, ne fait pas de TRIMext sur le quotient
::
( { %0 }, l1, l2 )
2DUP EQUALcase :: 2DROP { %1 }  SWAP ;
TEN ClrUserFlag
( { %0 }, l1, l2 )
DUPLENCOMP
DUP#1= casedrop :: ( { %0 }, list1, { elem2 } )
                   CARCOMP num1=case DROPSWAP
                   RESOROMP RDIVext LOP1ext SWAP
                   ( { elems1/elem2 }, { %0 } )
                   ;
( { %0 }, l1, l2, #l2 )
3PICK LENCOMP
( { %0 }, l1, l2, #l2, #l1 )
#>case DROP
( { %0 }, l1, l2 )


( { %0 }, A, B -> A div B, A mod B  si len A >= len B >= 2 )
SWAPINCOMP get1 INNERCOMP get1 
( { %0 }, a_a-1, ..., a0, bb_1, ..., b0, #b, #a )
TRUE QUOTOBJext
( {%0 }, r, q )
ROTDROPSWAP
( q, r )
;
********************************
NULLNAME CKFPOLYext
::
( obj -> obj ou ERROR )
DUP
DUPTYPELIST? NOTcaseDROP
' :: DUPTYPELIST? NOTcaseDROP
     DUPNULL{}? caseSIZEERR
     INNERCOMP
     ZERO_DO (DO) 1GETLAM EVAL
                  LOOP
     ;
DUP1LAMBIND EVAL ABND
;
**********************************
NULLNAME QXNDext
( obj -> a, b, c )
::
DUPTYPECOL? NOTcase :: %0 SWAP %1 ;
INNERCOMP #5= NcaseTYPEERR
DROP 4ROLLDROP
;
***********************************
NULLNAME NDXQext
::
( a, b, c -> seco )
%1 EQUALcasedro RADDext
OVER num0case 3DROP
( a, b, c, b )
DUPTYPECOL? pgcdflag TestUserFlag AND
( a, b, c, b, ?seco )
ITE ::	QXNDext ROT 
	( a, b, c, e, f, d )
	num0case ::	( a, b, c, e, f, 0 )
			DROPROT RMULText NOSIMPEVALext XSQRext
			( a, b, e, sqrt[c*f] )
			RMULText SWAPDROP RADDext RDROP
			( a+e*sqrt[c*f] )
			;
	3DROP
	;
	DROP
( a, b ,c )
' x<< 4UNROLL ' x\>> FIVE ::N 
;
**********************************
NULLNAME QADDext
( obj1, obj2 -> obj1 + obj2 )
::
PREPARext
( a1, b1, c1, a2, b2, c2 )
6ROLL 4ROLL RADDext UNROT
( b1, c1, a1+a2, b2, c2 )
:: %1 EQUALcasedro ( b1, c1, a1+a2, b2 ) RADDext
   ( b1, c1, a1+a2, b2, c2 )
   4ROLL
   ( b1, a1+a2, b2, c2, c1 )
   %1 EQUALcasedro :: ( b1, a1+a2, b2, c2 ) 2SWAP RADDext ;
   OVER EQUALcasedro :: ( b1, a1+a2, b2, c2 ) 4ROLLROT RADDext SWAPROT  ;
   ( b1, a1+a2, b2, c2, c1 )
   COMPext
   ITE :: 5UNROLL 2SWAP SWAP 5ROLL ;
       4UNROLL 
   ( b2, c2, a1+a2, b1, c1 avec c2>c1 )
   %0 UNROT NDXQext RADDext
   ( b2, c2, a1+a2+b1*sqrt[c1] )
   ;
( b, c, a )
UNROT NDXQext
;
***********************************
NULLNAME QSUBext
( obj1, obj2 -> obj1 - obj2 )
::
RNEGext QADDext
;
*************************
NULLNAME QMULText ( o1, o2 -> o1*o2 )
* Il faudra rajouter le test pgcd[c1,c2]<>0 
::
PREPARext
( a1, b1, c1, a2, b2, c2 )
:: %1
   EQUALcasedro :: RADDext
                   ( a1, b1, c1, a2+b2 )
                   4ROLLOVER RMULText
                   ( b1, c1, a2+b2, a1*[a2+b2] )
                   4UNROLLROT RMULText SWAP
                   ;
   4ROLL %1
   EQUALcasedro :: ( a1, b1, a2, b2, c2 )
                   5UNROLL 2SWAP RADDext
                   ( c2,  a2, b2, a1+b1 )
                   DUPROT RMULText UNROT RMULText
                   ( c2,  b2*[a1+b1], a2*[a1+b1] )
                   UNROTSWAP
                   ;
   ( a1, b1, a2, b2, c2, c1 )
   OVER
   EQUALcasedro :: 5UNROLL
                   4PICKOVER RMULText
                   ( c, a1, b1, a2, b2, a1*b2 )
                   2OVER RMULText RADDext 5UNROLL
                   ( c, a1*b2+a2*b1, a1, b1, a2, b2 )
                   ROT RMULText 5PICK RMULText UNROT
                   ( c, a1*b2+a2*b1, b1*b2*c, a1, a2 )
                   RMULText RADDext
                   ( c, a1*b2+a2*b1, b1*b2*c+a1*a2 )
                   SWAPROT
                   ;
   COMPext
   ( a1, b1, a2, b2, c2, c1, c2<c1? )
   ITE 4ROLL 
       :: SWAP 5ROLL UNROT 6ROLL          
          ( a2, b2, b1, c1, c2, a1 )
          ;
   ( a1, b1, b2, c2, c1, a2 )
   DUP 7PICK 
   ( a1, b1, b2, c2, c1, a2, a2, a1 )
   RMULText UNROT
   ( a1, b1, b2, c2, a1*a2, c1, a2 )
   6PICK RMULText SWAPDUP 8UNROLL
   ( c1, a1, b1, b2, c2, a1*a2, b1*a2, c1 )
   %0 UNROT NDXQext RADDext 6UNROLL
   ( a1*a2+b1*a2sqrt[c1], c1, a1, b1, b2, c2 )
   SWAPDUP
   ( a1*a2+b1*a2sqrt[c1], c1, a1, b1, c2, b2, b2 )
   5ROLL RMULText
   ( a1*a2+b1*a2sqrt[c1], c1, b1, c2, b2, a1*b2 )
   4UNROLLROT RMULText
   ( a1*a2+b1*a2sqrt[c1], c1, a1*b2, c2, b1*b2 )
   ROTSWAP 4ROLL 
   ( a1*a2+b1*a2sqrt[c1], c2, a1*b2, b1*b2, c1 )
   %0 %1 ROT NDXQext RMULText RADDext SWAP
   ( a1*a2+b1*a2sqrt[c1], a1*b2+b1*b2*sqrt[c1], c2 )
   ;
NDXQext
;
*************************
NULLNAME QDIVext
::
QCONJext DUP QNORMext UNROT QMULText QXNDext
( norme, a, b, c )
ROT 4PICK RDIVext UNROTSWAP 4ROLL RDIVext SWAP
NDXQext
;
*************************
NULLNAME QCONJext
::
QXNDext SWAP RNEGext SWAP NDXQext
;
**************************
NULLNAME QNORMext
::
QXNDext SWAPDUP RMULText RMULText SWAPDUP RMULText SWAP RSUBext
;
****************************
NULLNAME BIN2EVALext
( o1, o2, [ procedure du runstream] -> o1', o2' )
::
internalflag TestUserFlag ?SEMI
TWO TOLISText 'REVAL ZEROZERO TWO{}N FROMLISText
;
****************************
NULLNAME QOBJNEGext
::
QOBJext RNEGext
;
*********************************
NULLNAME LLVARDext ( o -> #depth, o, lvar )
* liste des identificateurs, racines carrees considerees comme op arithmetique
::
LISTOPext ' x\v/ >TCOMP
{ xRE xIM xCONJ }
complexflag UserITE DROP &COMP
LVARDext
;
**********************************
NULLNAME QOBJSECext ( objet [ runstream: programme ] -> objet )
* Ex\'exute programme sur les \'el\'ements de objet (pour des objets
* de type liste, alg\'ebrique,  ou array en les d\'ecomposant)
::
'R
CK1TONOext
' :: CK&DISPATCH1
     real 2GETEVAL
     TWO 2GETEVAL
     sym 2GETEVAL
     ELEVEN 2GETEVAL
     seco 2GETEVAL
     list LISTSECOext
     TAGGED :: xOBJ\-> SWAP 1GETLAM EVAL SWAP x\->TAG ;
     arry :: AXLext 1GETLAM EVAL ;
     any NOP
     ;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL
ABND
;
**********************************************
NULLNAME SLVARext ( lvar -> lvar )
::
( simplifie la liste des variables selon le flag 21 )
( lvar -> lvar simplifie si flag 21 set )
recurseflag TestUserFlag NOT?SEMI
DUPTYPELIST? NOT?SEMI
DUPNULL{}? ?SEMI
INNERDUP #1-SWAP
ZERO_DO 
	( var1, ..., varn, #n )
	get1 DUPTYPESYMB?
	IT ::	' xOBJ\-> EvalNoCK 
		( var2, ..., varn, #n, o1, ..., ok, %k, op )
		SWAP DUP%0= casedrop EvalNoCK
		COERCEDUP
		ZERO_DO (DO)
			get1 SIMP1ext SYMCOMPext UNROT
			LOOP
		SWAP
		( objets, #nombre, oper )
		NOTSECOcase :: real SYMBN SWAP' xFCNAPPLY OVER #3+ SYMBN ;
		SWAPDROP EvalNoCK
		;
	SWAPLOOP
#1+ {}N
;
************************************************
NULLNAME VAL2ext ( #depth, poly-liste, { x1 ... xn } -> poly-symb )
::
( #, P, lvar )
ROTSWAP
( P, #, lvar )
( LAM9: lvar )
( LAM8: C% -> a+bi )
' ::	iflag TestSysFlag NOT?SEMI 
	C%>% SYMBOL xi ; 'x* EvalNoCK ' x+ EvalNoCK
	;
( LAM7: seco -> seco ou symb )
' :: DUP CARCOMP EQ: x<< NOT?SEMI
     INNERCOMP #5= NcaseTYPEERR
     DROP 4ROLLDROP
     ( a, b, c )
*     ( teste si b est un irrquad dont le terme constant est nul )
*     :: SWAP NOTSECOcase SWAP
*        ( a, c, b )
*	QXNDext 3PICK %0 EQUALNOTcase :: NDXQext SWAP ;
*        ( a, c, 0, b', c' )
*	ROTDROP ROT RMULText
*	;
     THREE ZERO_DO (DO) 2GETEVAL EVAL UNROT LOOP
     ' x\v/ OVER TYPESYMB? ITE EvalNoCK :: TWO SYMBN ;
     x*ext ' x+ EvalNoCK
     ;
( LAM6: tagged -> tagged )
' :: xOBJ> SWAP 2GETEVAL EVAL SWAP >TAG
     ;
( LAM5: symb -> symb )
' :: INNERDUP #1-SWAP
     ZERO_DO (DO)
             ( meta )
             SWAP 2GETEVAL EVAL
             ( o1, ..., on-1, #n-1, on )
             DUPTYPESYMB?
             :: NOTcase OVER#2+UNROL
                INNERCOMP psh get1 #+-1
                ;
             LOOP
     #1+ SYMBN
* pour eviter les expr/1
     FXNDext NDXFext
     ;
ZERO ( LAM4: profondeur actuelle )
' :: ( LAM3: liste -> objet )
     NOSIMPEVALext TRIMOBJext
     NOTLISTcase :: 2GETEVAL EVAL ;
     9GETLAM 4GETLAM #1+DUP 4PUTLAM
     NTHELCOMP
     :: NOT?SEMI
     CK&DISPATCH1
     sym
     :: ( list, idnt/sym -> symb )
        ( code donnant les monmes dans l'ordre dcroissant )
        ( X, an,...,a0, #n+1)
        SWAPINCOMP DUP#0<> NcaseSIZEERR
        ( X, an,...,a0, #n+1)
        DUP#1= casedrop :: SWAPDROP 2GETEVAL EVAL ;
        get1 SWAPDUP
        ( an,...,a0, X, #n+1, #n+1 )
        ONE_DO (DO)
               ( meta, X, length[meta] )
               :: get1 2GETEVAL EVAL
                  num0case DROP#1-
                  ( meta, X, length[meta]+1, ak )
                  :: DUPTYPESYMB?
                     NOTcase :: num1=case :: DROPTRUE FALSE ;
                                num-1=case :: DROPFALSE FALSE ;
				DUPTYPEREAL? NOTcase :: UNROT TrueTrue ;
				DUP %0< NOTcase :: UNROT TrueTrue ;
				%CHS UNROT FALSETRUE
                                ;
                     TWO SWAPINCOMP psh
                     ( meta, meta_ak, X, length, #2 )
                     DROPROT
                     ( meta, meta_ak, X, length, length_meta_ak )
                     #+-1 TrueTrue
                     ;
                  ( meta, ak, X, length, flag?x-, flag?x* )
                  4ROLL DUP
                  ( meta, ak, length, flag?x-, flag?x*, X, X )
                  :: DUPTYPESYMB? NOTcase 5UNROLL
                     FOUR SWAPINCOMP psh
                     ( meta, ak, metaX, length, flag?x-, flagx*, X, #4 )
                     DROP 4ROLL 5ROLL
                     ( meta, ak, X, ak, flag?x-, flag?x*, length, length_X )
                      #+-1 4UNROLL
                     ;
                  ( meta, ak, X, length+1, flag?x-, flag?x*, X )
                  UNROT 'x* OVER
                  ( meta, ak, X, length+1, X, flag?x-, flag?x*, 'x*, flag?x* )
                  ITE 5UNROLL DROP
                  ( meta, ak, X, x*, length+1, X, flag?x-, flag?x* )
                  ISTOP-INDEX
                  ( meta, ak, X, x*, length+1, X, flag?x-, flag?x*, #k )
                      :: DUP#1= case DROPFALSE
                         UNCOERCE OVER
                         case :: 6UNROLL ' x^ 6UNROLL TRUE ;
                         5UNROLL ' x^ 5UNROLL TRUE
                         ;
                  ( meta, ak, X, x*, length+1, X, flag?x-, flag?*, flag?^ )
                  ITE THREE ONE SWAP IT #2+ 4ROLL #+
                  ( meta, ak, X, x*, X, flag?x-, newlength )
                  SWAPINDEX@
                  #1=case :: case #1- ' xNEG UNROT ;
                  ITE :: ' x+ ;
                      :: ' x- ;
                  UNROT
                  ;
               LOOP
        ( meta, X, length[meta] )
        get1 2GETEVAL EVAL ROTDROP
        ( meta, length[meta], a0 )
               :: num0case DROP#1-
                  num-1=case :: %CHS SWAP' x- SWAP#1+ ;
                  ( meta, length[meta], a0 )
                  SWAP' x+ SWAP#1+
                  ( meta, a0, x+, length )
                  3PICK DUPTYPESYMB? NOTcaseDROP
                  ( meta, a0, x+, length, a0 )
                  DROPROT TWO SWAPINCOMP psh
                  DROPROT #+-1
                  ;
        SYMBNext
        ;
     any :: ( list, any )
               SWAPINCOMP
               DUP#0=csDROP
               DUP#1= casedrop :: SWAPDROP 2GETEVAL EVAL ;
               reversym
               SWAP 2GETEVAL EVAL SWAP
               get1 SWAP
               ( a0,..., an, x , #n+1)
               ONE_DO
                     ( a0, ..., ak, res, x )
                     DUP4UNROLL RMULText SWAP 2GETEVAL EVAL RADDext
                     SWAPLOOP
               ( res, x ) DROP
               ;
     ;
     4GETLAM #1- 4PUTLAM
     ;
' :: ( LAM2: liste, fraction ou objet -> objet )
     CK&DISPATCH1
     list 3GETLAM
     symb 5GETLAM
     seco 7GETLAM
     THIRTEEN 6GETLAM
     TWO 8GETLAM
     any 'NOP
     ;
' :: ( LAM1 liste, # -> liste )
     DUP#0=csedrp :: 2GETEVAL EVAL ;
     #1-SWAP
     DUPTYPETAG?
     ( #, liste, flag )
     DUP4UNROLL
     IT :: xOBJ> 4UNROLL ;
     DUPTYPELIST? ITE INNERCOMP ONE
     ( tagged?, #, meta )
     DUP#0= case2drop :: DROP NULL{} ;
     get1 OVER
     ZERO_DO (DO)
             ( ak, ..., an, a1,...,ak-1, #n, # )
             OVER #2+ROLL OVER
             ( ak+1, ..., an, a1,...,ak-1,#n, #, ak,#)
             1GETLAM EVAL UNROT
             LOOP
     DROP {}N
     ( [tag,] flag, liste )
     SWAP NOT?SEMI
     SWAP >TAG
     ;
( P, #, lvar, fxnd, profondeur, prg non frac, prg frac, prg )
( LAM       6  ,   5      4            3          2         1  )
' NULLLAM NINE NDUPN DOBIND
( P, # )
1GETLAM EVAL
ABND
;
************************************************
NULLNAME COMPext ( obj1, obj2 -> obj1, obj2, true or false )
( teste si obj1 < obj2: tri par type puis par chaine de caracteres )
( longueur de chaine puis ordre alphabetique )
::
SWAP XEQTYPE ROT XEQTYPE
( o1, t1, o2, t2 )
ROT
( o1, o2, t2, t1 ) 
2DUP %> case2drop TRUE
%< caseFALSE
( o1, o2 )
2DUPSWAP DO>STR DUPLEN$ ROT DO>STR DUPLEN$ 
( o1, o2, s1, l1, s2, l2 )
ROTSWAP 
( o1, o2, s1, s2, l1, l2 )
2DUP#= case2drop :: ' x<? EvalNoCK %0<> ;
#< UNROT2DROP
;
*************************************************
NULLNAME PREPARext ( o1, o2 -> a1, b1, c1, a2, b2, c2 )
* avec c1=c2 ou c1 et c2 premiers entre eux 
::
SWAP QXNDext 4ROLL QXNDext
( a1, b1, c1, a2, b2, c2 )
4PICKOVER 
( a1, b1, c1, a2, b2, c2, c1, c2 )
EQUALcasedro NOP 
TWO{}N SIMPEVALext LPGCDext
TRIMOBJext %1 EQUALcasedro CARCOMP
( a1, b1, c1, a2, b2, { c2 c1 }, d )
5ROLLDROP DUPDUP 
( a1, b1, a2, b2, { c2 c1 }, d, d, d )
6UNROLL UNROT LOPDext
( a1, b1, d, a2, b2, d, { c2' c1' } )
INCOMPDROP 5UNROLL 
( a1, b1, d, c1', a2, b2, d, c2' )
TRIMOBJext COMPext IT SWAP 
:: %1 EQUALcasedro NOP
   4UNROLL
   ( a1, b1, d, c1', c2', a2, b2, d )
   %0 UNROT NDXQext ROT
   ;
( a1, b1, d, c1', a2', b2', c2' )
7UNROLL 7UNROLL 7UNROLL
( a2', b2', c2', a1, b1, d, c1'  )
TRIMOBJext COMPext IT SWAP 
:: %1 EQUALcasedro NOP
   4UNROLL
   ( a1, b1, d, c1', c2', a2, b2, d )
   %0 UNROT NDXQext ROT
   ;
( a2', b2', c2', a1', b1', c1'  )
6UNROLL 6UNROLL 6UNROLL
;
******************************************************
NULLNAME FACT2MULText ( listnum, listdeno -> list )
* listnum et listdeno representent des listes de facteurs au numerateur et au
* denominateur,
* on regroupe les facteurs sous la forme facteur multiplicite
* Exemple { 2 2 3 4 } { 3 3 3 5 5 } -> { 4 1 2 2 3 -2 5 -2 }
* l'algo n'est pas terrible, on extrait tous les facteurs du numerateur
* avec NEXTP, on regarde comment ils sont au denominateur
::
NULL{} UNROTSWAP
( elimine les 1 )
%1 >HCOMP NEXTPext DROP
[BEGIN]
	( res, ld, ln )
	DUPNULL{}?
NOT_WHILE
	::
	NEXTPext
	( res, ld, ln, { facteurs } )
	DUPLENCOMP UNCOERCE SWAP CARCOMP
	( res, ld, ln, multiplicite, facteur )
	4ROLLSWAP >HCOMP NEXTPext
	( res, ln, multiplicite, ld, { facteurs } )
	DUPLENCOMP #1- UNCOERCE 4ROLLSWAP %-
	( res, ln, ld, { facteurs }, multiplicite )
	DUP%0= case2drop SWAP
	SWAP CARCOMP OVER TWO{}N
	( res, ln, ld, multiplicite, { facteur multiplicite } )
	5ROLL SWAPROT %0> 
	( ln, ld, res, { facteur }, mult>0? )
	IT SWAP &COMP
	( ln, ld, res )
	UNROTSWAP
	;
[REPEAT]
( res, ld, ln )
DROP
( elimine les 1 )
%1 >HCOMP NEXTPext DROP
[BEGIN]
	( res, ld )
	DUPNULL{}?
NOT_WHILE
	::
	NEXTPext DUPLENCOMP UNCOERCE %CHS SWAP CARCOMP
	( res, ld, mult, facteur )
	4ROLLSWAP >TCOMP SWAP >TCOMP SWAP
	;
[REPEAT]
DROP
DUPNULL{}? casedrop { %1 %1 }
;
*******************************************
NULLNAME SMULTOBJext  ( matrice/vecteur, scalaire -> m,s, flag )
* Prpare un produit matrice ou vecteur par un scalaire
* flag=false pour resultat numerique, True pour symb
::
CK&DISPATCH1
BINT_65d FALSE ( matrice num * reel -> matrice num )
FOURTWO FALSE ( matrice num * complexe  -> matrice num )
SIXTYFOUR ::	( matrice num * objet -> matrice symb )
		SWAP AXLext SWAPTRUE
		;
EIGHTY TRUE
;
***********************************
NULLNAME VPMULText ( vecteur, scalaire -> vecteur )
::
SMULTOBJext NOTcase x*ext
RESOROMP RMULText ONE MLAM1LAM2ext
;
***************
NULLNAME MULMULText ( liste, coeff -> liste )
* multiplie les multiplicites dans liste par coeff
::
DUPNULL{}? caseDROP
SWAPINCOMP get1
( o1, %m1, ..., on, %mn, #2n, % )
SWAPDUP #2/
( o1, %m1, ..., on, %mn, %, #2n, #n )
ZERO_DO (DO)
	( o1, %m1, ..., on, %mn, %, #2n )
	get1 UNROT
	( %m1, ..., on, %mn, o1, %, #2n )
	get1 3PICK %* UNROT
	( ..., on, %mn, o1, %m1*%, %, #2n )
	LOOP
SWAPDROP {}N
;
**********************
NULLNAME ADDLISText ( liste, multiplicite, objet -> liste )
* ajoute un objet ayant une multiplicite a une liste
* d'objets-multiplicite
::	
' :: ROT INNERCOMP get1 SWAP#1+ get1 SWAP#1+ {}N ; 
( l, m, o, prg )
4PICK 3PICK EQUALPOSCOMP
( l, m, o, prg, # )
DUP#0=csedrp EVAL
DUPONE #AND #0= casedrop EVAL
( l, m, o, prg, # )
UNROT2DROP
( l, m, # )
#1+ 3PICKOVER NTHCOMPDROP
( l, m, #, m' )
ROT %+ SWAPROT PUTLIST
;
****************************
NULLNAME COMPLISText ( liste -> liste )
* additionne les multiplicites et supprime les facteurs multiples
* de la liste
::
( liste -> liste )
TRIMext 
( on s'assure qu'on n'a pas enleve une racine nulle )
DUPLENCOMP TWO #/ DROP
#1= IT :: %0 >HCOMP ;
NULL{} SWAP
( resultat, argument )
[BEGIN]
	DUPNULL{}?
NOT_WHILE
	::
	( res, arg )
	INNERCOMP #2- {}N
	( res, 1st, mult, arg )
	SWAPROT
	( res, arg, mult, 1st )
	' :: 4ROLL INNERCOMP get1 SWAP#1+ get1 SWAP#1+ {}N SWAP ;
	4PICK 3PICK EQUALPOSCOMP
	( res, arg, mult, 1st, prg, # )
	DUP#0=csedrp EVAL
	DUPONE #AND #0= casedrop EVAL
	( res, arg, mult, 1st, prg, # )
	2DROP ADDLISText
	( res, arg )
	;
[REPEAT]
DROP
;
****************************
NULLNAME SQFF2ext ( l1, ..., ln, #n-1 -> l1', ..., ln', #n-1)
* teste s'il y a des pgcd non triviaux entre les facteurs des lj
* pour renvoyer une liste de facteurs premiers entre eux
::
( on recherche les pgcd non triviaux liste a liste )
DUP#0= ?SEMI
get1 SWAPDUP
( l2, ..., ln, l1, #n-1, #n-1 )
ZERO_DO
	get1 INDEX@ #2+ DUP
	ONE_DO
	( li+1, ...,ln, l1, ..., li-1, #n-1, li, #i )
		get1 ROT 
		::
		( simplification de 2 listes )
		( l1, l2 )
		DUPNULL{}? ?SEMI
		SWAP DUPNULL{}? case SWAP
		SWAP
		DUPLENCOMP #2/
		#1+_ONE_DO
			( l1, l2 )
			DUPINDEX@ #2* #1- NTHCOMPDROP
			( l1, l2, f2i )
			ROT DUPLENCOMP #2/
		#1+_ONE_DO
			( l2, f2i, l1 )
			DUPINDEX@ #2* #1- NTHCOMPDROP
			( l2, f2i, l1, f1j )
			3PICK TWO{}N LPGCDext
			( l2, f2i, l1, { f1j f2i }, pgcd )
			::	TRIMOBJext num1=case 2DROP
				DUPUNROT LOPDext
				( l2, f2i, l1, pgcd, { f1j' f2i' } )
				INCOMPDROP
				::	TRIMOBJext num1=case DROP
					( mise a jour de l2 )
					5ROLLDROP 4UNROLL
					( l2, f2i', l1, pgcd, f1j' )
					5ROLL DUP JINDEX@ #2* NTHCOMPDROP 4PICK  
					( f2i', l1, pgcd, f1j', l2, multiplicite, pgcd )
					ADDLISText DUPLENCOMP #2/ #1+ JSTOPSTO 5UNROLL 
					( l2+pgcd+mult, f2i', l1, pgcd, f1j' )
					;
				( l2, f2i', l1, pgcd, f1j' )
				TRIMOBJext num1=case 2DROP
				ROT INDEX@ #2* #1-SWAP PUTLIST
				( l2, f2i', pgcd, l1 modifie par f1j' )
				DUPINDEX@ #2* NTHCOMPDROP 3PICK
				( l2, f2i', pgcd, l1 modifie par f1j', multiplicite, pgcd )
				ADDLISText
				( l2, f2i', pgcd, l1 )
				( si pgcd est un reel ou un compl., on refait le pgcd )
				SWAP num1=case DROP 
				( l2, f2i', l1, pgcd )
				XEQTYPE SWAPDROP %2 %>= ?SEMI
				INDEX@ #1- INDEXSTO
				;
			[LOOP]
			( on remplace f2i par f2i' dans l2 )
			( l2, f2i', l1 )
			UNROTSWAP INDEX@ #2* #1-SWAP PUTLIST
			( l1, l2 )
		[LOOP]
		( fin de simplification de 2 listes )
		;
		UNROT 4UNROLL
	[LOOP]
	DROP 
SWAPLOOP
;
******************************
NULLNAME RFACText ( obj, # -> lvar, obj interne, liste facteurs )
::
* Factorisation rationnelle selon #:
* ZERO: racines N/D, ONE: racines N, TWO; racines D
* FOUR: facteurs N/D, FIVE: facteurs N, SIX: facteurs D
* THREE: factorisation en facteurs premiers entre eux N/D
* Etapes de la factorisation:
* 1/ liste des variables, les racines carrees comprises
* 2/ transformation d'un symbolique en liste
*    de facteurs listes avec multiplicite
* 3/ appel de SQFFext sur chaque facteur liste
* 4/ calcul des pgcd entre facteurs pour obtenir une SQFF complete
( obj )

* Etape 1/
( obj, type de factorisation : cf. FACTOBJext )

( obj, # )

SWAP VXLVARext ROT
( obj, lvar, # )
RFACT2ext 
;
*********************************
NULLNAME RFACT2ext ( obj, lvar, # -> lvar, obj interne, lrac | lfac )
::
* Etape 2/
( obj, lvar, # )
FOUR #/ #1= ( obj, rem, ?facteurs )
' NULLLAM DUPTWO DOBIND

( obj, lvar )
( LAM6 = lvar )
( LAM5: liste, coeff -> liste )
* multiplie les multiplicites dans liste par coeff
RESOROMP MULMULText 
' ::	( LAM4 op=x*)
	( symb, o1,..., on-1, #n )
	#1- pZpargSWAPUn
	( symb, meta1, meta2 )
	SYMBNext
	OVER#2+UNROL SYMBNext
	( symb, symb1, symb2 )
	ROTDROP 1GETLAM EVAL
	( symb1, list2, root2 )
	ROT 1GETLAM EVAL
	( list2, root2, list1, root1 )
	4ROLLROT RMULText
	( root2, root1, list )
	UNROT &COMP
	( list, root )
	;
' ::	( LAM3: op=x^ )
	( symb, o1,..., on-1, #n )
	#1- pZpargSWAPUn
	( meta, meta-exposant)
	#1= NcaseSIZEERR
	( meta, exposant )
	DTYPEREAL? NcaseSIZEERR
	DUPDUP %FLOOR %= NcaseSIZEERR
	( meta, exposant reel entier )
	OVER#2+UNROL SYMBNext
	ROTDROP 1GETLAM EVAL
	( exposant, poly-liste, racines )
	SWAP3PICK RESOROMP RMULText MPext
	( exp, rac, poly-l )
	SWAPROT 5GETLAM EVAL
	( poly, rac )
	;
' ::	( LAM2: op=x/ )
	( symb, o1,..., on-1, #n )
	#1- pZpargSWAPUn
	( symb, meta1, meta2 )
	SYMBNext
	OVER#2+UNROL SYMBNext
	( symb, symb1, symb2 )
	ROTDROP 1GETLAM EVAL
	( symb1, list2, root2 )
	ROT 1GETLAM EVAL 
	( list2, root2, list1, root1 )
	%-1 5GETLAM EVAL
	( list2, root2, list1, root1 )
	4ROLLROT RDIVext
	( root2, root1, list2/list1 )
	UNROT &COMP
	( list, root )
	;
' ::	( LAM1: obj -> obj interne, liste de facteurs )
	num1=case NULL{}
	DUPTYPESYMB? 
	NOTcase ::	6GETLAM VXXLext 
			SWAPDROPDUP %1 TWO{}N
			;
	DUPINCOMP SWAP
	( symb, o1, ..., on-1, #n, on )
	{ x* 4GETLAM x^ 3GETLAM x/ 2GETLAM }
	EQLookup case :: EVAL EVAL ;
	( symb, o1, ..., on-1, #n, on )
	EQ: x=
	( symb, o1, ..., on-1, #n, flag )
	ITE	::	' x- SWAP SYMBN SWAPDROP
			;
	        :: #1- NDROP ;
	( symb )
	6GETLAM VXXLext SWAPDROP
	( objet interne )
	vxxlflag TestUserFlag NcaseSIZEERR
	TRIMOBJext 
	num1=case NULL{}
	DUP FXNDext
	( obj interne, numerateur, deno )
	num1=case :: DROP %1 TWO{}N ;
	OVER num1=case :: DROPSWAPDROP %-1 TWO{}N ;
	( obj interne, num, deno, num )
	DROP %1 SWAP %-1 FOUR {}N
	( obj interne, liste de facteurs )
	;
' NULLLAM SIX NDUPN DOBIND
1GETLAM EVAL
6GETLAM UNROT
( lvar, obj interne, liste de facteurs avec multiplicite )
ABND
DUPNULL{}? IT :: DROP %1 DUPTWO {}N ;

* Etape 3/
( liste -> l1, ..., ln, #n )
INNERDUP #2/
( o1, m1, ..., on, mn, #2n, #n )
ZERO_DO
	( o1, ..., mn, #2n )
	#1- get1
	( m1, ..., on, mn, #2n-1, o1 )
	SWAP get1
	( o2, ..., mn, o1, #2n-1, m1 )
	ROTOVER
	( o2, ..., mn, #2n-1, m1, o1, m1 )
	2GETLAM ::	DUP#0=csedrp DROPTRUE
			#1=case %0> %0<
			;
	( o2, ..., mn, #2n-1, m1, o1, flag )
	ITE ::	SQFFext NULL{} FACT2MULText SWAP MULMULText 
		;
	    ::	SWAP TWO{}N
		;
	( ..., on, mn, #2n-1, l1 )
	SWAPLOOP

* Etape 4
( lvar, obj interne, l1, ..., ln, #n )
#1- SQFF2ext
	::	DUP#0=csDROP
		ZERO_DO	(DO)
			&COMP
			LOOP
		;
( lvar, obj interne, liste facteurs non comprimee )
COMPLISText
2GETLAM #3= case ABND
2GETLAM 1GETLAM
ABND
( lvar, obj interne, liste facteurs, #, flag )

* Etapes 5 et 6
FACTOBJext
( lvar, obj interne, liste facteurs ou de racines )
;
******************************
NULLNAME FACTOOBJext ( inverse de RFACText )
* Si flag est TRUE on a affaire a des facteurs, sinon a des racines
::
( { fact mult }, flag, 'x*, 'x^ -> obj )
' NULLLAM DUPDUP THREE DOBIND
DUPNULL{}? casedrop :: %1 ABND ;
INNERCOMP #2/ %1 %1 ROT
ZERO_DO (DO)
	( fact1, num1, ..., factk, numk, num, deno )
	2SWAP DUPTYPEBINT? IT UNCOERCE dREALNcase SETSIZEERR
	DUP %0< UNROT %ABS 
	( .., num, deno, mult<0?, factk, | mult | )
	3GETLAM ?SKIP :: SWAP ONE{}N RACTOFACext CARCOMP SWAP 
			 ;
	1GETLAM EVAL SWAP
	( ..., num, deno, factk, mult<0? )
	ITE 	2GETEVAL
		:: ROTSWAP 2GETEVAL SWAP ;
	LOOP
NDXFext
ABND
;
*******************
NULLNAME DERIVext ( obj -> derivee )
* derivee symbolique, on doit etre en mode interne
::
' ::	( LAM5/8 objet, idnt/lam/sym/list -> derivee )
	CK&DISPATCH1
	idnt :: 3PUTLAM 4GETLAM EVAL ;
	symb :: DUP' TYPEIDNT? Find1stTrue
		( obj, f[t], [ t, true | false ] )
		NcaseTYPEERR
		3PUTLAM
		( obj, f[t] )
		4GETLAM EVAL SWAP 4GETLAM EVAL SWAP RDIVext
		;
	list ::	INNERCOMP DUP#0=csedrp SETTYPEERR get1 SWAPDUP
		ZERO_DO (DO)
			( v1, ..., vn, obj, #n )
			get1 3PICKSWAP 5GETLAM EVAL
			( v2, ..., vn, obj, #n, obj' )
			UNROT
			LOOP
		SWAPDROP {}N
		;
	;
' ::	( LAM4/7: objet -> derivee par rapport a LAM3/6 qui doit etre un idnt )
	QOBJext
	::	( LAM2: symb -> symb: derive symb par rapport a LAM5 )
		idntlamcase :: 6GETLAM EQUALcase %1 %0 ;
		DUPTYPESYMB? 
		NOTcase ::	XEQTYPE %18 %= NOTcasedrop %0
				5GETLAM EQLookup ?SEMI 
				DO>STR "Can't handle " SWAP &$
				EXITMSGSTO # 70000 ERRORSTO
				ERRJMP
				;
		DUPLENCOMP #1=case :: CARCOMP 2GETEVAL ;
		' xOBJ\-> EvalNoCK
		( objets, %nbre, oper )
		' xder EQUALcasedro
		::	( fnct, x, %2 )
			DROP
			( fnct, x )
			DERIVext
			2GETEVAL
			;
		SWAP DUP%0= case2drop %0
		COERCEDUP
		( objets, oper, #, # )
		#2+ NDUP
		( objets, oper, #, obj, oper, # )
		DUP#1+
		ZERO_DO 
			get1 2GETEVAL
			SWAPLOOP
		( objets, oper, #, derivees, der oper, # )
		DUP#1= casedrop ::	( obj, oper, #1, der, der oper )
					%0 
					EQUALcasedro :: ( fonction utilisateur )
							4UNROLL SWAP 
							( der, obj, #1, fonction )
							ID>$ "d1" SWAP&$ $>ID  
							ONE SYMBN
							SWAP' xFCNAPPLY FOUR SYMBN
							RMULText
							;
					5ROLL SYMCOMPext SWAP 
					XEQTYPE %18 EQ ITE EvalNoCK EVAL
					RMULText UNROT2DROP 
					;
		( objets, oper, #, derivees, der oper, # )
		SWAPDROP get1 #1+ get1 
		( objets, derivees, der oper, #, #+1, oper )
		SWAPDROP
		( objets, derivees, #, oper )
		4GETLAM EQLookup 
		NOTcase ::	( arg1...argk, der1...derk, #k , fnct utilisateur )
				ID>$ SWAPDUP SWAP#1+SWAP OVER#2+UNROL psh SYMBN
				( der1, ..., derk, id, #k+1, symbol arg1 ... argk ; )
				%0 ROT #1-
				ZERO_DO	(DO)
					( der1, .., derl, id, argl, res )
					OVER
						( der1..derl, id, argl, res, argl )
					"d"  ISTOP-INDEX UNCOERCE DO>STR &$ 
					( der1..derl, id, argl, res, argl, "der_l" )
					5PICK &$ $>ID ONE SYMBN  
					( der1..derl, id, argl, res, argl, der_lfnct )
					ISTOP@ ' xFCNAPPLY THREE SYMBN &COMP
					( der1..derl, id, argl, res, der_lfnct[argl] )
					5ROLL SWAP RMULText RADDext
					LOOP
				UNROT2DROP
				;
		SWAPDROP XEQTYPE %18 EQ ITE EvalNoCK EVAL
		;
	;
%0      ( LAM3/6 )
{
	( LAM2/5 liste de fonction, derivee )
	x+ %0 x- %0 x* %0 x/ %0 x^ %0
	xNEG	::	DROP %-1 ;
	xi %0 xe %0
	x\v/	::	' x\v/ EvalNoCK %2 SWAP RMULText %1 SWAP RDIVext ;
	xEXP	xEXP
	xLN	xINV
	xINV	::	' xSQ EvalNoCK ' xINV EvalNoCK ;
	xSQ	::	%2 SWAP RMULText ;
	xSIN	xCOS
	xCOS	::	' xSIN EvalNoCK RNEGext ;
	xTAN	::	' xTAN EvalNoCK ' xSQ EvalNoCK %1 RADDext ;
	xSINH	xCOSH
	xCOSH	xSINH
	xTANH	::	' xTANH EvalNoCK ' xSQ EvalNoCK %1 SWAP RSUBext ;
	xASIN	::	' xSQ EvalNoCK %1 SWAP RSUBext 
			' x\v/ EvalNoCK ' xINV EvalNoCK 
			;
	xACOS	::	' xSQ EvalNoCK %1 SWAP RSUBext 
			' x\v/ EvalNoCK ' xINV EvalNoCK RNEGext
			;
	xATAN	::	' xSQ EvalNoCK %1 RADDext ' xINV EvalNoCK ;
	x\.S_ALGEBRAIC %0 
}
{
	( LAM1/4 liste d'operateur, action [ objets, derivees -> derivee ] )
	x+ ::	RADDext UNROT2DROP ;
	x- ::	RSUBext UNROT2DROP ;
	x* ::	4ROLL RMULText UNROT RMULText RADDext ;
	x^ ::	( x, y, x', y' )
		4PICK ' xLN EvalNoCK RMULText
		( x, y, x', y'*ln[x] )
		4PICK 4PICK ' x^ EvalNoCK RMULText
		( x, y, x', y'*ln[x]*x^y )
		4UNROLL UNROT
		( y'*ln[x]*x^y, x', x, y )
		DUP4UNROLL %1 RSUBext ' x^ EvalNoCK
		( y'*ln[x]*x^y, y, x', x^[y-1] )
		RMULText RMULText RADDext
		( y*x'*x^[y-1]+y'*ln[x]*x^[y] )
		;
	x/ ::	( n, d, n', d' ) 
		4ROLL RMULText
		( d, n', n*d' )
		3PICK RDIVext
		( d, n', n*d'/d )
		RSUBext
		( d,n'-n*d'/d )
		SWAP RDIVext
		;
	x\.S
	 ::	( inf, sup, fnct, var muette, inf', sup', fnct', %0 )
		DROP 5UNROLL
		( inf, sup, fnct', fnct, var muette, inf', sup' )
		2OVER 8PICK MEVALext RMULText
		( inf, sup, fnct', fnct, var muette, inf', sup'*fnct[sup] )
		2SWAP DUP 5UNROLL
		( inf, sup, fnct', var muette, inf', sup'*fnct, fnct, muette )
		8PICK MEVALext ROTSWAP RMULText RSUBext 5UNROLL 
		' x\.S_ALGEBRAIC FIVE SYMBN RADDext
		;
}
' NULLLAM FIVE NDUPN DOBIND
( obj, lvar )
5GETLAM EVAL
ABND
;
****************************************
NULLNAME ISOLext
::
' ::	( LAM2 )
	( fonction ISOL: symb, idnt -> idnt, symb )
	( cherche a exprimer idnt pour que symb soit nul )
	SWAP LISTOPext LVARDext INNERCOMP reversym {}N ROTDROP 3PICK
	( idnt, symb, lvar, var )
	::	( symb, lvar, var -> symb, lvar )
		OVERSWAP
		' ::	( idnt, obj -> true/false )
			SWAP CK&DISPATCH1
			idnt EQUAL
			symb :: SWAP EQUALPOSCOMP #0<> ;
			any 2DROPFALSE
			;
		2Ob>Seco
		( symb, lvar, lvar, predicat )
		Find1stTrue
		( symb, lvar, [ var, true | false ] )
		NOT?SEMI 
		2DUP EQUALPOSCOMP
		( symb, lvar, var, # )
		ROTDUP CARCOMP
		( symb, var, #pos, lvar, 1st of lvar )
		UNROT PUTLIST
		( symb, var, lvar sans 1er element )
		ONESWAP PUTLIST
		;
	( idnt, symb, lvar )
	ONE RFACT2ext 
	( idnt, lvar, num/deno, liste racines/multiplicite )
	CARCOMP SWAPDROPSWAP 
	DUP CARCOMP UNROT CDRCOMP VALext 
	( idnt, var, symb )
	SWAP idntlamcase DROP
	( idnt, symb, symbvar )
	DUPTYPESYMB? NcaseTYPEERR
	( idnt, symb, symbvar )
	INNERCOMP #1-SWAP OVER#2+UNROL DUP#1= ITE_DROP SYMBN
	( idnt, symb, op, newsymbvar )
	UNROT 1GETLAM DUPROT
	( idnt, newsymbvar, symb, listop, listop, op )
	EQUALPOSCOMP DUP#0=csedrp  SETTYPEERR
	( idnt, newsymbvar, symb, listop, #pos )
	TWO #/ #2* SWAP #0= ITE #1- #2+ NTHCOMPDROP
	( idnt, newsymbvar, symb, op_inverse )
	EvalNoCK
	( idnt, newsymbvar, symb )
	' x- EvalNoCK SWAP 
	( newsymbvar - symb, idnt )
	2GETEVAL ( appel recursif de ISOLext )
	;
{	xLN xEXP 
	xINV xINV xSQ x\v/
	xCOS xACOS xSIN xASIN xTAN xATAN 
	xCOSH xACOSH xSINH xASINH xTANH xATANH
	}
' NULLLAM DUPTWO DOBIND
2GETEVAL ABND
;
****************************************
NULLNAME LIDNText
::
' ::	( LAM2 liste, comp -> liste )
	INNERCOMP
	DUP#0=csDROP
	get1 SWAP
	( o1, .., on, liste, #n )
	ZERO_DO (DO)
		( o1, .., on, liste )
		SWAP 1GETLAM EVAL
		( o1, .., on-1, liste )
		LOOP
	;
' ::	( LAM1 liste, obj -> liste )
	CK&DISPATCH1
	list 2GETEVAL
	symb 2GETEVAL
	idnt apndvarlst
	any DROP
	;
' NULLLAM DUPTWO DOBIND NULL{} SWAP 1GETLAM EVAL ABND
;
*****************************************************
* NULLNAME 13SIMP1ext
* ::
* complexflag TestUserFlag ?SEMI SIMP1ext
* ;
********************************
* NULLNAME RMSYMext ( objet -> symbolique )
* Elimine les symboles imbriqus
* ::
* ZEROSWAP
* ' :: ( meta, objet -> meta )
*     DUPTYPESYMB? NOTcase SWAP#1+
*     INNERCOMP reversym psh
*     ( o1, ..., on, #n, meta )
*     get1
*     ZERO_DO (DO)
*             ( o1,...,on, meta )
*             get1 1GETLAM EVAL
*             LOOP
*     ;
* ( meta vide, objet, prog )
* DUP1LAMBIND EVAL ABND SYMBN
* ;
************************
*	TITLE ALGB Library ErrorMsg

ASSEMBLE
=ALMSG

RPL
ARRY
*  12345678901234567890123
[
* #1 ( one )
*  " dnominateur(s) "
  " denominator(s) "
*  "racine(s) "
  "root(s) "
*  "dernire(s) "
  "last(s) "
*  "videntes "
  "obvious "
*  "factorise "
  "factorizing "
* #6 ( six )
*  "valeur "
  "value "
*  " test(s) "
  " test(s) "
*  "cherche "
  "searching "
*  "TAYLR de  en "
  "TAYLR of  at "
  "n "
* #B ( eleven )
*  " est "
  " is "
*  " numrateur(s) "
  " numerator(s) "
*  "Il y a au + "
  "Less than "
*  "multiplicit "
  "multiplicity "
*  "liste des "
  "list of "
* #10 ( sixteen )
*  "en "
  " at "
*  "facteur(s) "
  "factor(s) "
*  "Valeurs propres"
  "Eigenvalues "
*  "Calcul pour"
  "Computing for"
*  "Racine mult <"
  "Root mult <"
* #15 ( twentyone 21 )
*  "NumriqueSymbolique?"
   "Numerical to symbolic"
*  " ou lm. simples?"
   " or partial frac.?"
*  "Rsultat:"
   "Result:"
*  "Pivots"
   "Pivots"
*  "Suite: tapez CONT"
   "Type CONT to go on"
* #1A ( 26 twentysix )
*  "Test "
   "Test "
]
*	TITLE Algebre Library Configuration

*****************************************************************
* Add the ALGB Library ROMPART to the SYSRAMROMPAIR.
* The following construction of a binary integer is used
* to enable use of the ALROMID equate defined in ALROMID.H.
*
* NOTE: The label ALcfg is only referenced via a relative address
* in the header file ALHEAD so it is being made a "NAMELESS".
* If it was going to be referenced from a secondary then it would
* need to changed to a "NULLNAME" so that the reference would be
* made via a romptr.
*****************************************************************

ASSEMBLE
=ALcfg
RPL
::
  xVER DROP
  DOBINT ALROMID
  XEQSETLIB 		( autoattach )
;
